<?php

class BlockSystemUlinks extends JieqiBlock
{
	public $module = "system";
	public $template = "block_ulinks.html";
	public $exevars = array("field" => "toptime", "listnum" => 10, "asc" => 0, "uid" => "uid", "istop" => 0);

	public function BlockSystemUlinks(&$vars)
	{
		$this->JieqiBlock($vars);

		if (!empty($this->blockvars["vars"])) {
			$varary = explode(",", trim($this->blockvars["vars"]));
			$arynum = count($varary);

			if (0 < $arynum) {
				$varary[0] = trim($varary[0]);

				if (in_array($varary[0], array("toptime", "addtime"))) {
					$this->exevars["field"] = $varary[0];
				}
			}

			if (1 < $arynum) {
				$varary[1] = trim($varary[1]);
				if (is_numeric($varary[1]) && (0 < $varary[1])) {
					$this->exevars["listnum"] = intval($varary[1]);
				}
			}

			if (2 < $arynum) {
				$varary[2] = trim($varary[2]);

				if (in_array($varary[2], array("0", "1"))) {
					$this->exevars["asc"] = $varary[2];
				}
			}

			if (3 < $arynum) {
				$varary[3] = trim($varary[3]);

				if (0 < strlen($varary[3])) {
					$this->exevars["uid"] = $varary[3];
				}
			}

			if (4 < $arynum) {
				$varary[4] = trim($varary[4]);

				if (is_numeric($varary[4])) {
					$this->exevars["state"] = $varary[4];
				}
			}
		}

		$this->getCacheid();
	}

	public function setContent($isreturn = false)
	{
		global $jieqiTpl;
		$linkrows = array();

		if (0 < $this->blockvars["cacheid"]) {
			include_once (JIEQI_ROOT_PATH . "/class/userlink.php");
			$userlink_handler = &JieqiUserlinkHandler::getInstance("JieqiUserlinkHandler");
			$criteria = new CriteriaCompo();
			$criteria->add(new Criteria("userid", $this->blockvars["cacheid"]));

			if ($this->exevars["istop"] == 1) {
				$criteria->add(new Criteria("toptime", 0, ">"));
			}
			else if ($this->exevars["istop"] == 2) {
				$criteria->add(new Criteria("toptime", 0));
			}

			$criteria->setSort($this->exevars["field"]);

			if ($this->exevars["asc"] == 1) {
				$criteria->setOrder("ASC");
			}
			else {
				$criteria->setOrder("DESC");
			}

			$criteria->setLimit($this->exevars["listnum"]);
			$criteria->setStart(0);
			$userlink_handler->queryObjects($criteria);
			$k = 0;

			while ($v = $userlink_handler->getObject()) {
				$linkrows[$k]["ulid"] = $v->getVar("ulid");
				$linkrows[$k]["ultitle"] = $v->getVar("ultitle");
				$linkrows[$k]["ulurl"] = $v->getVar("ulurl");
				$linkrows[$k]["ulinfo"] = $v->getVar("ulinfo");
				$linkrows[$k]["userid"] = $v->getVar("userid");
				$linkrows[$k]["username"] = $v->getVar("username");
				$linkrows[$k]["score"] = $v->getVar("score");
				$linkrows[$k]["weight"] = $v->getVar("weight");
				$linkrows[$k]["toptime"] = $v->getVar("toptime");
				$linkrows[$k]["addtime"] = $v->getVar("addtime");
				$linkrows[$k]["allvisit"] = $v->getVar("allvisit");
				$k++;
			}
		}

		$jieqiTpl->assign_by_ref("linkrows", $linkrows);
		$jieqiTpl->assign("ownerid", $this->blockvars["cacheid"]);
		$jieqiTpl->assign("url_more", JIEQI_URL . "/userlink.php?uid=" . $this->blockvars["cacheid"]);
	}

	public function getCacheid()
	{
		global $jieqiTpl;
		$this->blockvars["cacheid"] = 0;

		if (strval($this->exevars["uid"]) != "0") {
			if ($this->exevars["uid"] == "self") {
				$this->blockvars["cacheid"] = intval($_SESSION["jieqiUserId"]);
			}
			else if (is_numeric($this->exevars["uid"])) {
				$this->blockvars["cacheid"] = intval($this->exevars["uid"]);
			}
			else if (substr($this->exevars["uid"], 0, 1) == "\$") {
				$this->blockvars["cacheid"] = intval($jieqiTpl->get_assign(substr($this->exevars["uid"], 1)));
			}
			else {
				$this->blockvars["cacheid"] = intval($_REQUEST[$this->exevars["uid"]]);
			}
		}

		return $this->blockvars["cacheid"];
	}
}


?>
