<?php

function jieqi_visit_valid($id, $vname, $save = true)
{
	if (!is_numeric($id) || (intval($id) <= 0)) {
		return false;
	}

	$sname = "";

	if (isset($_SESSION[$vname])) {
		$arysession = unserialize($_SESSION[$vname]);
	}
	else {
		$arysession = array();
	}

	if (!is_array($arysession)) {
		$arysession = array();
	}

	$tmpary = array();
	$arycookie = array();

	if (isset($_COOKIE["jieqiVisitId"])) {
		$tmpary = jieqi_strtosary($_COOKIE["jieqiVisitId"], "=", ",");

		if (isset($tmpary[$vname])) {
			$arycookie = explode("|", $tmpary[$vname]);
		}
	}

	if (!is_array($arycookie)) {
		$arycookie = array();
	}

	if (in_array($id, $arysession) || in_array($id, $arycookie)) {
		return false;
	}

	if ($save) {
		if (!in_array($id, $arysession) && isset($_SESSION)) {
			$arysession[] = $id;
			$_SESSION[$vname] = serialize($arysession);
		}

		if (!in_array($id, $arycookie)) {
			$arycookie[] = $id;
			$tmpary[$vname] = implode("|", $arycookie);
			setcookie("jieqiVisitId", jieqi_sarytostr($tmpary, "=", ","), JIEQI_NOW_TIME + 3600, "/", JIEQI_COOKIE_DOMAIN, 0);
		}
	}

	return true;
}

function jieqi_visit_ids($id, $vname, $lastvisit = -1)
{
	if (!is_numeric($id) || (intval($id) <= 0)) {
		return false;
	}

	if (!preg_match("/^\w+$/is", $vname)) {
		return false;
	}

	$vname = strtolower($vname);
	$ret = array();

	if (JIEQI_ENABLE_CACHE) {
		$logfile = JIEQI_CACHE_PATH . "/cachevars/cachevisit/" . $vname . ".php";
		jieqi_checkdir(dirname($logfile), true);

		if (rand(1, 100) == 1) {
			$visitary = @file($logfile);

			if ($fp = @fopen($logfile, "w")) {
				@fclose($fp);
			}

			$visitary[] = (0 <= $lastvisit ? $id . "|" . $lastvisit : $id);

			foreach ($visitary as $v ) {
				$v = trim($v);
				$tmpary = explode("|", $v);
				$tmpary[0] = intval($tmpary[0]);

				if (!empty($tmpary[0])) {
					if (key_exists($tmpary[0], $ret)) {
						$ret[$tmpary[0]]["visitnum"]++;
					}
					else {
						$ret[$tmpary[0]]["visitnum"] = 1;
					}

					if (isset($tmpary[1])) {
						$ret[$tmpary[0]]["lastvisit"] = intval($tmpary[1]);
					}
					else {
						$ret[$tmpary[0]]["lastvisit"] = -1;
					}
				}
			}
		}
		else if ($fp = @fopen($logfile, "a")) {
			@flock($filenum, LOCK_EX);

			if (0 <= $lastvisit) {
				@fwrite($fp, $id . "|" . $lastvisit . "\r\n");
			}
			else {
				@fwrite($fp, $id . "\r\n");
			}

			@flock($filenum, LOCK_UN);
			@fclose($fp);
			@chmod($logfile, 511);
		}
	}
	else {
		$ret[$id] = array("visitnum" => 1, "lastvisit" => $lastvisit);
	}

	return empty($ret) ? false : $ret;
}

function jieqi_visit_stat($id, $table, $fieldstat, $fieldid, $query = NULL, $addnum = 1)
{
	if (jieqi_visit_valid($id, $table . "_" . $fieldstat)) {
		if ($ids = jieqi_visit_ids($id, $table . "_" . $fieldstat)) {
			global $query;

			if (!is_a($query, "JieqiQueryHandler")) {
				jieqi_includedb();
				$query = JieqiQueryHandler::getInstance("JieqiQueryHandler");
			}

			foreach ($ids as $k => $v ) {
				$v["visitnum"] = intval($v["visitnum"] * $addnum);
				$sql = "UPDATE " . $table . " SET " . $fieldstat . "=" . $fieldstat . "+" . $v["visitnum"] . " WHERE " . $fieldid . "=" . intval($k);
				$query->execute($sql);
			}
		}

		return true;
	}
	else {
		return false;
	}
}

function jieqi_visit_addorup($lasttime, $nowtime = -1)
{
	$lastdate = date("Y-m-d", $lasttime);
	$lastweek = date("w", $lasttime);

	if ($lastweek == 0) {
		$lastweek = 7;
	}

	if ($nowtime < 0) {
		$nowtime = (defined("JIEQI_NOW_TIME") ? JIEQI_NOW_TIME : time());
	}

	$nowdate = date("Y-m-d", $nowtime);
	$nowweek = date("w", $nowtime);

	if ($nowweek == 0) {
		$nowweek = 7;
	}

	$ret = array("day" => false, "week" => false, "month" => false, "all" => false);
	if (($nowdate != $lastdate) && ($lasttime < $nowtime)) {
		$ret["day"] = true;
		if (($nowweek <= $lastweek) || (604800 < ($nowtime - $lasttime))) {
			$ret["week"] = true;
		}

		if (substr($nowdate, 0, 7) != substr($lastdate, 0, 7)) {
			$ret["month"] = true;
		}
	}

	return $ret;
}


?>
