<?php

function jieqi_excel_addrow($row, $sheet)
{
	static $excel_roworder = 1;
	$k = 1;

	foreach ($row as $v ) {
		$cellcode = jieqi_excel_colcode($k) . $excel_roworder;
		$sheet->setCellValue($cellcode, iconv("UTF-8", "GBK//IGNORE", $v));
		$sheet->getStyle($cellcode)->getBorders()->getTop()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);
		$sheet->getStyle($cellcode)->getBorders()->getLeft()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);
		$sheet->getStyle($cellcode)->getBorders()->getRight()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);
		$sheet->getStyle($cellcode)->getBorders()->getBottom()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);

		if ($excel_roworder == 1) {
			$sheet->getStyle($cellcode)->getFont()->setBold(true);
			$sheet->getStyle($cellcode)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
		}

		$k++;
	}

	$excel_roworder++;
}

function jieqi_excel_setwidth($row, $sheet)
{
	$k = 1;

	foreach ($row as $v ) {
		$sheet->getColumnDimension(jieqi_excel_colcode($k))->setWidth(intval($v));
		$k++;
	}
}

function jieqi_excel_colcode($k)
{
	$ret = "";
	$k = intval($k);

	if (0 < $k) {
		while (26 < $k) {
			$ret = chr(64 + ($k % 26)) . $ret;
			$k = floor($k / 26);
		}

		$ret = chr(64 + $k) . $ret;
	}

	return $ret;
}

define("JIEQI_MODULE_NAME", "article");
require_once ("../../../global.php");
jieqi_getconfigs(JIEQI_MODULE_NAME, "power");
jieqi_checkpower($jieqiPower["article"]["manageallarticle"], $jieqiUsersStatus, $jieqiUsersGroup, false, true);
jieqi_getconfigs("article", "configs");
jieqi_getconfigs("article", "sort");
jieqi_getconfigs("article", "option", "jieqiOption");
jieqi_getconfigs("article", "export", "jieqiExport");
if (empty($_POST["act"]) || ($_POST["act"] != "export")) {
	$jieqiTset["jieqi_contents_template"] = $jieqiModules["article"]["path"] . "/templates/admin/articleexport.html";
	include_once (JIEQI_ROOT_PATH . "/admin/header.php");
	$jieqiTpl->assign("sortrows", jieqi_funtoarray("jieqi_htmlstr", $jieqiSort["article"]));

	foreach ($jieqiOption["article"] as $k => $v ) {
		$jieqiTpl->assign_by_ref($k, $jieqiOption["article"][$k]);
	}

	$jieqiTpl->assign("_request", jieqi_funtoarray("jieqi_htmlstr", $_REQUEST));
	$jieqiTpl->setCaching(0);
	include_once (JIEQI_ROOT_PATH . "/admin/footer.php");
}
else {
	jieqi_checkpost();
	jieqi_includedb();
	$query = JieqiQueryHandler::getInstance("JieqiQueryHandler");
	$where = "";
	$badparm = false;

	if (!empty($_POST["sortid"])) {
		if ($where != "") {
			$where .= " AND";
		}

		$where .= " sortid = " . intval($_POST["sortid"]);
	}

	if (!empty($_POST["typeid"])) {
		if ($where != "") {
			$where .= " AND";
		}

		$where .= " typeid = " . intval($_POST["typeid"]);
	}

	if (isset($_POST["issign"]) && is_numeric($_POST["issign"]) && (0 <= intval($_POST["issign"]))) {
		$_POST["issign"] = intval($_POST["issign"]);

		if ($where != "") {
			$where .= " AND";
		}

		if ($_POST["issign"] == 0) {
			$where .= " issign = 0";
		}
		else {
			$where .= " issign >= " . $_POST["issign"];
		}
	}

	if (!empty($_POST["upday"]) && is_numeric($_POST["upday"])) {
		$upfield = (!empty($_POST["upfield"]) ? "postdate" : "lastupdate");

		if ($where != "") {
			$where .= " AND";
		}

		$where .= " $upfield >= " . (JIEQI_NOW_TIME - (floatval($_POST["upday"]) * 3600 * 24));
	}
	else if (!empty($_POST["upday"])) {
		$badparm = true;
	}

	if (!empty($_POST["articles"])) {
		if ($_POST["idname"] == 0) {
			$_POST["articles"] = trim($_POST["articles"]);
			$aidary = explode(",", $_POST["articles"]);
			$aidstr = "";

			foreach ($aidary as $aid ) {
				$aid = intval(trim($aid));

				if ($aid) {
					if ($aidstr != "") {
						$aidstr .= ",";
					}

					$aidstr .= $aid;
				}
			}

			if ($aidstr != "") {
				if ($where != "") {
					$where .= " AND";
				}

				$where .= " articleid IN (" . $aidstr . ")";
			}
			else {
				$badparm = true;
			}
		}
		else {
			$_POST["articles"] = trim($_POST["articles"]);
			$anameary = explode("\n", $_POST["articles"]);
			$anamestr = "";

			foreach ($anameary as $aname ) {
				$aname = trim($aname);

				if (!empty($aname)) {
					if ($anamestr != "") {
						$anamestr .= ",";
					}

					$anamestr .= "'" . jieqi_dbslashes($aname) . "'";
				}
			}

			if ($anamestr != "") {
				if ($where != "") {
					$where .= " AND";
				}

				$where .= " articlename IN (" . $anamestr . ")";
			}
			else {
				$badparm = true;
			}
		}
	}

	if ($badparm) {
		jieqi_printfail(LANG_ERROR_PARAMETER);
	}

	if (empty($where)) {
		$where = "1";
	}

	include_once ($jieqiModules["article"]["path"] . "/include/funarticle.php");
	$orderary = array("articleid", "articlename", "postdate", "lastupdaye", "toptime", "goodnum", "hotnum", "ratenum", "size", "monthsize", "weeksize", "daysize", "presize", "allvisit", "monthvisit", "weekvisit", "dayvisit", "allvote", "monthvote", "weekvote", "dayvote", "allvipvote", "monthvipvote", "weekvipvote", "dayvipvote", "previpvote", "allflower", "monthflower", "weekflower", "dayflower", "preflower", "allegg", "monthegg", "weekegg", "dayegg", "preegg");
	if (isset($_REQUEST["order"]) && in_array($_REQUEST["order"], $orderary)) {
		$order = $_REQUEST["order"];
	}
	else {
		$order = "articlename";
	}

	if (!isset($_REQUEST["asc"]) || !empty($_REQUEST["asc"])) {
		$asc = "ASC";
	}
	else {
		$asc = "DESC";
	}

	$sql = "SELECT * FROM " . jieqi_dbprefix("article_article") . " WHERE $where ORDER BY $order $asc LIMIT 0, 10000";
	$query->execute($sql);
	include_once (JIEQI_ROOT_PATH . "/header.php");
	include_once (JIEQI_ROOT_PATH . "/lib/excel/PHPExcel.php");
	include_once (JIEQI_ROOT_PATH . "/lib/excel/PHPExcel/Writer/Excel5.php");
	$objExcel = new PHPExcel();
	$objWriter = new PHPExcel_Writer_Excel5($objExcel);
	$objProps = $objExcel->getProperties();
	$objProps->setCreator("JIEQI CMS");
	$objProps->setLastModifiedBy("JIEQI CMS");
	$objProps->setTitle("Article");
	$objProps->setSubject("Book");
	$objProps->setDescription("");
	$objProps->setKeywords("");
	$objProps->setCategory("");
	$objExcel->setActiveSheetIndex(0);
	$objActSheet = $objExcel->getActiveSheet();
	$objActSheet->setTitle("Sheet1");
	$titlefields = array();
	$titlewidth = array();

	foreach ($jieqiExport["article"] as $k => $v ) {
		if (0 < $v["display"]) {
			$titlefields[$k] = $v["caption"];
			$titlewidth[$k] = $v["width"];
		}
	}

	if (empty($titlefields)) {
		jieqi_printfail(LANG_ERROR_PARAMETER);
	}

	$line = array_values($titlefields);
	jieqi_excel_addrow($line, $objActSheet);
	jieqi_excel_setwidth($titlewidth, $objActSheet);

	while ($row = $query->getRow()) {
		$row = jieqi_article_vars($row, false, "n");
		$row["postday"] = date("Y-m-d", $row["postdate"]);
		$row["posthour"] = date("Y-m-d H", $row["postdate"]);
		$row["postminute"] = date("Y-m-d H:i", $row["postdate"]);
		$row["postsecond"] = date("Y-m-d H:i:s", $row["postdate"]);
		$row["lastupday"] = date("Y-m-d", $row["lastupdate"]);
		$row["lastuphour"] = date("Y-m-d H", $row["lastupdate"]);
		$row["lastupminute"] = date("Y-m-d H:i", $row["lastupdate"]);
		$row["lastupsecond"] = date("Y-m-d H:i:s", $row["lastupdate"]);
		$line = array();

		foreach ($titlefields as $k => $v ) {
			$line[] = (isset($row[$k]) ? $row[$k] : "");
		}

		jieqi_excel_addrow($line, $objActSheet);
	}

	$outputFileName = "article_" . date("Ymd") . ".xls";
	header("Content-Type: application/force-download");
	header("Content-Type: application/octet-stream");
	header("Content-Type: application/download");
	header("Content-Disposition:attachment;filename=\"" . jieqi_headstr($outputFileName) . "\"");
	header("Content-Transfer-Encoding: binary");
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
	header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
	header("Pragma: no-cache");
	header("content-Type:application/vnd.ms-excel;charset=gbk");
	$objWriter->save("php://output");
}

?>
