<?php

/**
 * 浠樻鏂瑰纺銆? */
class PaymentMethod
{
	const ALL = "ALL";
	const Credit = "Credit";
	const WebATM = "WebATM";
	const ATM = "ATM";
	const CVS = "CVS";
	const BARCODE = "BARCODE";
	const Alipay = "Alipay";
	const Tenpay = "Tenpay";
	const TopUpUsed = "TopUpUsed";
}

/**
 * 浠樻鏂瑰纺瀛愰爡鐩EUR? */
class PaymentMethodItem
{
	const None = "";
	const WebATM_TAISHIN = "TAISHIN";
	const WebATM_ESUN = "ESUN";
	const WebATM_HUANAN = "HUANAN";
	const WebATM_BOT = "BOT";
	const WebATM_FUBON = "FUBON";
	const WebATM_CHINATRUST = "CHINATRUST";
	const WebATM_FIRST = "FIRST";
	const WebATM_CATHAY = "CATHAY";
	const WebATM_MEGA = "MEGA";
	const WebATM_YUANTA = "YUANTA";
	const WebATM_LAND = "LAND";
	const ATM_TAISHIN = "TAISHIN";
	const ATM_ESUN = "ESUN";
	const ATM_HUANAN = "HUANAN";
	const ATM_BOT = "BOT";
	const ATM_FUBON = "FUBON";
	const ATM_CHINATRUST = "CHINATRUST";
	const ATM_LAND = "LAND";
	const ATM_CATHAY = "CATHAY";
	const ATM_Tachong = "Tachong";
	const ATM_Sinopac = "Sinopac";
	const ATM_CHB = "CHB";
	const ATM_FIRST = "FIRST";
	const CVS = "CVS";
	const CVS_OK = "OK";
	const CVS_FAMILY = "FAMILY";
	const CVS_HILIFE = "HILIFE";
	const CVS_IBON = "IBON";
	const Alipay = "Alipay";
	const Tenpay = "Tenpay";
	const TopUpUsed_AllPay = "AllPay";
	const TopUpUsed_ESUN = "ESUN";
	const BARCODE = "BARCODE";
	const Credit = "Credit";
	const COD = "COD";
}

/**
 * 椤嶅浠樻璩囱▕銆? */
class ExtraPaymentInfo
{
	const Yes = "Y";
	const No = "N";
}

/**
 * 椤嶅浠樻璩囱▕銆? */
class DeviceType
{
	const PC = "P";
	const Mobile = "M";
}

/**
 * 淇＄敤鍗¤▊鍠檿鐞嗗嫊浣滆硣瑷娿EUR? */
class ActionType
{
	const C = "C";
	const R = "R";
	const E = "E";
	const N = "N";
}

/**
 * 瀹氭湡瀹氶镄勯EUR辨湡绋銆? */
class PeriodType
{
	const None = "";
	const Year = "Y";
	const Month = "M";
	const Day = "D";
}

/**
 * 板诲瓙鐧肩エ闁嬬珛瑷昏銆? */
class InvoiceState
{
	const Yes = "Y";
	const No = "";
}

/**
 * 板诲瓙鐧肩エ杓夊叿椤炲垾
 */
class CarruerType
{
	const None = "";
	const Member = "1";
	const Citizen = "2";
	const Cellphone = "3";
}

/**
 * 板诲瓙鐧肩エ鍒楀嵃瑷昏
 */
class PrintMark
{
	const No = "0";
	const Yes = "1";
}

/**
 * 板诲瓙鐧肩エ鎹愯磮瑷昏
 */
class Donation
{
	const Yes = "1";
	const No = "2";
}

/**
 * 阃氶棞鏂瑰纺
 */
class ClearanceMark
{
	const Yes = "1";
	const No = "2";
}

/**
 * 瑾茬▍椤炲垾
 */
class TaxType
{
	const Dutiable = "1";
	const Zero = "2";
	const Free = "3";
	const Mix = "9";
}

/**
 * 瀛楄粚椤炲垾
 */
class InvType
{
	const General = "07";
	const Special = "08";
}

class EncryptType
{
	const ENC_MD5 = 0;
	const ENC_SHA256 = 1;
}

class UseRedeem
{
	const Yes = "Y";
	const No = "N";
}

abstract class Verification
{
	public $arInvoice = array("RelateNumber", "CustomerIdentifier", "CarruerType", "CustomerID", "Donation", "Print", "TaxType", "CustomerName", "CustomerAddr", "CustomerPhone", "CustomerEmail", "ClearanceMark", "CarruerNum", "LoveCode", "InvoiceRemark", "DelayDay", "InvoiceItemName", "InvoiceItemCount", "InvoiceItemWord", "InvoiceItemPrice", "InvoiceItemTaxType", "InvType");

	abstract public function check_goods($arParameters);

	abstract public function filter_string($arExtend, $InvoiceMark);

	abstract public function check_extend_string($arExtend, $InvoiceMark);

	protected function check_string($arParameters = array(), $ServiceURL = "", $HashKey = "", $HashIV = "")
	{
		$arErrors = array();

		if (strlen($ServiceURL) == 0) {
			array_push($arErrors, "ServiceURL is required.");
		}

		if (200 < strlen($ServiceURL)) {
			array_push($arErrors, "ServiceURL max langth as 200.");
		}

		if (strlen($HashKey) == 0) {
			array_push($arErrors, "HashKey is required.");
		}

		if (strlen($HashIV) == 0) {
			array_push($arErrors, "HashIV is required.");
		}

		if (strlen($arParameters["MerchantID"]) == 0) {
			array_push($arErrors, "MerchantID is required.");
		}

		if (10 < strlen($arParameters["MerchantID"])) {
			array_push($arErrors, "MerchantID max langth as 10.");
		}

		if (strlen($arParameters["ReturnURL"]) == 0) {
			array_push($arErrors, "ReturnURL is required.");
		}

		if (200 < strlen($arParameters["ClientBackURL"])) {
			array_push($arErrors, "ClientBackURL max langth as 10.");
		}

		if (200 < strlen($arParameters["OrderResultURL"])) {
			array_push($arErrors, "OrderResultURL max langth as 10.");
		}

		if (strlen($arParameters["MerchantTradeNo"]) == 0) {
			array_push($arErrors, "MerchantTradeNo is required.");
		}

		if (20 < strlen($arParameters["MerchantTradeNo"])) {
			array_push($arErrors, "MerchantTradeNo max langth as 20.");
		}

		if (strlen($arParameters["MerchantTradeDate"]) == 0) {
			array_push($arErrors, "MerchantTradeDate is required.");
		}

		if (strlen($arParameters["TotalAmount"]) == 0) {
			array_push($arErrors, "TotalAmount is required.");
		}

		if (strlen($arParameters["TradeDesc"]) == 0) {
			array_push($arErrors, "TradeDesc is required.");
		}

		if (200 < strlen($arParameters["TradeDesc"])) {
			array_push($arErrors, "TradeDesc max langth as 200.");
		}

		if (strlen($arParameters["ChoosePayment"]) == 0) {
			array_push($arErrors, "ChoosePayment is required.");
		}

		if (strlen($arParameters["NeedExtraPaidInfo"]) == 0) {
			array_push($arErrors, "NeedExtraPaidInfo is required.");
		}

		if (strlen($arParameters["DeviceSource"]) == 0) {
			array_push($arErrors, "DeviceSource is required.");
		}

		if (sizeof($arParameters["Items"]) == 0) {
			array_push($arErrors, "Items is required.");
		}

		if (1 < strlen($arParameters["EncryptType"])) {
			array_push($arErrors, "EncryptType max langth as 1.");
		}

		if (0 < sizeof($arErrors)) {
			throw new Exception(join("<br>", $arErrors));
		}
	}

	public function check_invoiceString($arExtend = array())
	{
		$arErrors = array();

		if (!array_key_exists("RelateNumber", $arExtend)) {
			array_push($arErrors, "RelateNumber is required.");
		}
		else if (30 < strlen($arExtend["RelateNumber"])) {
			array_push($arErrors, "RelateNumber max length as 30.");
		}

		if (!array_key_exists("CustomerIdentifier", $arExtend)) {
			$arExtend["CustomerIdentifier"] = "";
		}
		else if (strlen($arExtend["CustomerIdentifier"]) != 8) {
			array_push($arErrors, "CustomerIdentifier length should be 8.");
		}

		if (!array_key_exists("CarruerType", $arExtend)) {
			$arExtend["CarruerType"] = CarruerType::None;
		}
		else {
			if ((0 < strlen($arExtend["CustomerIdentifier"])) && ($arExtend["CarruerType"] != CarruerType::None)) {
				array_push($arErrors, "CarruerType should be None.");
			}
		}

		if (!array_key_exists("CustomerID", $arExtend)) {
			$arExtend["CustomerID"] = "";
		}
		else {
			if (($arExtend["CarruerType"] == CarruerType::Member) && strlen($arExtend["CustomerID"] == 0)) {
				array_push($arErrors, "CustomerID is required.");
			}
		}

		if (!array_key_exists("Donation", $arExtend)) {
			$arExtend["Donation"] = Donation::No;
		}
		else {
			if ((0 < strlen($arExtend["CustomerIdentifier"])) && ($arExtend["Donation"] != Donation::No)) {
				array_push($arErrors, "Donation should be No.");
			}
		}

		if (!array_key_exists("Print", $arExtend)) {
			$arExtend["Print"] = PrintMark::No;
		}
		else {
			if (($arExtend["Donation"] == Donation::Yes) && ($arExtend["PrintMark"] != Donation::No)) {
				array_push($arErrors, "Print should be No.");
			}

			if ((0 < strlen($arExtend["CustomerIdentifier"])) && ($arExtend["Print"] != PrintMark::Yes)) {
				array_push($arErrors, "Print should be Yes.");
			}

			$notPrint = array(CarruerType::Member, CarruerType::Citizen, CarruerType::Cellphone);
			if (in_array($arExtend["CarruerType"], $notPrint) && ($arExtend["Print"] == PrintMark::Yes)) {
				array_push($arErrors, "Print should be No.");
			}
		}

		if (!array_key_exists("CustomerName", $arExtend)) {
			$arExtend["CustomerName"] = "";
		}
		else {
			if (20 < mb_strlen($arExtend["CustomerName"], "UTF-8")) {
				array_push($arErrors, "CustomerName max length as 20.");
			}

			if (($arExtend["Print"] == PrintMark::Yes) && (strlen($arExtend["CustomerName"]) == 0)) {
				array_push($arErrors, "CustomerName is required.");
			}
		}

		if (!array_key_exists("CustomerAddr", $arExtend)) {
			$arExtend["CustomerAddr"] = "";
		}
		else {
			if (200 < mb_strlen($arExtend["CustomerAddr"], "UTF-8")) {
				array_push($arErrors, "CustomerAddr max length as 200.");
			}

			if (($arExtend["Print"] == PrintMark::Yes) && (strlen($arExtend["CustomerAddr"]) == 0)) {
				array_push($arErrors, "CustomerAddr is required.");
			}
		}

		if (!array_key_exists("CustomerPhone", $arExtend)) {
			$arExtend["CustomerPhone"] = "";
		}
		else if (20 < strlen($arExtend["CustomerPhone"])) {
			array_push($arErrors, "CustomerPhone max length as 20.");
		}

		if (!array_key_exists("CustomerEmail", $arExtend)) {
			$arExtend["CustomerEmail"] = "";
		}
		else if (200 < strlen($arExtend["CustomerEmail"])) {
			array_push($arErrors, "CustomerEmail max length as 200.");
		}

		if ((strlen($arExtend["CustomerPhone"]) == 0) && (strlen($arExtend["CustomerEmail"]) == 0)) {
			array_push($arErrors, "CustomerPhone or CustomerEmail is required.");
		}

		if (strlen($arExtend["TaxType"]) == 0) {
			array_push($arErrors, "TaxType is required.");
		}

		if (!array_key_exists("ClearanceMark", $arExtend)) {
			$arExtend["ClearanceMark"] = "";
		}
		else {
			if (($arExtend["TaxType"] == TaxType::Zero) && (($arExtend["ClearanceMark"] != ClearanceMark::Yes) || ($arExtend["ClearanceMark"] != ClearanceMark::No))) {
				array_push($arErrors, "ClearanceMark is required.");
			}

			if ((0 < strlen($arExtend["ClearanceMark"])) && ($arExtend["TaxType"] != TaxType::Zero)) {
				array_push($arErrors, "Please remove ClearanceMark.");
			}
		}

		if (!array_key_exists("CarruerNum", $arExtend)) {
			$arExtend["CarruerNum"] = "";
		}
		else {
			switch ($arExtend["CarruerType"]) {
			case CarruerType:
			case CarruerType:
				if (0 < strlen($arExtend["CarruerNum"])) {
					array_push($arErrors, "Please remove CarruerNum.");
				}

				break;

			case CarruerType:
				if (!preg_match("/^[a-zA-Z]{2}\d{14}$/", $arExtend["CarruerNum"])) {
					array_push($arErrors, "Invalid CarruerNum.");
				}

				break;

			case CarruerType:
				if (!preg_match("/^\/{1}[0-9a-zA-Z+-.]{7}$/", $arExtend["CarruerNum"])) {
					array_push($arErrors, "Invalid CarruerNum.");
				}

				break;

			default:
				array_push($arErrors, "Please remove CarruerNum.");
			}
		}

		if (!array_key_exists("LoveCode", $arExtend)) {
			$arExtend["LoveCode"] = "";
		}

		if ($arExtend["Donation"] == Donation::Yes) {
			if (!preg_match("/^([xX]{1}[0-9]{2,6}|[0-9]{3,7})$/", $arExtend["LoveCode"])) {
				array_push($arErrors, "Invalid LoveCode.");
			}
		}
		else if (0 < strlen($arExtend["LoveCode"])) {
			array_push($arErrors, "Please remove LoveCode.");
		}

		if (!array_key_exists("InvoiceRemark", $arExtend)) {
			$arExtend["InvoiceRemark"] = "";
		}

		if (!array_key_exists("DelayDay", $arExtend)) {
			$arExtend["DelayDay"] = 0;
		}

		if (($arExtend["DelayDay"] < 0) || (15 < $arExtend["DelayDay"])) {
			array_push($arErrors, "DelayDay should be 0 ~ 15.");
		}

		if (!array_key_exists("InvType", $arExtend)) {
			array_push($arErrors, "InvType is required.");
		}

		if (!array_key_exists("InvoiceItems", $arExtend)) {
			array_push($arErrors, "Invoice Goods information not found.");
		}
		else {
			$InvSptr = "|";
			$tmpItemName = array();
			$tmpItemCount = array();
			$tmpItemWord = array();
			$tmpItemPrice = array();
			$tmpItemTaxType = array();

			foreach ($arExtend["InvoiceItems"] as $tmpItemInfo ) {
				if (0 < mb_strlen($tmpItemInfo["Name"], "UTF-8")) {
					array_push($tmpItemName, $tmpItemInfo["Name"]);
				}

				if (0 < strlen($tmpItemInfo["Count"])) {
					array_push($tmpItemCount, $tmpItemInfo["Count"]);
				}

				if (0 < mb_strlen($tmpItemInfo["Word"], "UTF-8")) {
					array_push($tmpItemWord, $tmpItemInfo["Word"]);
				}

				if (0 < strlen($tmpItemInfo["Price"])) {
					array_push($tmpItemPrice, $tmpItemInfo["Price"]);
				}

				if (0 < strlen($tmpItemInfo["TaxType"])) {
					array_push($tmpItemTaxType, $tmpItemInfo["TaxType"]);
				}
			}

			if ($arExtend["TaxType"] == TaxType::Mix) {
				if (in_array(TaxType::Dutiable, $tmpItemTaxType) && in_array(TaxType::Free, $tmpItemTaxType)) {
				}
				else {
					$tmpItemTaxType = array();
				}
			}

			if ((count($tmpItemName) + count($tmpItemCount) + count($tmpItemWord) + count($tmpItemPrice) + count($tmpItemTaxType)) == count($tmpItemName) * 5) {
				$arExtend["InvoiceItemName"] = implode($InvSptr, $tmpItemName);
				$arExtend["InvoiceItemCount"] = implode($InvSptr, $tmpItemCount);
				$arExtend["InvoiceItemWord"] = implode($InvSptr, $tmpItemWord);
				$arExtend["InvoiceItemPrice"] = implode($InvSptr, $tmpItemPrice);
				$arExtend["InvoiceItemTaxType"] = implode($InvSptr, $tmpItemTaxType);
			}

			unset($arExtend["InvoiceItems"]);
		}

		$encode_fields = array("CustomerName", "CustomerAddr", "CustomerEmail", "InvoiceItemName", "InvoiceItemWord", "InvoiceRemark");

		foreach ($encode_fields as $tmp_field ) {
			$arExtend[$tmp_field] = urlencode($arExtend[$tmp_field]);
		}

		if (0 < sizeof($arErrors)) {
			throw new Exception(join("<br>", $arErrors));
		}

		return $arExtend;
	}
}

/**
    * 锷熻兘椤?    */
class Aio
{
	public function generateCheckMacValue($arParameters = array(), $HashKey = "", $HashIV = "", $encType = 0)
	{
		$sMacValue = "";

		if (isset($arParameters)) {
			uksort($arParameters, array("Aio", "merchantSort"));
			$sMacValue = "HashKey=" . $HashKey;

			foreach ($arParameters as $key => $value ) {
				$sMacValue .= "&" . $key . "=" . $value;
			}

			$sMacValue .= "&HashIV=" . $HashIV;
			$sMacValue = urlencode($sMacValue);
			$sMacValue = strtolower($sMacValue);
			$sMacValue = str_replace("%2d", "-", $sMacValue);
			$sMacValue = str_replace("%5f", "_", $sMacValue);
			$sMacValue = str_replace("%2e", ".", $sMacValue);
			$sMacValue = str_replace("%21", "!", $sMacValue);
			$sMacValue = str_replace("%2a", "*", $sMacValue);
			$sMacValue = str_replace("%28", "(", $sMacValue);
			$sMacValue = str_replace("%29", ")", $sMacValue);

			switch ($encType) {
			case EncryptType:
				$sMacValue = hash("sha256", $sMacValue);
				break;

			case EncryptType:
			default:
				$sMacValue = md5($sMacValue);
			}

			$sMacValue = strtoupper($sMacValue);
		}

		return $sMacValue;
	}

	/**
        * 镊▊鎺掑簭浣跨敤
        */
	static private function merchantSort($a, $b)
	{
		return strcasecmp($a, $b);
	}
}

/**
 * AllInOne short summary.
 *
 * AllInOne description.
 *
 * @version 1.0
 * @author andy.chao
 */
class AllInOne extends Aio
{
	public $ServiceURL = "ServiceURL";
	public $ServiceMethod = "ServiceMethod";
	public $HashKey = "HashKey";
	public $HashIV = "HashIV";
	public $MerchantID = "MerchantID";
	public $PaymentType = "PaymentType";
	public $Send = "Send";
	public $SendExtend = "SendExtend";
	public $Query = "Query";
	public $Action = "Action";
	public $ChargeBack = "ChargeBack";
	public $EncryptType = EncryptType::ENC_MD5;

	public function __construct()
	{
		$this->PaymentType = "aio";
		$this->Send = array(
						s => "",
						s => "",
						s => "",
						s => "",
						s => "",
						s => "aio",
						s => "",
						s => "",
						s => PaymentMethod::ALL,
						s => "",
						s => PaymentMethodItem::None,
						s => ExtraPaymentInfo::No,
						s => DeviceType::PC,
						s => "",
						s => "",
						s => InvoiceState::No,
						s => array(),
						s => EncryptType::ENC_MD5,
						s => UseRedeem::No
			);
		$this->SendExtend = array();
		$this->Query = array("MerchantTradeNo" => "", "TimeStamp" => "");
		$this->Action = array("MerchantTradeNo" => "", "TradeNo" => "", "Action" => ActionType::C, "TotalAmount" => 0);
		$this->ChargeBack = array("MerchantTradeNo" => "", "TradeNo" => "", "ChargeBackTotalAmount" => 0, "Remark" => "");
	}

	public function CheckOut($target = "_self")
	{
		$arParameters = array("MerchantID" => $this->MerchantID);
		$arParameters = array_merge($arParameters, $this->Send);
		$obj = new Send($arParameters, $this->SendExtend, $this->ServiceURL, $this->HashKey, $this->HashIV);
		$obj->CheckOut($target);
	}

	public function CheckOutString($paymentButton = NULL, $target = "_self")
	{
		$arParameters = array("MerchantID" => $this->MerchantID);
		$arParameters = array_merge($arParameters, $this->Send);
		$obj = new Send($arParameters, $this->SendExtend, $this->ServiceURL, $this->HashKey, $this->HashIV);
		$szHtml = $obj->CheckOutString($paymentButton, $target = "_self");
		return $szHtml;
	}

	public function CheckOutFeedback()
	{
		$arErrors = array();
		$arParameters = array();
		$arFeedback = array();
		$szCheckMacValue = "";

		foreach ($_POST as $keys => $value ) {
			if ($keys != "CheckMacValue") {
				if ($keys == "PaymentType") {
					$value = str_replace("_CVS", "", $value);
					$value = str_replace("_BARCODE", "", $value);
					$value = str_replace("_Alipay", "", $value);
					$value = str_replace("_Tenpay", "", $value);
					$value = str_replace("_CreditCard", "", $value);
				}

				if ($keys == "PeriodType") {
					$value = str_replace("Y", "Year", $value);
					$value = str_replace("M", "Month", $value);
					$value = str_replace("D", "Day", $value);
				}

				$arFeedback[$keys] = $value;
			}
		}

		$arParameters = $_POST;
		unset($arParameters["CheckMacValue"]);
		$CheckMacValue = $this->generateCheckMacValue($arParameters, $this->HashKey, $this->HashIV, 0);

		if ($CheckMacValue != $_POST["CheckMacValue"]) {
			array_push($arErrors, "CheckMacValue verify fail.");
		}

		if (0 < sizeof($arErrors)) {
			throw new Exception(join("- ", $arErrors));
		}

		return $arFeedback;
	}

	public function QueryTradeInfo()
	{
		$arErrors = array();
		$this->Query["TimeStamp"] = time();
		$arFeedback = array();
		$arConfirmArgs = array();

		if (strlen($this->ServiceURL) == 0) {
			array_push($arErrors, "ServiceURL is required.");
		}

		if (200 < strlen($this->ServiceURL)) {
			array_push($arErrors, "ServiceURL max langth as 200.");
		}

		if (strlen($this->HashKey) == 0) {
			array_push($arErrors, "HashKey is required.");
		}

		if (strlen($this->HashIV) == 0) {
			array_push($arErrors, "HashIV is required.");
		}

		if (strlen($this->MerchantID) == 0) {
			array_push($arErrors, "MerchantID is required.");
		}

		if (10 < strlen($this->MerchantID)) {
			array_push($arErrors, "MerchantID max langth as 10.");
		}

		if (strlen($this->Query["MerchantTradeNo"]) == 0) {
			array_push($arErrors, "MerchantTradeNo is required.");
		}

		if (20 < strlen($this->Query["MerchantTradeNo"])) {
			array_push($arErrors, "MerchantTradeNo max langth as 20.");
		}

		if (strlen($this->Query["TimeStamp"]) == 0) {
			array_push($arErrors, "TimeStamp is required.");
		}

		if (sizeof($arErrors) == 0) {
			$arParameters = array("MerchantID" => $this->MerchantID);
			$arParameters = array_merge($arParameters, $this->Query);
			$szCheckMacValue = $this->generateCheckMacValue($arParameters, $this->HashKey, $this->HashIV, 0);
			$arParameters["CheckMacValue"] = $szCheckMacValue;
			$szResult = $this->ServerPost($arParameters);
			$szResult = str_replace(" ", "%20", $szResult);
			$szResult = str_replace("+", "%2B", $szResult);
			parse_str($szResult, $arParameters);

			foreach ($arParameters as $keys => $value ) {
				if ($keys == "CheckMacValue") {
					$szCheckMacValue = $value;
				}
				else {
					$arFeedback[$keys] = $value;
					$arConfirmArgs[$keys] = $value;
				}
			}

			if (0 < sizeof($arFeedback)) {
				$szConfirmMacValue = $this->generateCheckMacValue($arConfirmArgs, $this->HashKey, $this->HashIV, 0);

				if ($szCheckMacValue != $szConfirmMacValue) {
					array_push($arErrors, "CheckMacValue verify fail.");
				}
			}
		}

		if (0 < sizeof($arErrors)) {
			throw new Exception(join("- ", $arErrors));
		}

		return $arFeedback;
	}

	public function QueryPeriodCreditCardTradeInfo()
	{
		$arErrors = array();
		$this->Query["TimeStamp"] = time();
		$arFeedback = array();
		$arConfirmArgs = array();

		if (strlen($this->ServiceURL) == 0) {
			array_push($arErrors, "ServiceURL is required.");
		}

		if (200 < strlen($this->ServiceURL)) {
			array_push($arErrors, "ServiceURL max langth as 200.");
		}

		if (strlen($this->HashKey) == 0) {
			array_push($arErrors, "HashKey is required.");
		}

		if (strlen($this->HashIV) == 0) {
			array_push($arErrors, "HashIV is required.");
		}

		if (strlen($this->MerchantID) == 0) {
			array_push($arErrors, "MerchantID is required.");
		}

		if (10 < strlen($this->MerchantID)) {
			array_push($arErrors, "MerchantID max langth as 10.");
		}

		if (strlen($this->Query["MerchantTradeNo"]) == 0) {
			array_push($arErrors, "MerchantTradeNo is required.");
		}

		if (20 < strlen($this->Query["MerchantTradeNo"])) {
			array_push($arErrors, "MerchantTradeNo max langth as 20.");
		}

		if (strlen($this->Query["TimeStamp"]) == 0) {
			array_push($arErrors, "TimeStamp is required.");
		}

		if (sizeof($arErrors) == 0) {
			$arParameters = array("MerchantID" => $this->MerchantID);
			$arParameters = array_merge($arParameters, $this->Query);
			$szCheckMacValue = $this->generateCheckMacValue($arParameters, $this->HashKey, $this->HashIV, 0);
			$arParameters["CheckMacValue"] = $szCheckMacValue;
			$szResult = $this->ServerPost($arParameters);
			$szResult = str_replace(" ", "%20", $szResult);
			$szResult = str_replace("+", "%2B", $szResult);
			parse_str($szResult, $arParameters);
		}

		if (0 < sizeof($arErrors)) {
			throw new Exception(join("- ", $arErrors));
		}

		return $arFeedback;
	}

	public function DoAction()
	{
		$arErrors = array();
		$arFeedback = array();

		if (strlen($this->ServiceURL) == 0) {
			array_push($arErrors, "ServiceURL is required.");
		}

		if (200 < strlen($this->ServiceURL)) {
			array_push($arErrors, "ServiceURL max langth as 200.");
		}

		if (strlen($this->HashKey) == 0) {
			array_push($arErrors, "HashKey is required.");
		}

		if (strlen($this->HashIV) == 0) {
			array_push($arErrors, "HashIV is required.");
		}

		if (strlen($this->MerchantID) == 0) {
			array_push($arErrors, "MerchantID is required.");
		}

		if (10 < strlen($this->MerchantID)) {
			array_push($arErrors, "MerchantID max langth as 10.");
		}

		if (strlen($this->Action["MerchantTradeNo"]) == 0) {
			array_push($arErrors, "MerchantTradeNo is required.");
		}

		if (20 < strlen($this->Action["MerchantTradeNo"])) {
			array_push($arErrors, "MerchantTradeNo max langth as 20.");
		}

		if (strlen($this->Action["TradeNo"]) == 0) {
			array_push($arErrors, "TradeNo is required.");
		}

		if (20 < strlen($this->Action["TradeNo"])) {
			array_push($arErrors, "TradeNo max langth as 20.");
		}

		if (strlen($this->Action["Action"]) == 0) {
			array_push($arErrors, "Action is required.");
		}

		if (1 < strlen($this->Action["Action"])) {
			array_push($arErrors, "Action max length as 1.");
		}

		if (strlen($this->Action["TotalAmount"]) == 0) {
			array_push($arErrors, "TotalAmount is required.");
		}

		if (sizeof($arErrors) == 0) {
			$arParameters = array("MerchantID" => $this->MerchantID);
			$arParameters = array_merge($arParameters, $this->Action);
			$szCheckMacValue = $this->generateCheckMacValue($arParameters, $this->HashKey, $this->HashIV, 0);
			$arParameters["CheckMacValue"] = $szCheckMacValue;
			$szResult = $this->ServerPost($arParameters);
			parse_str($szResult, $arParameters);

			foreach ($arParameters as $keys => $value ) {
				if ($keys == "CheckMacValue") {
					$szCheckMacValue = $value;
				}
				else {
					$arFeedback[$keys] = $value;
				}
			}

			if (array_key_exists("RtnCode", $arFeedback) && ($arFeedback["RtnCode"] != "1")) {
				array_push($arErrors, vsprintf("#%s: %s", array($arFeedback["RtnCode"], $arFeedback["RtnMsg"])));
			}
		}

		if (0 < sizeof($arErrors)) {
			throw new Exception(join("- ", $arErrors));
		}

		return $arFeedback;
	}

	public function AioChargeback()
	{
		$arErrors = array();
		$arParameters = array("MerchantID" => $this->MerchantID);
		$arParameters = array_merge($arParameters, $this->ChargeBack);
		$arFeedback = array();

		if (strlen($this->ServiceURL) == 0) {
			array_push($arErrors, "ServiceURL is required.");
		}

		if (200 < strlen($this->ServiceURL)) {
			array_push($arErrors, "ServiceURL max langth as 200.");
		}

		if (strlen($this->HashKey) == 0) {
			array_push($arErrors, "HashKey is required.");
		}

		if (strlen($this->HashIV) == 0) {
			array_push($arErrors, "HashIV is required.");
		}

		if (strlen($this->MerchantID) == 0) {
			array_push($arErrors, "MerchantID is required.");
		}

		if (10 < strlen($this->MerchantID)) {
			array_push($arErrors, "MerchantID max langth as 10.");
		}

		if (strlen($this->ChargeBack["MerchantTradeNo"]) == 0) {
			array_push($arErrors, "MerchantTradeNo is required.");
		}

		if (20 < strlen($this->ChargeBack["MerchantTradeNo"])) {
			array_push($arErrors, "MerchantTradeNo max langth as 20.");
		}

		if (strlen($this->ChargeBack["TradeNo"]) == 0) {
			array_push($arErrors, "TradeNo is required.");
		}

		if (20 < strlen($this->ChargeBack["TradeNo"])) {
			array_push($arErrors, "TradeNo max langth as 20.");
		}

		if (strlen($this->ChargeBack["ChargeBackTotalAmount"]) == 0) {
			array_push($arErrors, "ChargeBackTotalAmount is required.");
		}

		if (200 < strlen($this->ChargeBack["Remark"])) {
			array_push($arErrors, "Remark max length as 200.");
		}

		$szCheckMacValue = $this->generateCheckMacValue($arParameters, $this->HashKey, $this->HashIV, 0);
		$arParameters["CheckMacValue"] = $szCheckMacValue;
		$szResult = $this->ServerPost($arParameters);

		if ($szResult == "1|OK") {
			$arFeedback["RtnCode"] = "1";
			$arFeedback["RtnMsg"] = "OK";
		}
		else {
			array_push($arErrors, str_replace("-", ": ", $szResult));
		}

		if (0 < sizeof($arErrors)) {
			throw new Exception(join("- ", $arErrors));
		}

		return $arFeedback;
	}

	private function ServerPost($parameters)
	{
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $this->ServiceURL);
		curl_setopt($ch, CURLOPT_HEADER, false);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($parameters));
		$rs = curl_exec($ch);
		curl_close($ch);
		return $rs;
	}
}

/**
*  鐢㈢敓瑷傚柈
*/
class Send extends Aio
{
	public $arParameters;
	public $arExtend;
	public $ServiceURL;
	public $HashKey;
	public $HashIV;
	public $PaymentObj;

	public function __construct($arParameters = array(), $arExtend = array(), $ServiceURL = "", $HashKey = "", $HashIV = "")
	{
		$this->ServiceURL = $ServiceURL;
		$this->HashKey = $HashKey;
		$this->HashIV = $HashIV;
		$PaymentMethod = "allPay_" . $arParameters["ChoosePayment"];
		$this->PaymentObj = new $PaymentMethod();
		$arParameters = $this->PaymentObj->check_string($arParameters, $this->ServiceURL, $this->HashKey, $this->HashIV);
		$arParameters = $this->PaymentObj->check_goods($arParameters);
		$arExtend = $this->PaymentObj->check_extend_string($arExtend, $arParameters["InvoiceMark"]);
		$this->arExtend = $this->PaymentObj->filter_string($arExtend, $arParameters["InvoiceMark"]);
		$this->arParameters = array_merge($arParameters, $this->arExtend);
	}

	public function CheckOut($target = "_self")
	{
		$szCheckMacValue = $this->generateCheckMacValue($this->arParameters, $this->HashKey, $this->HashIV, $this->arParameters["EncryptType"]);
		$szHtml = "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />";
		$szHtml .= "<div style=\"text-align:center;\" ><form id=\"__allpayForm\" method=\"post\" target=\"" . $target . "\" action=\"" . $this->ServiceURL . "\">";

		foreach ($this->arParameters as $keys => $value ) {
			$szHtml .= "<input type='hidden' name='$keys' value='$value' />";
		}

		$szHtml .= "<input type=\"hidden\" name=\"CheckMacValue\" value=\"" . $szCheckMacValue . "\" />";
		$szHtml .= "<script type=\"text/javascript\">document.getElementById(\"__allpayForm\").submit();</script>";
		$szHtml .= "</form></div>";
		echo $szHtml;
		exit();
	}

	public function CheckOutString($paymentButton, $target = "_self")
	{
		$szCheckMacValue = $this->generateCheckMacValue($this->arParameters, $this->HashKey, $this->HashIV, $this->arParameters["EncryptType"]);
		$szHtml = "";
		$szHtml = "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />";
		$szHtml .= "<div style=\"text-align:center;\" ><form id=\"__allpayForm\" method=\"post\" target=\"" . $target . "\" action=\"" . $this->ServiceURL . "\">";

		foreach ($this->arParameters as $keys => $value ) {
			$szHtml .= "<input type='hidden' name='$keys' value='$value' />";
		}

		$szHtml .= "<input type=\"hidden\" name=\"CheckMacValue\" value=\"" . $szCheckMacValue . "\" />";

		if (!isset($paymentButton)) {
			$szHtml .= "<script type=\"text/javascript\">document.getElementById(\"__allpayForm\").submit();</script>";
		}
		else {
			$szHtml .= "<input type=\"submit\" id=\"__paymentButton\" value=\"" . $paymentButton . "\" />";
		}

		$szHtml .= "</form></div>";
		return $szHtml;
	}
}

/**
*  浠樻鏂瑰纺锛氲秴鍟嗕唬纰?*/
class allPay_CVS extends Verification
{
	public $arPayMentExtend = array("Desc_1" => "", "Desc_2" => "", "Desc_3" => "", "Desc_4" => "", "PaymentInfoURL" => "", "ClientRedirectURL" => "", "StoreExpireDate" => "");

	public function check_string($arParameters = array(), $ServiceURL = "", $HashKey = "", $HashIV = "")
	{
		parent::check_string($arParameters, $ServiceURL, $HashKey, $HashIV);

		if (!$arParameters["PlatformID"]) {
			unset($arParameters["PlatformID"]);
		}

		unset($arParameters["IgnorePayment"]);
		return $arParameters;
	}

	public function check_extend_string($arExtend = array(), $InvoiceMark = "")
	{
		foreach ($this->arPayMentExtend as $key => $value ) {
			if (!isset($arExtend[$key])) {
				$arExtend[$key] = $value;
			}
		}

		if ($InvoiceMark == "Y") {
			$arExtend = $this->check_invoiceString($arExtend);
		}

		return $arExtend;
	}

	public function filter_string($arExtend = array(), $InvoiceMark = "")
	{
		$arPayMentExtend = ($InvoiceMark == "" ? array_keys($this->arPayMentExtend) : array_merge(array_keys($this->arPayMentExtend), $this->arInvoice));

		foreach ($arExtend as $key => $value ) {
			if (!in_array($key, $arPayMentExtend)) {
				unset($arExtend[$key]);
			}
		}

		return $arExtend;
	}

	public function check_goods($arParameters = array())
	{
		$szItemName = "";
		$arErrors = array();

		if (0 < sizeof($arParameters["Items"])) {
			foreach ($arParameters["Items"] as $keys => $value ) {
				$szItemName .= vsprintf("#%s %d %s x %u", $arParameters["Items"][$keys]);

				if (!array_key_exists("ItemURL", $arParameters)) {
					$arParameters["ItemURL"] = $arParameters["Items"][$keys]["URL"];
				}
			}

			if (0 < strlen($szItemName)) {
				$szItemName = mb_substr($szItemName, 1, 200);
				$arParameters["ItemName"] = $szItemName;
			}
		}
		else {
			array_push($arErrors, "Goods information not found.");
		}

		if (0 < sizeof($arErrors)) {
			throw new Exception(join("<br>", $arErrors));
		}

		unset($arParameters["Items"]);
		return $arParameters;
	}
}

/**
* 浠樻鏂瑰纺 : BARCODE 
*/
class allPay_BARCODE extends Verification
{
	public $arPayMentExtend = array("Desc_1" => "", "Desc_2" => "", "Desc_3" => "", "Desc_4" => "", "PaymentInfoURL" => "", "ClientRedirectURL" => "", "StoreExpireDate" => "");

	public function check_string($arParameters = array(), $ServiceURL = "", $HashKey = "", $HashIV = "")
	{
		parent::check_string($arParameters, $ServiceURL, $HashKey, $HashIV);

		if (!$arParameters["PlatformID"]) {
			unset($arParameters["PlatformID"]);
		}

		unset($arParameters["IgnorePayment"]);
		return $arParameters;
	}

	public function check_extend_string($arExtend = array(), $InvoiceMark = "")
	{
		foreach ($this->arPayMentExtend as $key => $value ) {
			if (!isset($arExtend[$key])) {
				$arExtend[$key] = $value;
			}
		}

		if ($InvoiceMark == "Y") {
			$arExtend = $this->check_invoiceString($arExtend);
		}

		return $arExtend;
	}

	public function filter_string($arExtend = array(), $InvoiceMark = "")
	{
		$arPayMentExtend = ($InvoiceMark == "" ? array_keys($this->arPayMentExtend) : array_merge(array_keys($this->arPayMentExtend), $this->arInvoice));

		foreach ($arExtend as $key => $value ) {
			if (!in_array($key, $arPayMentExtend)) {
				unset($arExtend[$key]);
			}
		}

		return $arExtend;
	}

	public function check_goods($arParameters = array())
	{
		$szItemName = "";
		$arErrors = array();

		if (0 < sizeof($arParameters["Items"])) {
			foreach ($arParameters["Items"] as $keys => $value ) {
				$szItemName .= vsprintf("#%s %d %s x %u", $arParameters["Items"][$keys]);

				if (!array_key_exists("ItemURL", $arParameters)) {
					$arParameters["ItemURL"] = $arParameters["Items"][$keys]["URL"];
				}
			}

			if (0 < strlen($szItemName)) {
				$szItemName = mb_substr($szItemName, 1, 200);
				$arParameters["ItemName"] = $szItemName;
			}
		}
		else {
			array_push($arErrors, "Goods information not found.");
		}

		if (0 < sizeof($arErrors)) {
			throw new Exception(join("<br>", $arErrors));
		}

		unset($arParameters["Items"]);
		return $arParameters;
	}
}

/**
*  浠樻鏂瑰纺 ATM
*/
class allPay_ATM extends Verification
{
	public $arPayMentExtend = array("ExpireDate" => 3, "PaymentInfoURL" => "", "ClientRedirectURL" => "");

	public function check_string($arParameters = array(), $ServiceURL = "", $HashKey = "", $HashIV = "")
	{
		parent::check_string($arParameters, $ServiceURL, $HashKey, $HashIV);

		if (!$arParameters["PlatformID"]) {
			unset($arParameters["PlatformID"]);
		}

		unset($arParameters["IgnorePayment"]);
		return $arParameters;
	}

	public function check_extend_string($arExtend = array(), $InvoiceMark = "")
	{
		foreach ($this->arPayMentExtend as $key => $value ) {
			if (!isset($arExtend[$key])) {
				$arExtend[$key] = $value;
			}
		}

		if ($InvoiceMark == "Y") {
			$arExtend = $this->check_invoiceString($arExtend);
		}

		return $arExtend;
	}

	public function filter_string($arExtend = array(), $InvoiceMark = "")
	{
		$arPayMentExtend = ($InvoiceMark == "" ? array_keys($this->arPayMentExtend) : array_merge(array_keys($this->arPayMentExtend), $this->arInvoice));

		foreach ($arExtend as $key => $value ) {
			if (!in_array($key, $arPayMentExtend)) {
				unset($arExtend[$key]);
			}
		}

		return $arExtend;
	}

	public function check_goods($arParameters = array())
	{
		$szItemName = "";
		$arErrors = array();

		if (0 < sizeof($arParameters["Items"])) {
			foreach ($arParameters["Items"] as $keys => $value ) {
				$szItemName .= vsprintf("#%s %d %s x %u", $arParameters["Items"][$keys]);

				if (!array_key_exists("ItemURL", $arParameters)) {
					$arParameters["ItemURL"] = $arParameters["Items"][$keys]["URL"];
				}
			}

			if (0 < strlen($szItemName)) {
				$szItemName = mb_substr($szItemName, 1, 200);
				$arParameters["ItemName"] = $szItemName;
			}
		}
		else {
			array_push($arErrors, "Goods information not found.");
		}

		if (0 < sizeof($arErrors)) {
			throw new Exception(join("<br>", $arErrors));
		}

		unset($arParameters["Items"]);
		return $arParameters;
	}
}

/**
*  浠樻鏂瑰纺 WebATM
*/
class allPay_WebATM extends Verification
{
	public $arPayMentExtend = array();

	public function check_string($arParameters = array(), $ServiceURL = "", $HashKey = "", $HashIV = "")
	{
		parent::check_string($arParameters, $ServiceURL, $HashKey, $HashIV);

		if (!$arParameters["PlatformID"]) {
			unset($arParameters["PlatformID"]);
		}

		unset($arParameters["IgnorePayment"]);
		return $arParameters;
	}

	public function check_extend_string($arExtend = array(), $InvoiceMark = "")
	{
		foreach ($this->arPayMentExtend as $key => $value ) {
			if (!isset($arExtend[$key])) {
				$arExtend[$key] = $value;
			}
		}

		if ($InvoiceMark == "Y") {
			$arExtend = $this->check_invoiceString($arExtend);
		}

		return $arExtend;
	}

	public function filter_string($arExtend = array(), $InvoiceMark = "")
	{
		$arPayMentExtend = ($InvoiceMark == "" ? array_keys($this->arPayMentExtend) : array_merge(array_keys($this->arPayMentExtend), $this->arInvoice));

		foreach ($arExtend as $key => $value ) {
			if (!in_array($key, $arPayMentExtend)) {
				unset($arExtend[$key]);
			}
		}

		return $arExtend;
	}

	public function check_goods($arParameters = array())
	{
		$arErrors = array();
		$szItemName = "";

		if (0 < sizeof($arParameters["Items"])) {
			foreach ($arParameters["Items"] as $keys => $value ) {
				$szItemName .= vsprintf("#%s %d %s x %u", $arParameters["Items"][$keys]);

				if (!array_key_exists("ItemURL", $arParameters)) {
					$arParameters["ItemURL"] = $arParameters["Items"][$keys]["URL"];
				}
			}

			if (0 < strlen($szItemName)) {
				$szItemName = mb_substr($szItemName, 1, 200);
				$arParameters["ItemName"] = $szItemName;
			}
		}
		else {
			array_push($arErrors, "Goods information not found.");
		}

		if (0 < sizeof($arErrors)) {
			throw new Exception(join("<br>", $arErrors));
		}

		unset($arParameters["Items"]);
		return $arParameters;
	}
}

/**
* 浠樻鏂瑰纺 : Alipay
*/
class allPay_Alipay extends Verification
{
	public $arPayMentExtend = array("Email" => "", "PhoneNo" => "", "UserName" => "", "AlipayItemName" => "", "AlipayItemCounts" => "", "AlipayItemPrice" => "");

	public function check_string($arParameters = array(), $ServiceURL = "", $HashKey = "", $HashIV = "")
	{
		parent::check_string($arParameters, $ServiceURL, $HashKey, $HashIV);

		if (!$arParameters["PlatformID"]) {
			unset($arParameters["PlatformID"]);
		}

		unset($arParameters["IgnorePayment"]);
		return $arParameters;
	}

	public function check_extend_string($arExtend = array(), $InvoiceMark = "")
	{
		$arErrors = array();

		foreach ($this->arPayMentExtend as $value ) {
			if (!array_key_exists($value, $arExtend)) {
				array_push($arErrors, $value . " is required");
			}
		}

		if (empty($arExtend["AlipayItemName"]) || empty($arExtend["AlipayItemCounts"]) || empty($arExtend["AlipayItemPrice"])) {
			array_push($arErrors, "AlipayItemName , AlipayItemCounts ,AlipayItemPrice is required");
		}

		if (0 < sizeof($arErrors)) {
			throw new Exception(join("<br>", $arErrors));
		}

		if ($InvoiceMark == "Y") {
			$arExtend = $this->check_invoiceString($arExtend);
		}

		return $arExtend;
	}

	public function filter_string($arExtend = array(), $InvoiceMark = "")
	{
		$arPayMentExtend = ($InvoiceMark == "" ? $this->arPayMentExtend : array_merge($this->arPayMentExtend, $this->arInvoice));

		foreach ($arExtend as $key => $value ) {
			if (!in_array($key, $arPayMentExtend)) {
				unset($arExtend[$key]);
			}
		}

		return $arExtend;
	}

	public function check_goods($arParameters = array())
	{
		$arErrors = array();
		$szAlipayItemName = "";
		$szAlipayItemCounts = "";
		$szAlipayItemPrice = "";

		if (0 < sizeof($arParameters["Items"])) {
			foreach ($arParameters["Items"] as $keys => $value ) {
				$szItemName .= vsprintf("#%s %d %s x %u", $arParameters["Items"][$keys]);
				$szAlipayItemName .= sprintf("#%s", $arParameters["Items"][$keys]["Name"]);
				$szAlipayItemCounts .= sprintf("#%u", $arParameters["Items"][$keys]["Quantity"]);
				$szAlipayItemPrice .= sprintf("#%d", $arParameters["Items"][$keys]["Price"]);

				if (!array_key_exists("ItemURL", $arParameters)) {
					$arParameters["ItemURL"] = $arParameters["Items"][$keys]["URL"];
				}
			}

			if (0 < strlen($szItemName)) {
				$szItemName = mb_substr($szItemName, 1, 200);
				$arParameters["ItemName"] = $szItemName;
			}

			if (0 < strlen($szAlipayItemName)) {
				$szAlipayItemName = mb_substr($szAlipayItemName, 1, 200);
			}

			if (0 < strlen($szAlipayItemCounts)) {
				$szAlipayItemCounts = mb_substr($szAlipayItemCounts, 1, 100);
			}

			if (0 < strlen($szAlipayItemPrice)) {
				$szAlipayItemPrice = mb_substr($szAlipayItemPrice, 1, 20);
			}

			$arParameters["AlipayItemName"] = $szAlipayItemName;
			$arParameters["AlipayItemCounts"] = $szAlipayItemCounts;
			$arParameters["AlipayItemPrice"] = $szAlipayItemPrice;
		}
		else {
			array_push($arErrors, "Goods information not found.");
		}

		if (0 < sizeof($arErrors)) {
			throw new Exception(join("<br>", $arErrors));
		}

		unset($arParameters["Items"]);
		return $arParameters;
	}
}

/**
* 浠樻鏂瑰纺锛歍enpay
*/
class allPay_Tenpay extends Verification
{
	public $arPayMentExtend = array("ExpireTime" => "");

	public function check_string($arParameters = array(), $ServiceURL = "", $HashKey = "", $HashIV = "")
	{
		parent::check_string($arParameters, $ServiceURL, $HashKey, $HashIV);

		if (!$arParameters["PlatformID"]) {
			unset($arParameters["PlatformID"]);
		}

		unset($arParameters["IgnorePayment"]);
		return $arParameters;
	}

	public function check_extend_string($arExtend = array(), $InvoiceMark = "")
	{
		foreach ($this->arPayMentExtend as $key => $value ) {
			if (!isset($arExtend[$key])) {
				$arExtend[$key] = $value;
			}
		}

		if ($InvoiceMark == "Y") {
			$arExtend = $this->check_invoiceString($arExtend);
		}

		return $arExtend;
	}

	public function filter_string($arExtend = array(), $InvoiceMark = "")
	{
		$arPayMentExtend = ($InvoiceMark == "" ? array_keys($this->arPayMentExtend) : array_merge(array_keys($this->arPayMentExtend), $this->arInvoice));

		foreach ($arExtend as $key => $value ) {
			if (!in_array($key, $arPayMentExtend)) {
				unset($arExtend[$key]);
			}
		}

		return $arExtend;
	}

	public function check_goods($arParameters = array())
	{
		$szItemName = "";
		$arErrors = array();

		if (0 < sizeof($arParameters["Items"])) {
			foreach ($arParameters["Items"] as $keys => $value ) {
				$szItemName .= vsprintf("#%s %d %s x %u", $arParameters["Items"][$keys]);

				if (!array_key_exists("ItemURL", $arParameters)) {
					$arParameters["ItemURL"] = $arParameters["Items"][$keys]["URL"];
				}
			}

			if (0 < strlen($szItemName)) {
				$szItemName = mb_substr($szItemName, 1, 200);
				$arParameters["ItemName"] = $szItemName;
			}
		}
		else {
			array_push($arErrors, "Goods information not found.");
		}

		if (0 < sizeof($arErrors)) {
			throw new Exception(join("<br>", $arErrors));
		}

		unset($arParameters["Items"]);
		return $arParameters;
	}
}

/**
* 浠樻鏂瑰纺 : 淇＄敤鍗?*/
class allPay_Credit extends Verification
{
	public $arPayMentExtend = array("CreditInstallment" => 0, "InstallmentAmount" => 0, "Redeem" => false, "UnionPay" => false, "Language" => "", "PeriodAmount" => "", "PeriodType" => "", "Frequency" => "", "ExecTimes" => "");

	public function check_string($arParameters = array(), $ServiceURL = "", $HashKey = "", $HashIV = "")
	{
		parent::check_string($arParameters, $ServiceURL, $HashKey, $HashIV);

		if (!$arParameters["PlatformID"]) {
			unset($arParameters["PlatformID"]);
		}

		unset($arParameters["IgnorePayment"]);
		return $arParameters;
	}

	public function check_extend_string($arExtend = array(), $InvoiceMark = "")
	{
		foreach ($this->arPayMentExtend as $key => $value ) {
			if (!isset($arExtend[$key])) {
				$arExtend[$key] = $value;
			}
		}

		if ($InvoiceMark == "Y") {
			$arExtend = $this->check_invoiceString($arExtend);
		}

		return $arExtend;
	}

	public function filter_string($arExtend = array(), $InvoiceMark = "")
	{
		$arPayMentExtend = ($InvoiceMark == "" ? array_keys($this->arPayMentExtend) : array_merge(array_keys($this->arPayMentExtend), $this->arInvoice));

		foreach ($arExtend as $key => $value ) {
			if (!in_array($key, $arPayMentExtend)) {
				unset($arExtend[$key]);
			}
		}

		return $arExtend;
	}

	public function check_goods($arParameters = array())
	{
		$arErrors = array();
		$szItemName = "";

		if (0 < sizeof($arParameters["Items"])) {
			foreach ($arParameters["Items"] as $keys => $value ) {
				$szItemName .= vsprintf("#%s %d %s x %u", $arParameters["Items"][$keys]);

				if (!array_key_exists("ItemURL", $arParameters)) {
					$arParameters["ItemURL"] = $arParameters["Items"][$keys]["URL"];
				}
			}

			if (0 < strlen($szItemName)) {
				$szItemName = mb_substr($szItemName, 1, 200);
				$arParameters["ItemName"] = $szItemName;
			}
		}
		else {
			array_push($arErrors, "Goods information not found.");
		}

		if (0 < sizeof($arErrors)) {
			throw new Exception(join("<br>", $arErrors));
		}

		unset($arParameters["Items"]);
		return $arParameters;
	}
}

/**
* 浠樻鏂瑰纺:TopUpUsed
*/
class allPay_TopUpUsed extends Verification
{
	public $arPayMentExtend = array();

	public function check_string($arParameters = array(), $ServiceURL = "", $HashKey = "", $HashIV = "")
	{
		parent::check_string($arParameters, $ServiceURL, $HashKey, $HashIV);

		if (!$arParameters["PlatformID"]) {
			unset($arParameters["PlatformID"]);
		}

		unset($arParameters["IgnorePayment"]);
		return $arParameters;
	}

	public function check_extend_string($arExtend = array(), $InvoiceMark = "")
	{
		if ($InvoiceMark == "Y") {
			$arExtend = $this->check_invoiceString($arExtend);
		}

		return $arExtend;
	}

	public function filter_string($arExtend = array(), $InvoiceMark = "")
	{
		return $arExtend;
	}

	public function check_goods($arParameters = array())
	{
		$arErrors = array();
		$szItemName = "";

		if (0 < sizeof($arParameters["Items"])) {
			foreach ($arParameters["Items"] as $keys => $value ) {
				$szItemName .= vsprintf("#%s %d %s x %u", $arParameters["Items"][$keys]);

				if (!array_key_exists("ItemURL", $arParameters)) {
					$arParameters["ItemURL"] = $arParameters["Items"][$keys]["URL"];
				}
			}

			if (0 < strlen($szItemName)) {
				$szItemName = mb_substr($szItemName, 1, 200);
				$arParameters["ItemName"] = $szItemName;
			}
		}
		else {
			array_push($arErrors, "Goods information not found.");
		}

		if (0 < sizeof($arErrors)) {
			throw new Exception(join("<br>", $arErrors));
		}

		unset($arParameters["Items"]);
		return $arParameters;
	}
}

/**
*  浠樻鏂瑰纺锛氩叏锷熻兘
*/
class allPay_ALL extends Verification
{
	public $arPayMentExtend = array();

	public function check_string($arParameters = array(), $ServiceURL = "", $HashKey = "", $HashIV = "")
	{
		parent::check_string($arParameters, $ServiceURL, $HashKey, $HashIV);

		if (!$arParameters["PlatformID"]) {
			unset($arParameters["PlatformID"]);
		}

		return $arParameters;
	}

	public function check_extend_string($arExtend = array(), $InvoiceMark = "")
	{
		if ($InvoiceMark == "Y") {
			$arExtend = $this->check_invoiceString($arExtend);
		}

		return $arExtend;
	}

	public function filter_string($arExtend = array(), $InvoiceMark = "")
	{
		return $arExtend;
	}

	public function check_goods($arParameters = array())
	{
		$arErrors = array();
		$szAlipayItemName = "";
		$szAlipayItemCounts = "";
		$szAlipayItemPrice = "";
		$szItemName = "";

		if (0 < sizeof($arParameters["Items"])) {
			foreach ($arParameters["Items"] as $keys => $value ) {
				$szItemName .= vsprintf("#%s %d %s x %u", $arParameters["Items"][$keys]);
				$szAlipayItemName .= sprintf("#%s", $arParameters["Items"][$keys]["Name"]);
				$szAlipayItemCounts .= sprintf("#%u", $arParameters["Items"][$keys]["Quantity"]);
				$szAlipayItemPrice .= sprintf("#%d", $arParameters["Items"][$keys]["Price"]);

				if (!array_key_exists("ItemURL", $arParameters)) {
					$arParameters["ItemURL"] = $arParameters["Items"][$keys]["URL"];
				}
			}

			if (0 < strlen($szItemName)) {
				$szItemName = mb_substr($szItemName, 1, 200);
				$arParameters["ItemName"] = $szItemName;
			}

			if (0 < strlen($szAlipayItemName)) {
				$szAlipayItemName = mb_substr($szAlipayItemName, 1, 200);
			}

			if (0 < strlen($szAlipayItemCounts)) {
				$szAlipayItemCounts = mb_substr($szAlipayItemCounts, 1, 100);
			}

			if (0 < strlen($szAlipayItemPrice)) {
				$szAlipayItemPrice = mb_substr($szAlipayItemPrice, 1, 20);
			}

			$arParameters["AlipayItemName"] = $szAlipayItemName;
			$arParameters["AlipayItemCounts"] = $szAlipayItemCounts;
			$arParameters["AlipayItemPrice"] = $szAlipayItemPrice;
		}
		else {
			array_push($arErrors, "Goods information not found.");
		}

		if (0 < sizeof($arErrors)) {
			throw new Exception(join("<br>", $arErrors));
		}

		unset($arParameters["Items"]);
		return $arParameters;
	}
}


?>
