<?php

define("JIEQI_MODULE_NAME", "pay");
define("JIEQI_PAY_TYPE", "sndagame");
require_once ("../../global.php");
jieqi_loadlang("pay", JIEQI_MODULE_NAME);

if (!jieqi_checklogin(true)) {
	jieqi_printfail($jieqiLang["pay"]["need_login"]);
}

jieqi_getconfigs(JIEQI_MODULE_NAME, JIEQI_PAY_TYPE, "jieqiPayset");
$_REQUEST["paytype"] = trim($_REQUEST["paytype"]);
if (!$_REQUEST["paytype"] || ($_REQUEST["paytype"] == "")) {
	jieqi_printfail($jieqiLang["pay"]["need_pay_type"]);
}

if (isset($_REQUEST["egold"]) && is_numeric($_REQUEST["egold"]) && (0 < $_REQUEST["egold"])) {
	$_REQUEST["egold"] = intval($_REQUEST["egold"]);

	if (!empty($jieqiPayset[JIEQI_PAY_TYPE]["paylimit"])) {
		if (!empty($jieqiPayset[JIEQI_PAY_TYPE]["paylimit"][$_REQUEST["egold"]])) {
			$money = intval($jieqiPayset[JIEQI_PAY_TYPE]["paylimit"][$_REQUEST["egold"]] * 100);
		}
		else {
			jieqi_printfail($jieqiLang["pay"]["buy_type_error"]);
		}
	}
	else {
		$money = intval($_REQUEST["egold"]);
	}

	include_once (JIEQI_ROOT_PATH . "/modules/pay/class/paylog.php");
	$paylog_handler = JieqiPaylogHandler::getInstance("JieqiPaylogHandler");
	$paylog = $paylog_handler->create();
	$paylog->setVar("siteid", JIEQI_SITE_ID);
	$paylog->setVar("buytime", JIEQI_NOW_TIME);
	$paylog->setVar("rettime", 0);
	$paylog->setVar("buyid", $_SESSION["jieqiUserId"]);
	$paylog->setVar("buyname", $_SESSION["jieqiUserName"]);
	$paylog->setVar("buyinfo", "");
	$paylog->setVar("moneytype", $jieqiPayset[JIEQI_PAY_TYPE]["moneytype"]);
	$paylog->setVar("money", $money);
	$paylog->setVar("egoldtype", $jieqiPayset[JIEQI_PAY_TYPE]["paysilver"]);
	$paylog->setVar("egold", $_REQUEST["egold"]);
	$paylog->setVar("paytype", JIEQI_PAY_TYPE);
	$paylog->setVar("retserialno", "");
	$paylog->setVar("retaccount", "");
	$paylog->setVar("retinfo", "");
	$paylog->setVar("masterid", 0);
	$paylog->setVar("mastername", "");
	$paylog->setVar("masterinfo", "");
	$paylog->setVar("note", "");
	$paylog->setVar("payflag", 0);

	if (!$paylog_handler->insert($paylog)) {
		jieqi_printfail($jieqiLang["pay"]["add_paylog_error"]);
	}
	else {
		$amount = $money / 100;
		$merchant_id = $jieqiPayset[JIEQI_PAY_TYPE]["payid"];
		$orderid = $paylog->getVar("payid");
		$currency = $jieqiPayset[JIEQI_PAY_TYPE]["currency"];
		$merchant_url = $jieqiPayset[JIEQI_PAY_TYPE]["payreturn"];
		$commodity_info = urlencode(JIEQI_EGOLD_NAME);
		$pname = urlencode($_SESSION["jieqiUserName"]);
		$pemail = $jieqiPayset[JIEQI_PAY_TYPE]["pemail"];
		$merchant_param = $jieqiPayset[JIEQI_PAY_TYPE]["merchant_param"];
		$isSupportDES = $jieqiPayset[JIEQI_PAY_TYPE]["isSupportDES"] = "2";
		$key = $jieqiPayset[JIEQI_PAY_TYPE]["paykey"];
		$pid_15173account = $jieqiPayset[JIEQI_PAY_TYPE]["pid_15173account"];
		$attach = "sndagame";
		$text = "bargainor_id=" . $merchant_id . "&sp_billno=" . $orderid . "&pay_type=" . $_REQUEST["paytype"] . "&return_url=" . $merchant_url . "&attach=" . $attach . "&key=" . $key;
		$mac = strtoupper(md5($text));
		include_once (JIEQI_ROOT_PATH . "/header.php");
		include_once (JIEQI_ROOT_PATH . "/lib/template/template.php");
		$jieqiTpl = &JieqiTpl::getInstance();
		$jieqiTpl->assign("url_pay", $jieqiPayset[JIEQI_PAY_TYPE]["payurl"]);
		$jieqiTpl->assign("buyname", $_SESSION["jieqiUserName"]);
		$jieqiTpl->assign("egold", $_REQUEST["egold"]);
		$jieqiTpl->assign("egoldname", JIEQI_EGOLD_NAME);
		$jieqiTpl->assign("money", sprintf("%0.2f", $money / 100));
		$jieqiTpl->assign("merchant_id", $merchant_id);
		$jieqiTpl->assign("orderid", $orderid);
		$jieqiTpl->assign("paytype", $_REQUEST["paytype"]);
		$jieqiTpl->assign("amount", $amount);
		$jieqiTpl->assign("attach", $attach);
		$jieqiTpl->assign("currency", $currency);
		$jieqiTpl->assign("merchant_url", $merchant_url);
		$jieqiTpl->assign("notify_url", $jieqiPayset[JIEQI_PAY_TYPE]["paynotify"]);
		$jieqiTpl->assign("commodity_info", $commodity_info);
		$jieqiTpl->assign("pname", $pname);
		$jieqiTpl->assign("pemail", $pemail);
		$jieqiTpl->assign("merchant_param", $merchant_param);
		$jieqiTpl->assign("isSupportDES", $isSupportDES);
		$jieqiTpl->assign("pid_15173account", $pid_15173account);
		$jieqiTpl->assign("mac", $mac);

		if (is_array($jieqiPayset[JIEQI_PAY_TYPE]["addvars"])) {
			foreach ($jieqiPayset[JIEQI_PAY_TYPE]["addvars"] as $k => $v ) {
				$jieqiTpl->assign($k, $v);
			}
		}

		$jieqiTpl->setCaching(0);
		$jieqiTset["jieqi_contents_template"] = JIEQI_ROOT_PATH . "/modules/pay/templates/15173.html";
		include_once (JIEQI_ROOT_PATH . "/footer.php");
	}
}
else {
	jieqi_printfail($jieqiLang["pay"]["need_buy_type"]);
}

?>
