<?php

define("JIEQI_MODULE_NAME", "pay");
define("JIEQI_PAY_TYPE", "zhifuka");
require_once ("../../global.php");
jieqi_loadlang("pay", JIEQI_MODULE_NAME);
jieqi_loadlang("zhifuka", JIEQI_MODULE_NAME);

if (!jieqi_checklogin(true)) {
	jieqi_printfail($jieqiLang["pay"]["need_login"]);
}

jieqi_getconfigs(JIEQI_MODULE_NAME, JIEQI_PAY_TYPE, "jieqiPayset");
$_REQUEST["cardtype"] = trim($_REQUEST["cardtype"]);
$_REQUEST["cardnum"] = trim($_REQUEST["cardnum"]);
$_REQUEST["cardpass"] = trim($_REQUEST["cardpass"]);

if (empty($_REQUEST["cardtype"])) {
	jieqi_printfail($jieqiLang["pay"]["need_card_type"]);
}

if (empty($_REQUEST["cardnum"]) || empty($_REQUEST["cardpass"])) {
	jieqi_printfail($jieqiLang["pay"]["need_card_nopass"]);
}

$tmpary = explode("|", $_REQUEST["cardtype"]);

if (count($tmpary) < 3) {
	jieqi_printfail($jieqiLang["pay"]["need_card_type"]);
}

if (empty($_REQUEST["cardno"])) {
	$_REQUEST["cardno"] = trim($tmpary[0]);
}

if (empty($_REQUEST["faceno"])) {
	$_REQUEST["faceno"] = trim($tmpary[1]);
}

if (empty($_REQUEST["ordermoney"])) {
	$_REQUEST["ordermoney"] = trim($tmpary[2]);
}

$_REQUEST["ordermoney"] = floatval($_REQUEST["ordermoney"]);

if (!isset($jieqiPayset[JIEQI_PAY_TYPE]["cardegold"][$_REQUEST["cardno"]])) {
	jieqi_printfail($jieqiLang["pay"]["need_card_type"]);
}

if (isset($jieqiPayset[JIEQI_PAY_TYPE]["cardegold"][$_REQUEST["cardno"]][$_REQUEST["ordermoney"]])) {
	$_REQUEST["egold"] = $jieqiPayset[JIEQI_PAY_TYPE]["cardegold"][$_REQUEST["cardno"]][$_REQUEST["ordermoney"]];
}
else if (isset($jieqiPayset[JIEQI_PAY_TYPE]["cardegold"][$_REQUEST["cardno"]][1])) {
	$_REQUEST["egold"] = floor($_REQUEST["ordermoney"] * $jieqiPayset[JIEQI_PAY_TYPE]["cardegold"][$_REQUEST["cardno"]][1]);
}

if (isset($_REQUEST["egold"]) && is_numeric($_REQUEST["egold"]) && (0 < $_REQUEST["egold"])) {
	$_REQUEST["egold"] = intval($_REQUEST["egold"]);
	$money = intval($_REQUEST["ordermoney"] * 100);
	include_once (JIEQI_ROOT_PATH . "/modules/pay/class/paylog.php");
	$paylog_handler = JieqiPaylogHandler::getInstance("JieqiPaylogHandler");
	$paylog = $paylog_handler->create();
	$paylog->setVar("siteid", JIEQI_SITE_ID);
	$paylog->setVar("buytime", JIEQI_NOW_TIME);
	$paylog->setVar("rettime", 0);
	$paylog->setVar("buyid", $_SESSION["jieqiUserId"]);
	$paylog->setVar("buyname", $_SESSION["jieqiUserName"]);
	$paylog->setVar("buyinfo", "");
	$paylog->setVar("moneytype", $jieqiPayset[JIEQI_PAY_TYPE]["moneytype"]);
	$paylog->setVar("money", $money);
	$paylog->setVar("egoldtype", $jieqiPayset[JIEQI_PAY_TYPE]["paysilver"]);
	$paylog->setVar("egold", $_REQUEST["egold"]);
	$paylog->setVar("paytype", JIEQI_PAY_TYPE);
	$paylog->setVar("retserialno", "");
	$paylog->setVar("retaccount", "");
	$paylog->setVar("retinfo", "");
	$paylog->setVar("masterid", 0);
	$paylog->setVar("mastername", "");
	$paylog->setVar("masterinfo", "");
	$paylog->setVar("note", "");
	$paylog->setVar("payflag", 0);

	if (!$paylog_handler->insert($paylog)) {
		jieqi_printfail($jieqiLang["pay"]["add_paylog_error"]);
	}
	else {
		$params = array();
		$params["customerid"] = $jieqiPayset[JIEQI_PAY_TYPE]["payid"];
		$params["sdcustomno"] = $paylog->getVar("payid");
		$params["ordermoney"] = $_REQUEST["ordermoney"];
		$params["cardno"] = $_REQUEST["cardno"];
		$params["faceno"] = $_REQUEST["faceno"];
		$params["cardnum"] = $_REQUEST["cardnum"];
		$params["cardpass"] = $_REQUEST["cardpass"];
		$params["noticeurl"] = $jieqiPayset[JIEQI_PAY_TYPE]["payreturn"];
		$params["remarks"] = "";
		$params["mark"] = "";
		$params["sign"] = strtoupper(md5("customerid=" . $params["customerid"] . "&sdcustomno=" . $params["sdcustomno"] . "&noticeurl=" . $params["noticeurl"] . "&mark=" . $params["mark"] . "&key=" . $jieqiPayset[JIEQI_PAY_TYPE]["paykey"]));
		include_once (JIEQI_ROOT_PATH . "/lib/net/client.php");
		$client = new JieqiClient();
		$client->enableHistory(false);
		$client->post($jieqiPayset[JIEQI_PAY_TYPE]["payurl"], $params);
		$res = $client->currentResponse();
		if (($res["code"] == "200") && !empty($res["body"])) {
			$matches = array();
			preg_match("/<item\s+name=\"state\"\s+value=\"(\d+)\"\s*\/>/is", $res["body"], $matches);
			$state = 0;

			if (!empty($matches)) {
				$state = intval(trim($matches[1]));
			}

			if ($state == 1) {
				jieqi_msgwin(LANG_DO_SUCCESS, $jieqiLang["pay"]["zhifuka_post_success"]);
			}
			else {
				$error = $jieqiLang["pay"]["unknown_error_code"];
				$matches = array();
				preg_match("/<item\s+name=\"errmsg\"\s+value=\"([^<>\"']*)\"\s*\/>/is", $res["body"], $matches);

				if (!empty($matches)) {
					$error = jieqi_htmlstr($matches[1]);
				}

				jieqi_printfail(sprintf($jieqiLang["pay"]["zhifuka_post_error"], $error));
			}

			echo jieqi_htmlstr($res["body"]);
		}
		else {
			jieqi_printfail($jieqiLang["pay"]["zhifuka_post_faliure"]);
		}
	}
}
else {
	jieqi_printfail($jieqiLang["pay"]["need_buy_type"]);
}

?>
