<?php

define("JIEQI_MODULE_NAME", "article");
require_once ("../../../global.php");
jieqi_getconfigs(JIEQI_MODULE_NAME, "power");
jieqi_checkpower($jieqiPower["article"]["manageallreview"], $jieqiUsersStatus, $jieqiUsersGroup, false, true);
jieqi_getconfigs(JIEQI_MODULE_NAME, "configs");
jieqi_getconfigs("article", "action", "jieqiAction");
$article_static_url = (empty($jieqiConfigs["article"]["staticurl"]) ? $jieqiModules["article"]["url"] : $jieqiConfigs["article"]["staticurl"]);
$article_dynamic_url = (empty($jieqiConfigs["article"]["dynamicurl"]) ? $jieqiModules["article"]["url"] : $jieqiConfigs["article"]["dynamicurl"]);
include_once ($jieqiModules["article"]["path"] . "/class/reviews.php");
$reviews_handler = &JieqiReviewsHandler::getInstance("JieqiReviewsHandler");
$query = JieqiQueryHandler::getInstance("JieqiQueryHandler");
if (isset($_REQUEST["action"]) && !empty($_REQUEST["rid"])) {
	$actreview = $reviews_handler->get($_REQUEST["rid"]);

	if (is_object($actreview)) {
		$criteria = new CriteriaCompo(new Criteria("topicid", $_REQUEST["rid"]));

		switch ($_REQUEST["action"]) {
		case "top":
			$reviews_handler->updatefields(array("istop" => 1), $criteria);
			break;

		case "untop":
			$reviews_handler->updatefields(array("istop" => 0), $criteria);
			break;

		case "good":
			$reviews_handler->updatefields(array("isgood" => 1), $criteria);
			include_once (JIEQI_ROOT_PATH . "/class/users.php");
			$users_handler = &JieqiUsersHandler::getInstance("JieqiUsersHandler");

			if ($actreview->getVar("userid") == $_SESSION["jieqiUserId"]) {
				$users_handler->changeScore($_SESSION["jieqiUserId"], $jieqiAction["article"]["reviewgood"]["earnscore"], true);
			}
			else {
				$users_handler->changeScore($actreview->getVar("userid"), $jieqiAction["article"]["reviewgood"]["earnscore"], true);
			}

			break;

		case "normal":
			if ($actreview->getVar("isgood") == 1) {
				$reviews_handler->updatefields(array("isgood" => 0), $criteria);
				include_once (JIEQI_ROOT_PATH . "/class/users.php");
				$users_handler = &JieqiUsersHandler::getInstance("JieqiUsersHandler");

				if ($actreview->getVar("userid") == $_SESSION["jieqiUserId"]) {
					$users_handler->changeScore($_SESSION["jieqiUserId"], $jieqiAction["article"]["reviewgood"]["earnscore"], false);
				}
				else {
					$users_handler->changeScore($actreview->getVar("userid"), $jieqiAction["article"]["reviewgood"]["earnscore"], false);
				}
			}

			break;

		case "del":
			$reviews_handler->delete($criteria);
			$query->execute("DELETE FROM " . jieqi_dbprefix("article_replies") . " WHERE topicid=" . intval($_REQUEST["rid"]));
			break;
		}

		unset($criteria);
	}
}
else {
	if (isset($_REQUEST["batchdel"]) && ($_REQUEST["batchdel"] == 1) && is_array($_REQUEST["checkid"]) && (0 < count($_REQUEST["checkid"]))) {
		$where = "";

		foreach ($_REQUEST["checkid"] as $v ) {
			if (is_numeric($v)) {
				$v = intval($v);

				if (!empty($where)) {
					$where .= ", ";
				}

				$where .= $v;
			}
		}

		if (!empty($where)) {
			$sql = "DELETE FROM " . jieqi_dbprefix("article_reviews") . " WHERE topicid IN (" . $where . ")";
			$query->execute($sql);
			$sql = "DELETE FROM " . jieqi_dbprefix("article_replies") . " WHERE topicid IN (" . $where . ")";
			$query->execute($sql);
		}
	}
}

$jieqiTset["jieqi_contents_template"] = $jieqiModules["article"]["path"] . "/templates/admin/reviews.html";
include_once (JIEQI_ROOT_PATH . "/admin/header.php");
$jieqiPset = jieqi_get_pageset();
$jieqiTpl->assign("article_static_url", $article_static_url);
$jieqiTpl->assign("article_dynamic_url", $article_dynamic_url);
include_once (JIEQI_ROOT_PATH . "/lib/text/textfunction.php");
$jieqiTpl->assign("url_review", $article_dynamic_url . "/admin/reviews.php");
$jieqiTpl->assign("checkall", "<input type=\"checkbox\" id=\"checkall\" name=\"checkall\" value=\"checkall\" onclick=\"javascript: for (var i=0;i<this.form.elements.length;i++){ if (this.form.elements[i].name != 'checkkall') this.form.elements[i].checked = form.checkall.checked; }\">");
$criteria = new CriteriaCompo();
$criteria->setFields("r.*,a.articlename");
$criteria->setTables(jieqi_dbprefix("article_reviews") . " AS r LEFT JOIN " . jieqi_dbprefix("article_article") . " AS a ON r.ownerid=a.articleid");

if (!empty($_REQUEST["keyword"])) {
	$_REQUEST["keyword"] = trim($_REQUEST["keyword"]);

	if ($_REQUEST["keytype"] == 1) {
		$criteria->add(new Criteria("r.poster", $_REQUEST["keyword"], "="));
	}
	else {
		$criteria->add(new Criteria("a.articlename", $_REQUEST["keyword"], "="));
	}
}

if (isset($_REQUEST["type"]) && ($_REQUEST["type"] == "good")) {
	$criteria->add(new Criteria("isgood", 1));
}
else {
	$_REQUEST["type"] = "all";
}

$criteria->setSort("topicid");
$criteria->setOrder("DESC");
$criteria->setLimit($jieqiPset["rows"]);
$criteria->setStart($jieqiPset["start"]);
$query->queryObjects($criteria);
$reviewrows = array();
$k = 0;

while ($v = $query->getObject()) {
	$start = 3;

	if ($v->getVar("istop") == 1) {
		$reviewrows[$k]["istop"] = 1;
		$start += 4;
	}
	else {
		$reviewrows[$k]["istop"] = 0;
	}

	if ($v->getVar("isgood") == 1) {
		$reviewrows[$k]["isgood"] = 1;
		$start += 4;
	}
	else {
		$reviewrows[$k]["isgood"] = 0;
	}

	$reviewrows[$k]["topicid"] = $v->getVar("topicid");
	$reviewrows[$k]["posttime"] = $v->getVar("posttime");
	$reviewrows[$k]["posterid"] = $v->getVar("posterid");
	$reviewrows[$k]["poster"] = $v->getVar("poster");
	$reviewrows[$k]["title"] = $v->getVar("title");
	$reviewrows[$k]["views"] = $v->getVar("views");
	$reviewrows[$k]["replies"] = $v->getVar("replies");
	$reviewrows[$k]["url_top"] = jieqi_addurlvars(array("action" => "top", "rid" => $v->getVar("topicid")));
	$reviewrows[$k]["url_untop"] = jieqi_addurlvars(array("action" => "untop", "rid" => $v->getVar("topicid")));
	$reviewrows[$k]["url_good"] = jieqi_addurlvars(array("action" => "good", "rid" => $v->getVar("topicid")));
	$reviewrows[$k]["url_normal"] = jieqi_addurlvars(array("action" => "normal", "rid" => $v->getVar("topicid")));
	$reviewrows[$k]["url_delete"] = jieqi_addurlvars(array("action" => "del", "rid" => $v->getVar("topicid")));
	$reviewrows[$k]["checkbox"] = "<input type=\"checkbox\" id=\"checkid[]\" name=\"checkid[]\" value=\"" . $v->getVar("topicid") . "\">";
	$reviewrows[$k]["ownerid"] = $v->getVar("ownerid");
	$reviewrows[$k]["articlename"] = $v->getVar("articlename");
	$reviewrows[$k]["url_articleinfo"] = jieqi_geturl("article", "article", $v->getVar("ownerid"), "info");
	$k++;
}

$jieqiTpl->assign_by_ref("reviewrows", $reviewrows);
include_once (JIEQI_ROOT_PATH . "/lib/html/page.php");
$jieqiPset["count"] = $query->getCount($criteria);
$jumppage = new JieqiPage($jieqiPset);
$jumppage->setlink("", true, true);
$jieqiTpl->assign("url_jumppage", $jumppage->whole_bar());
$jieqiTpl->setCaching(0);
include_once (JIEQI_ROOT_PATH . "/admin/footer.php");

?>
