<?php

class BlockArticleRich extends JieqiBlock
{
	public $module = "article";
	public $template = "block_rich.html";
	public $exevars = array("field" => "day", "listnum" => 10, "asc" => 0, "actname" => "");

	public function BlockArticleRich(&$vars)
	{
		global $jieqiTpl;
		global $jieqiTop;
		$this->JieqiBlock($vars);

		if (!empty($this->blockvars["vars"])) {
			$varary = explode(",", trim($this->blockvars["vars"]));
			$arynum = count($varary);

			if (0 < $arynum) {
				$varary[0] = trim($varary[0]);

				if (in_array($varary[0], array("day", "week", "month", "all"))) {
					$this->exevars["field"] = $varary[0];
				}
			}

			if (1 < $arynum) {
				$varary[1] = trim($varary[1]);

				if (is_numeric($varary[1])) {
					$this->exevars["listnum"] = intval($varary[1]);
				}
			}

			if (2 < $arynum) {
				$varary[2] = trim($varary[2]);

				if (in_array($varary[2], array("0", "1"))) {
					$this->exevars["asc"] = $varary[2];
				}
			}

			if (3 < $arynum) {
				$varary[3] = trim($varary[3]);

				if (0 < strlen($varary[3])) {
					$this->exevars["actname"] = $varary[3];
				}
			}
		}

		if ($this->exevars["articleid"] == 0) {
			$this->blockvars["cacheid"] = md5(serialize($this->exevars) . "|" . $this->blockvars["template"]);
		}
		else {
			$this->cachetime = -1;
			$this->blockvars["cachetime"] = -1;
		}
	}

	public function setContent($isreturn = false)
	{
		global $jieqiTpl;
		global $jieqiModules;
		global $jieqiConfigs;
		global $jieqiActlog;
		global $query;

		if (!is_a($query, "JieqiQueryHandler")) {
			jieqi_includedb();
			$query = JieqiQueryHandler::getInstance("JieqiQueryHandler");
		}

		if (!isset($jieqiConfigs["article"])) {
			jieqi_getconfigs("article", "configs", "jieqiConfigs");
		}

		if (!isset($jieqiActlog["article"])) {
			jieqi_getconfigs("article", "actlog", "jieqiActlog");
		}

		$article_static_url = (empty($jieqiConfigs["article"]["staticurl"]) ? $GLOBALS["jieqiModules"]["article"]["url"] : $jieqiConfigs["article"]["staticurl"]);
		$article_dynamic_url = (empty($jieqiConfigs["article"]["dynamicurl"]) ? $GLOBALS["jieqiModules"]["article"]["url"] : $jieqiConfigs["article"]["dynamicurl"]);
		$jieqiTpl->assign("article_static_url", $article_static_url);
		$jieqiTpl->assign("article_dynamic_url", $article_dynamic_url);
		$richrows = array();

		if ($this->exevars["field"] == "day") {
			$start = mktime(0, 0, 0, date("m"), date("d"), date("Y"));
			$end = mktime(0, 0, 0, date("m"), date("d") + 1, date("Y")) - 1;
			$slimit = "o.addtime >= $start and  o.addtime <= $end";
		}
		else if ($this->exevars["field"] == "week") {
			$w = date("w", JIEQI_NOW_TIME);
			$start = strtotime(date("Y-m-d", JIEQI_NOW_TIME) . " -" . ($w ? $w - 1 : 6) . " days");
			$end = strtotime(date("Y-m-d", $start) . " +6 days");
			$slimit = "o.addtime >= $start and  o.addtime <= $end";
		}
		else if ($this->exevars["field"] == "month") {
			$start = mktime(0, 0, 0, date("m"), 1, date("Y"));
			$end = mktime(23, 59, 59, date("m"), date("t"), date("Y"));
			$slimit = "o.addtime >= $start and  o.addtime <= $end";
		}
		else {
			$slimit = " o.addtime != '0' ";
		}

		if ($this->exevars["asc"] == 0) {
			$order = "DESC";
		}
		else {
			$order = "ASC";
		}

		if (0 < strlen($this->exevars["actname"])) {
			$type = " AND o.actname = '" . jieqi_dbslashes($this->exevars["actname"]) . "'";
		}

		$limitstart = 0;
		$listpnum = intval($this->exevars["listnum"]);
		$sql = "SELECT *,sum(egold) as egoldnum FROM " . jieqi_dbprefix("article_actlog") . " o LEFT JOIN " . jieqi_dbprefix("article_article") . " a ON o.articleid = a.articleid WHERE $slimit $type GROUP BY uid ORDER BY sum(egold) $order LIMIT $limitstart,$listpnum";
		$richrows = array();
		$query->execute($sql);
		$k = 0;

		while ($row = $query->getRow()) {
			$richrows[$k] = jieqi_article_vars($row);
			$k++;
		}

		$jieqiTpl->assign_by_ref("richrows", $richrows);
	}
}


?>
