<?php

class BlockArticleUbookcase extends JieqiBlock
{
	public $module = "article";
	public $template = "block_ubookcase.html";
	public $exevars = array("field" => "lastupdate", "listnum" => 10, "asc" => 0, "uid" => "uid", "flag" => 0);

	public function BlockArticleUbookcase(&$vars)
	{
		$this->JieqiBlock($vars);

		if (!empty($this->blockvars["vars"])) {
			$varary = explode(",", trim($this->blockvars["vars"]));
			$arynum = count($varary);

			if (0 < $arynum) {
				$varary[0] = trim($varary[0]);

				if (in_array($varary[0], array("articleid", "lastupdate", "caseid", "joindate", "lastvisit"))) {
					$this->exevars["field"] = $varary[0];
				}
			}

			if (1 < $arynum) {
				$varary[1] = trim($varary[1]);
				if (is_numeric($varary[1]) && (0 < $varary[1])) {
					$this->exevars["listnum"] = intval($varary[1]);
				}
			}

			if (2 < $arynum) {
				$varary[2] = trim($varary[2]);

				if (in_array($varary[2], array("0", "1"))) {
					$this->exevars["asc"] = $varary[2];
				}
			}

			if (3 < $arynum) {
				$varary[3] = trim($varary[3]);

				if (0 < strlen($varary[3])) {
					$this->exevars["uid"] = $varary[3];
				}
			}

			if (4 < $arynum) {
				$varary[4] = trim($varary[4]);

				if (in_array($varary[4], array("0", "1", "2"))) {
					$this->exevars["flag"] = $varary[4];
				}
			}
		}

		$this->getCacheid();
	}

	public function setContent($isreturn = false)
	{
		global $jieqiTpl;
		global $jieqiConfigs;
		jieqi_getconfigs("article", "configs");
		jieqi_getconfigs("article", "sort");
		$article_static_url = (empty($jieqiConfigs["article"]["staticurl"]) ? $GLOBALS["jieqiModules"]["article"]["url"] : $jieqiConfigs["article"]["staticurl"]);
		$article_dynamic_url = (empty($jieqiConfigs["article"]["dynamicurl"]) ? $GLOBALS["jieqiModules"]["article"]["url"] : $jieqiConfigs["article"]["dynamicurl"]);
		$jieqiTpl->assign("article_static_url", $article_static_url);
		$jieqiTpl->assign("article_dynamic_url", $article_dynamic_url);
		$bookcaserows = array();

		if (0 < $this->blockvars["cacheid"]) {
			jieqi_includedb();
			$bookcase_query = JieqiQueryHandler::getInstance("JieqiQueryHandler");
			$criteria = new CriteriaCompo();
			$criteria->add(new Criteria("c.userid", $this->blockvars["cacheid"]));

			if ($this->exevars["flag"] == 1) {
				$criteria->add(new Criteria("flag", 1));
			}
			else if ($this->exevars["flag"] == 2) {
				$criteria->add(new Criteria("flag", 0));
			}

			$criteria->setTables(jieqi_dbprefix("article_bookcase") . " c LEFT JOIN " . jieqi_dbprefix("article_article") . " a ON c.articleid=a.articleid");
			$criteria->setFields("c.*, a.imgflag, a.articleid, a.lastupdate, a.articlename, a.authorid, a.author, a.sortid, a.typeid, a.lastchapterid, a.lastchapter");
			$tmpary = array("articleid" => "a.articleid", "lastupdate" => "a.lastupdate", "caseid" => "c.caseid", "joindate" => "c.joindate", "lastvisit" => "c.lastvisit");
			$criteria->setSort($tmpary[$this->exevars["field"]]);

			if ($this->exevars["asc"] == 1) {
				$criteria->setOrder("ASC");
			}
			else {
				$criteria->setOrder("DESC");
			}

			$criteria->setLimit($this->exevars["listnum"]);
			$criteria->setStart(0);
			$bookcase_query->queryObjects($criteria);
			unset($criteria);
			$k = 0;

			while ($v = $bookcase_query->getObject()) {
				$bookcaserows[$k]["caseid"] = $v->getVar("caseid");
				$bookcaserows[$k]["articleid"] = $v->getVar("articleid");
				$bookcaserows[$k]["lastchapterid"] = $v->getVar("lastchapterid");
				$bookcaserows[$k]["chapterid"] = $v->getVar("chapterid");
				$bookcaserows[$k]["sortid"] = $v->getVar("sortid");
				$bookcaserows[$k]["typeid"] = $v->getVar("typeid");
				$bookcaserows[$k]["sort"] = $jieqiSort["article"][$v->getVar("sortid")]["caption"];
				$bookcaserows[$k]["sortname"] = $jieqiSort["article"][$v->getVar("sortid")]["caption"];
				$bookcaserows[$k]["type"] = $jieqiSort["article"][$v->getVar("sortid")]["types"][$v->getVar("typeid")];
				$bookcaserows[$k]["authorid"] = $v->getVar("authorid");
				$bookcaserows[$k]["author"] = $v->getVar("author");
				$bookcaserows[$k]["url_image"] = jieqi_geturl("article", "cover", $v->getvar("articleid"), "s", $v->getvar("imgflag"));
				$bookcaserows[$k]["url_simage"] = jieqi_geturl("article", "cover", $v->getvar("articleid"), "s", $v->getvar("imgflag"));
				$bookcaserows[$k]["url_limage"] = jieqi_geturl("article", "cover", $v->getvar("articleid"), "l", $v->getvar("imgflag"));
				$bookcaserows[$k]["checkbox"] = "<input type=\"checkbox\" id=\"checkid[]\" name=\"checkid[]\" value=\"" . $v->getVar("caseid") . "\">";
				$tmpvar = $v->getVar("articlename");

				if (!empty($tmpvar)) {
					$bookcaserows[$k]["url_articleinfo"] = $article_dynamic_url . "/readbookcase.php?aid=" . $v->getVar("articleid") . "&bid=" . $v->getVar("caseid");
					$bookcaserows[$k]["url_index"] = $bookcaserows[$k]["url_articleinfo"] . "&indexflag=1";
					$bookcaserows[$k]["articlename"] = $v->getVar("articlename");
				}
				else {
					$bookcaserows[$k]["url_articleinfo"] = "#";
					$bookcaserows[$k]["url_index"] = "#";
					$bookcaserows[$k]["articlename"] = $jieqiLang["article"]["articlemark_has_deleted"];
				}

				if ($v->getVar("lastchapter") == "") {
					$bookcaserows[$k]["lastchapter"] = "";
					$bookcaserows[$k]["url_lastchapter"] = "#";
				}
				else {
					$bookcaserows[$k]["lastchapter"] = $v->getVar("lastchapter");
					$bookcaserows[$k]["url_lastchapter"] = $article_dynamic_url . "/readbookcase.php?aid=" . $v->getVar("articleid") . "&bid=" . $v->getVar("caseid") . "&cid=" . $v->getVar("lastchapterid");
				}

				if ($v->getVar("lastvisit") < $v->getVar("lastupdate")) {
					$bookcaserows[$k]["hasnew"] = 1;
				}
				else {
					$bookcaserows[$k]["hasnew"] = 0;
				}

				if ($v->getVar("chaptername") == "") {
					$bookcaserows[$k]["articlemark"] = "";
					$bookcaserows[$k]["url_articlemark"] = "#";
				}
				else {
					$bookcaserows[$k]["articlemark"] = $v->getVar("chaptername");

					if (0 < intval($v->getVar("flag", "n"))) {
						$bookcaserows[$k]["url_articlemark"] = $article_dynamic_url . "/readbookcase.php?oid=" . $v->getVar("vipid") . "&bid=" . $v->getVar("caseid") . "&ocid=" . $v->getVar("chapterid");
					}
					else {
						$bookcaserows[$k]["url_articlemark"] = $article_dynamic_url . "/readbookcase.php?aid=" . $v->getVar("articleid") . "&bid=" . $v->getVar("caseid") . "&cid=" . $v->getVar("chapterid");
					}
				}

				$bookcaserows[$k]["lastupdate"] = $v->getVar("lastupdate");
				$bookcaserows[$k]["url_delete"] = jieqi_addurlvars(array("delid" => $v->getVar("caseid")));
				$k++;
			}
		}

		$jieqiTpl->assign_by_ref("bookcaserows", $bookcaserows);
		$jieqiTpl->assign("ownerid", $this->blockvars["cacheid"]);
	}

	public function getCacheid()
	{
		global $jieqiTpl;
		$this->blockvars["cacheid"] = 0;

		if (strval($this->exevars["uid"]) != "0") {
			if ($this->exevars["uid"] == "self") {
				$this->blockvars["cacheid"] = intval($_SESSION["jieqiUserId"]);
			}
			else if (is_numeric($this->exevars["uid"])) {
				$this->blockvars["cacheid"] = intval($this->exevars["uid"]);
			}
			else if (substr($this->exevars["uid"], 0, 1) == "\$") {
				$this->blockvars["cacheid"] = intval($jieqiTpl->get_assign(substr($this->exevars["uid"], 1)));
			}
			else {
				$this->blockvars["cacheid"] = intval($_REQUEST[$this->exevars["uid"]]);
			}
		}

		return $this->blockvars["cacheid"];
	}
}


?>
