<?php

define("JIEQI_MODULE_NAME", "pay");
define("JIEQI_PAY_TYPE", "99bill");
require_once ("../../global.php");
jieqi_loadlang("pay", JIEQI_MODULE_NAME);
jieqi_getconfigs(JIEQI_MODULE_NAME, JIEQI_PAY_TYPE, "jieqiPayset");
$showCode = (isset($_REQUEST["showCode"]) ? intval($_REQUEST["showCode"]) : 0);

if ($showCode != 0) {
	switch ($showCode) {
	case 1:
		include_once ($jieqiModules["pay"]["path"] . "/class/paylog.php");
		$paylog_handler = JieqiPaylogHandler::getInstance("JieqiPaylogHandler");
		$orderid = intval($_REQUEST["showOid"]);
		$paylog = $paylog_handler->get($orderid);

		if (is_object($paylog)) {
			$buyname = $paylog->getVar("buyname");
			$buyid = $paylog->getVar("buyid");
			$payflag = $paylog->getVar("payflag");
			$egold = $paylog->getVar("egold");
			jieqi_msgwin(LANG_DO_SUCCESS, sprintf($jieqiLang["pay"]["buy_egold_success"], $buyname, JIEQI_EGOLD_NAME, $egold));
		}
		else {
			jieqi_printfail($jieqiLang["pay"]["pay_return_error"]);
		}

		break;

	case -1:
		jieqi_printfail($jieqiLang["pay"]["customer_id_error"]);
		break;

	case -2:
		jieqi_printfail($jieqiLang["pay"]["pay_return_error"]);
		break;

	case -3:
		jieqi_printfail($jieqiLang["pay"]["save_paylog_failure"]);
		break;

	case -4:
		jieqi_printfail($jieqiLang["pay"]["no_buy_record"]);
		break;

	default:
		jieqi_printfail($jieqiLang["pay"]["pay_return_error"]);
		break;
	}

	exit();
}

$parmary = array();
$parmary["merchantAcctId"] = trim($_REQUEST["merchantAcctId"]);
$parmary["version"] = trim($_REQUEST["version"]);
$parmary["language"] = trim($_REQUEST["language"]);
$parmary["signType"] = trim($_REQUEST["signType"]);
$parmary["payType"] = trim($_REQUEST["payType"]);
$parmary["bankId"] = trim($_REQUEST["bankId"]);
$parmary["orderId"] = trim($_REQUEST["orderId"]);
$parmary["orderTime"] = trim($_REQUEST["orderTime"]);
$parmary["orderAmount"] = trim($_REQUEST["orderAmount"]);
$parmary["dealId"] = trim($_REQUEST["dealId"]);
$parmary["bankDealId"] = trim($_REQUEST["bankDealId"]);
$parmary["dealTime"] = trim($_REQUEST["dealTime"]);
$parmary["payAmount"] = trim($_REQUEST["payAmount"]);
$parmary["fee"] = trim($_REQUEST["fee"]);
$parmary["ext1"] = trim($_REQUEST["ext1"]);
$parmary["ext2"] = trim($_REQUEST["ext2"]);
$parmary["payResult"] = trim($_REQUEST["payResult"]);
$parmary["errCode"] = trim($_REQUEST["errCode"]);
$signMsg = trim($_REQUEST["signMsg"]);
$txtmac = "";

foreach ($parmary as $k => $v ) {
	if ($v != "") {
		if ($txtmac != "") {
			$txtmac .= "&";
		}

		$txtmac .= $k . "=" . $v;
	}
}

if ($txtmac != "") {
	$txtmac .= "&";
}

$txtmac .= "key=" . $jieqiPayset[JIEQI_PAY_TYPE]["paykey"];
$mysignMsg = strtoupper(md5($txtmac));

if ($jieqiPayset[JIEQI_PAY_TYPE]["payid"] != $parmary["merchantAcctId"]) {
	if ($showCode == 0) {
		exit("<result>0</result><redirecturl>" . $jieqiPayset[JIEQI_PAY_TYPE]["payreturn"] . "?showCode=-1</redirecturl>");
	}
	else {
		jieqi_printfail($jieqiLang["pay"]["customer_id_error"]);
	}
}
else if ($parmary["payResult"] != "10") {
	if ($showCode == 0) {
		exit("<result>0</result><redirecturl>" . $jieqiPayset[JIEQI_PAY_TYPE]["payreturn"] . "?showCode=-2</redirecturl>");
	}
	else {
		jieqi_printfail($jieqiLang["pay"]["pay_return_error"]);
	}
}
else if (strtoupper($signMsg) == strtoupper($mysignMsg)) {
	include_once ($jieqiModules["pay"]["path"] . "/class/paylog.php");
	$paylog_handler = JieqiPaylogHandler::getInstance("JieqiPaylogHandler");
	$orderid = intval($parmary["orderId"]);
	$paylog = $paylog_handler->get($orderid);

	if (is_object($paylog)) {
		$buyname = $paylog->getVar("buyname");
		$buyid = $paylog->getVar("buyid");
		$payflag = $paylog->getVar("payflag");
		$egold = $paylog->getVar("egold");
		$money = $paylog->getVar("money");

		if ($payflag == 0) {
			include_once (JIEQI_ROOT_PATH . "/class/users.php");
			$users_handler = &JieqiUsersHandler::getInstance("JieqiUsersHandler");
			$paysilver = (empty($jieqiPayset[JIEQI_PAY_TYPE]["paysilver"]) ? 0 : intval($jieqiPayset[JIEQI_PAY_TYPE]["paysilver"]));
			$payscore = (empty($jieqiPayset[JIEQI_PAY_TYPE]["payrate"]) ? 0 : floor(($money * $jieqiPayset[JIEQI_PAY_TYPE]["payrate"]) / 100));
			$ret = $users_handler->income($buyid, $egold, $paysilver, $payscore);

			if ($ret) {
				$note = sprintf($jieqiLang["pay"]["add_egold_success"], $buyname, JIEQI_EGOLD_NAME, $egold);
			}
			else {
				$note = sprintf($jieqiLang["pay"]["add_egold_failure"], $buyid, $buyname, JIEQI_EGOLD_NAME, $egold);
			}

			$paylog->setVar("rettime", JIEQI_NOW_TIME);
			$paylog->setVar("retserialno", $parmary["dealId"]);
			$paylog->setVar("retaccount", $parmary["bankDealId"]);
			$paylog->setVar("retinfo", "");
			$paylog->setVar("note", $note);
			$paylog->setVar("payflag", 1);

			if (!$paylog_handler->insert($paylog)) {
				if ($showCode == 0) {
					exit("<result>0</result><redirecturl>" . $jieqiPayset[JIEQI_PAY_TYPE]["payreturn"] . "?showCode=-3</redirecturl>");
				}
				else {
					jieqi_printfail($jieqiLang["pay"]["save_paylog_failure"]);
				}
			}
			else if ($showCode == 0) {
				exit("<result>1</result><redirecturl>" . $jieqiPayset[JIEQI_PAY_TYPE]["payreturn"] . "?showCode=1&showOid=" . $orderid . "</redirecturl>");
			}
			else {
				jieqi_msgwin(LANG_DO_SUCCESS, sprintf($jieqiLang["pay"]["buy_egold_success"], $buyname, JIEQI_EGOLD_NAME, $egold));
			}
		}
		else if ($showCode == 0) {
			exit("<result>1</result><redirecturl>" . $jieqiPayset[JIEQI_PAY_TYPE]["payreturn"] . "?showCode=1&showOid=" . $orderid . "</redirecturl>");
		}
		else {
			jieqi_msgwin(LANG_DO_SUCCESS, sprintf($jieqiLang["pay"]["buy_egold_success"], $buyname, JIEQI_EGOLD_NAME, $egold));
		}
	}
	else if ($showCode == 0) {
		exit("<result>0</result><redirecturl>" . $jieqiPayset[JIEQI_PAY_TYPE]["payreturn"] . "?showCode=-4</redirecturl>");
	}
	else {
		jieqi_printfail($jieqiLang["pay"]["no_buy_record"]);
	}
}

?>
