<?php

define("JIEQI_MODULE_NAME", "pay");
require_once ("../../../global.php");
jieqi_getconfigs("pay", "power");
jieqi_checkpower($jieqiPower["pay"]["adminpaylog"], $jieqiUsersStatus, $jieqiUsersGroup, false, true);
jieqi_loadlang("pay", JIEQI_MODULE_NAME);
include_once ($jieqiModules["pay"]["path"] . "/class/paylog.php");
$paylog_handler = JieqiPaylogHandler::getInstance("JieqiPaylogHandler");
if (!empty($_POST["act"]) && !empty($_REQUEST["id"])) {
	jieqi_checkpost();

	switch ($_POST["act"]) {
	case "confirm":
		$tmplog = $paylog_handler->get($_REQUEST["id"]);
		if (is_object($tmplog) && ($tmplog->getVar("payflag") == 0)) {
			$buyid = $tmplog->getVar("buyid");
			$buyname = $tmplog->getVar("buyname");
			$egoldtype = $tmplog->getVar("egoldtype");
			$egold = $tmplog->getVar("egold");
			include_once (JIEQI_ROOT_PATH . "/class/users.php");
			$users_handler = &JieqiUsersHandler::getInstance("JieqiUsersHandler");
			$ret = $users_handler->income($buyid, $egold, $egoldtype);

			if ($ret) {
				$note = sprintf($jieqiLang["pay"]["add_egold_success"], $buyname, JIEQI_EGOLD_NAME, $egold);
			}
			else {
				$note = sprintf($jieqiLang["pay"]["add_egold_failure"], $buyid, $buyname, JIEQI_EGOLD_NAME, $egold);
			}

			$tmplog->setVar("rettime", JIEQI_NOW_TIME);
			$tmplog->setVar("note", $note);

			if (!empty($_SESSION["jieqiUserId"])) {
				$tmplog->setVar("masterid", $_SESSION["jieqiUserId"]);
				$tmplog->setVar("mastername", $_SESSION["jieqiUserName"]);
			}

			$tmplog->setVar("payflag", 2);
			$paylog_handler->insert($tmplog);
		}

		jieqi_jumppage($jieqiModules["pay"]["url"] . "/admin/paylog.php", "", "", true);
		break;

	case "del":
		$criteria = new CriteriaCompo(new Criteria("payid", $_REQUEST["id"], "="));
		$criteria->add(new Criteria("payflag", 0));
		$paylog_handler->delete($criteria);
		unset($criteria);
		jieqi_jumppage($jieqiModules["pay"]["url"] . "/admin/paylog.php", "", "", true);
		break;
	}
}

jieqi_getconfigs(JIEQI_MODULE_NAME, "configs");
$jieqiTset["jieqi_contents_template"] = $jieqiModules["pay"]["path"] . "/templates/admin/paylog.html";
include_once (JIEQI_ROOT_PATH . "/admin/header.php");
$jieqiPset = jieqi_get_pageset();
$criteria = new CriteriaCompo();

if (!empty($_REQUEST["keyword"])) {
	switch ($_REQUEST["keytype"]) {
	case "payid":
		$criteria->add(new Criteria("payid", intval($_REQUEST["keyword"]), "="));
		break;

	case "payflag":
		switch ($_REQUEST["keyword"]) {
		case $jieqiLang["pay"]["state_unconfirm"]:
			$payflag = 0;
			break;

		case :
			$payflag = 1;
			break;

		case :
			$payflag = 2;
			break;

		default:
			$payflag = -1;
			break;
		}

		if (0 <= $payflag) {
			$criteria->add(new Criteria("payflag", $payflag, "="));
		}

		break;

	case "buyname":
	default:
		$criteria->add(new Criteria("buyname", $_REQUEST["keyword"], "="));
		break;
	}
}

switch ($_REQUEST["payflag"]) {
case "success":
	$criteria->add(new Criteria("payflag", 0, ">"));
	break;

case "failure":
	$criteria->add(new Criteria("payflag", 0, "="));
	break;
}

if (!empty($_REQUEST["datestart"])) {
	$tmpvar = @strtotime($_REQUEST["datestart"]);

	if (0 < $tmpvar) {
		$criteria->add(new Criteria("buytime", $tmpvar, ">="));
	}
}

if (!empty($_REQUEST["dateend"])) {
	$tmpvar = @strtotime($_REQUEST["dateend"]);

	if (0 < $tmpvar) {
		$criteria->add(new Criteria("buytime", $tmpvar, "<="));
	}
}

$criteria->setSort("payid");
$criteria->setOrder("DESC");
$criteria->setLimit($jieqiPset["rows"]);
$criteria->setStart($jieqiPset["start"]);
$paylog_handler->queryObjects($criteria);
$paylogrows = array();
$k = 0;
jieqi_getconfigs(JIEQI_MODULE_NAME, "paytype");

while ($v = $paylog_handler->getObject()) {
	$paylogrows[$k] = jieqi_query_rowvars($v);

	if (isset($jieqiPaytype[$v->getVar("paytype", "n")])) {
		$paylogrows[$k]["paytype"] = $jieqiPaytype[$v->getVar("paytype", "n")]["shortname"];
	}

	$k++;
}

$jieqiTpl->assign_by_ref("paylogrows", $paylogrows);
$jieqiTpl->assign("_request", jieqi_funtoarray("jieqi_htmlstr", $_REQUEST));
$query = JieqiQueryHandler::getInstance("JieqiQueryHandler");
$sql = "SELECT count(*) as cot, sum(egold) as sumegold, sum(money) as summoney FROM " . jieqi_dbprefix("pay_paylog") . " " . $criteria->renderWhere();
$query->execute($sql);
$paylogstat = $query->getRow();
$paylogstat = jieqi_funtoarray("jieqi_htmlstr", $paylogstat);
$jieqiTpl->assign_by_ref("paylogstat", $paylogstat);
include_once (JIEQI_ROOT_PATH . "/lib/html/page.php");
$jieqiPset["count"] = $paylog_handler->getCount($criteria);
$jumppage = new JieqiPage($jieqiPset);
$jumppage->setlink("", true, true);
$jieqiTpl->assign("url_jumppage", $jumppage->whole_bar());
$jieqiTpl->setCaching(0);
include_once (JIEQI_ROOT_PATH . "/admin/footer.php");

?>
