<?php

define("JIEQI_MODULE_NAME", "pay");
define("JIEQI_PAY_TYPE", "alipay");
require_once ("../../global.php");
jieqi_loadlang("pay", JIEQI_MODULE_NAME);
jieqi_getconfigs(JIEQI_MODULE_NAME, JIEQI_PAY_TYPE, "jieqiPayset");
$logflag = (defined("JIEQI_DEBUG_MODE") && (0 < JIEQI_DEBUG_MODE) ? 1 : 0);

if ($logflag) {
	$logfile = JIEQI_ROOT_PATH . "/files/pay/log/" . JIEQI_PAY_TYPE . "_return.txt";
	jieqi_checkdir(dirname($logfile), true);
	$log = print_r($_REQUEST, true);
	jieqi_writefile($logfile, $log, "ab");
}

$mymerchant_id = $jieqiPayset[JIEQI_PAY_TYPE]["payid"];
$key = $jieqiPayset[JIEQI_PAY_TYPE]["paykey"];
if (!empty($_GET["notify_id"]) && !empty($_GET["buyer_email"]) && !empty($_GET["out_trade_no"])) {
	$getvars = $_GET;
	$showmode = 1;
}
else {
	if (!empty($_POST["notify_id"]) && !empty($_POST["buyer_email"]) && !empty($_POST["out_trade_no"])) {
		$getvars = $_POST;
		$showmode = 0;
		echo "success";
	}
	else {
		echo "fail";
		exit();
	}
}

if ((strtoupper($getvars["trade_status"]) != "TRADE_FINISHED") && (strtoupper($getvars["trade_status"]) != "TRADE_SUCCESS")) {
	if ($showmode) {
		jieqi_printfail($jieqiLang["pay"]["pay_return_error"] . "<br /><br />RETCODE:" . $getvars["trade_status"]);
	}
	else {
		exit();
	}
}

ksort($getvars);
reset($getvars);
$signtext = "";
$signdecode = "";

foreach ($getvars as $k => $v ) {
	if (($k != "sign") && ($k != "sign_type")) {
		if (!empty($signtext)) {
			$signtext .= "&";
			$signdecode .= "&";
		}

		$signtext .= $k . "=" . $v;
		$signdecode .= $k . "=" . urldecode($v);
	}
}

if ((strtolower($getvars["sign"]) == strtolower(md5($signtext . $jieqiPayset[JIEQI_PAY_TYPE]["paykey"]))) || (strtolower($getvars["sign"]) == strtolower(md5($signdecode . $jieqiPayset[JIEQI_PAY_TYPE]["paykey"])))) {
	include_once ($jieqiModules["pay"]["path"] . "/class/paylog.php");
	$paylog_handler = JieqiPaylogHandler::getInstance("JieqiPaylogHandler");
	$orderid = intval($getvars["out_trade_no"]);
	$paylog = $paylog_handler->get($orderid);

	if (is_object($paylog)) {
		$buyname = $paylog->getVar("buyname");
		$buyid = $paylog->getVar("buyid");
		$payflag = $paylog->getVar("payflag");
		$egold = $paylog->getVar("egold");
		$money = $paylog->getVar("money");

		if ($payflag == 0) {
			include_once (JIEQI_ROOT_PATH . "/class/users.php");
			$users_handler = &JieqiUsersHandler::getInstance("JieqiUsersHandler");
			$paysilver = (empty($jieqiPayset[JIEQI_PAY_TYPE]["paysilver"]) ? 0 : intval($jieqiPayset[JIEQI_PAY_TYPE]["paysilver"]));
			$payscore = (empty($jieqiPayset[JIEQI_PAY_TYPE]["payrate"]) ? 0 : floor(($money * $jieqiPayset[JIEQI_PAY_TYPE]["payrate"]) / 100));
			$ret = $users_handler->income($buyid, $egold, $paysilver, $payscore);

			if ($ret) {
				$note = sprintf($jieqiLang["pay"]["add_egold_success"], $buyname, JIEQI_EGOLD_NAME, $egold);
			}
			else {
				$note = sprintf($jieqiLang["pay"]["add_egold_failure"], $buyid, $buyname, JIEQI_EGOLD_NAME, $egold);
			}

			$paylog->setVar("rettime", JIEQI_NOW_TIME);
			$paylog->setVar("retserialno", $getvars["trade_no"]);
			$paylog->setVar("retaccount", $getvars["buyer_email"]);
			$paylog->setVar("retinfo", $getvars["buyer_id"]);
			$paylog->setVar("note", $note);
			$paylog->setVar("payflag", 1);

			if (!$paylog_handler->insert($paylog)) {
				if ($showmode) {
					jieqi_printfail($jieqiLang["pay"]["save_paylog_failure"]);
				}
			}
			else if ($showmode) {
				jieqi_msgwin(LANG_DO_SUCCESS, sprintf($jieqiLang["pay"]["buy_egold_success"], $buyname, JIEQI_EGOLD_NAME, $egold));
			}
		}
		else if ($showmode) {
			jieqi_msgwin(LANG_DO_SUCCESS, sprintf($jieqiLang["pay"]["buy_already_success"], $buyname, JIEQI_EGOLD_NAME, $egold));
		}
	}
	else if ($showmode) {
		jieqi_printfail($jieqiLang["pay"]["no_buy_record"]);
	}
}
else if ($showmode) {
	jieqi_printfail($jieqiLang["pay"]["return_checkcode_error"]);
}

?>
