<?php

function getNonceStr($length = 32)
{
	$chars = "abcdefghijklmnopqrstuvwxyz0123456789";
	$str = "";

	for ($i = 0; $i < $length; $i++) {
		$str .= substr($chars, mt_rand(0, strlen($chars) - 1), 1);
	}

	return $str;
}

function ToXml($values)
{
	if (!is_array($values) || (count($values) <= 0)) {
		return "数组数据异常！";
	}

	$xml = "<xml>";

	foreach ($values as $key => $val ) {
		if (is_numeric($val)) {
			$xml .= "<" . $key . ">" . $val . "</" . $key . ">";
		}
		else {
			$xml .= "<" . $key . "><![CDATA[" . $val . "]]></" . $key . ">";
		}
	}

	$xml .= "</xml>";
	return $xml;
}

function postXmlCurl($xml, $url, $useCert = false, $second = 30)
{
	global $jieqiPayset;
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_TIMEOUT, $second);
	if ((WxPayConfig::CURL_PROXY_HOST != "0.0.0.0") && (WxPayConfig::CURL_PROXY_PORT != 0)) {
		curl_setopt($ch, CURLOPT_PROXY, WxPayConfig::CURL_PROXY_HOST);
		curl_setopt($ch, CURLOPT_PROXYPORT, WxPayConfig::CURL_PROXY_PORT);
	}

	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	curl_setopt($ch, CURLOPT_HEADER, false);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

	if ($useCert == true) {
		curl_setopt($ch, CURLOPT_SSLCERTTYPE, "PEM");
		curl_setopt($ch, CURLOPT_SSLCERT, WxPayConfig::SSLCERT_PATH);
		curl_setopt($ch, CURLOPT_SSLKEYTYPE, "PEM");
		curl_setopt($ch, CURLOPT_SSLKEY, WxPayConfig::SSLKEY_PATH);
	}

	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $xml);
	$data = curl_exec($ch);

	if ($data) {
		curl_close($ch);
		return $data;
	}
	else {
		$error = curl_errno($ch);
		curl_close($ch);
		return "curl出错，错误码:$error";
	}
}

function getMillisecond()
{
	$time = explode(" ", microtime());
	$time = $time[1] . ($time[0] * 1000);
	$time2 = explode(".", $time);
	$time = $time2[0];
	return $time;
}

function FromXml($xml)
{
	if (!$xml) {
		return "xml数据异常！";
	}

	libxml_disable_entity_loader(true);
	$values = json_decode(json_encode(simplexml_load_string($xml, "SimpleXMLElement", LIBXML_NOCDATA)), true);
	return $values;
}

function reportCostTime($url, $startTimeStamp, $data)
{
	global $jieqiPayset;

	if (WxPayConfig::REPORT_LEVENL == 0) {
		return NULL;
	}

	if ((WxPayConfig::REPORT_LEVENL == 1) && isset($data["return_code"]) && ($data["return_code"] == "SUCCESS") && isset($data["result_code"]) && ($data["result_code"] == "SUCCESS")) {
		return NULL;
	}

	$endTimeStamp = getmillisecond();
	$objInput = array();
	$objInput["interface_url"] = $url;
	$objInput["execute_time_"] = $endTimeStamp - $startTimeStamp;

	if (isset($data["return_code"])) {
		$objInput["return_code"] = $data["return_code"];
	}

	if (isset($data["return_msg"])) {
		$objInput["return_msg"] = $data["return_msg"];
	}

	if (isset($data["result_code"])) {
		$objInput["result_code"] = $data["result_code"];
	}

	if (isset($data["err_code"])) {
		$objInput["err_code"] = $data["err_code"];
	}

	if (isset($data["err_code_des"])) {
		$objInput["err_code_des"] = $data["err_code_des"];
	}

	if (isset($data["out_trade_no"])) {
		$objInput["out_trade_no"] = $data["out_trade_no"];
	}

	if (isset($data["device_info"])) {
		$objInput["device_info"] = $data["device_info"];
	}

	try {
		report($objInput);
	}
	catch (Exception $e) {
	}
}

function report($inputObj, $timeOut = 1)
{
	global $jieqiPayset;
	$url = "https://api.mch.weixin.qq.com/payitil/report";

	if (!isset($inputObj["interface_url"])) {
		return false;
	}

	if (empty($inputObj["return_code"])) {
		return false;
	}

	if (!isset($inputObj["result_code"])) {
		return false;
	}

	if (!isset($inputObj["user_ip"])) {
		return false;
	}

	if (!isset($inputObj["execute_time_"])) {
		return false;
	}

	$inputObj["appid"] = WxPayConfig::APPID;
	$inputObj["mch_id"] = WxPayConfig::MCHID;
	$inputObj["user_ip"] = $_SERVER["REMOTE_ADDR"];
	$inputObj["time"] = date("YmdHis");
	$inputObj["nonce_str"] = getnoncestr();
	ksort($inputObj);
	$sign = "";
	$query = "";

	foreach ($inputObj as $k => $v ) {
		if (($k != "sign") && ($v != "") && !is_array($v)) {
			$query .= $k . "=" . $v . "&";
		}

		$sign = trim($query, "&");
	}

	$inputObj["sign"] = strtoupper(md5($sign . "&key=" . WxPayConfig::KEY));
	$xml = toxml($inputObj);
	$response = postxmlcurl($xml, $url, false, $timeOut);
	return $response;
}

function orderQuery($inputObj, $timeOut = 6)
{
	global $jieqiPayset;
	$url = "https://api.mch.weixin.qq.com/pay/orderquery";
	if (!isset($inputObj["out_trade_no"]) && !isset($inputObj["transaction_id"])) {
		return "订单查询接口中，out_trade_no、transaction_id至少填一个！";
	}

	$orderQuery = array();
	$orderQuery["appid"] = WxPayConfig::APPID;
	$orderQuery["mch_id"] = WxPayConfig::MCHID;
	$orderQuery["nonce_str"] = getnoncestr();
	$orderQuery["transaction_id"] = $inputObj["transaction_id"];
	ksort($orderQuery);
	$sign = "";
	$query = "";

	foreach ($orderQuery as $k => $v ) {
		if (($k != "sign") && ($v != "") && !is_array($v)) {
			$query .= $k . "=" . $v . "&";
		}

		$sign = trim($query, "&");
	}

	$orderQuery["sign"] = strtoupper(md5($sign . "&key=" . WxPayConfig::KEY));
	$xml = toxml($orderQuery);
	$startTimeStamp = getmillisecond();
	$response = postxmlcurl($xml, $url, false, $timeOut);
	$result = fromxml($response);
	reportcosttime($url, $startTimeStamp, $result);
	return $result;
}

function ToUrlParams($urlObj)
{
	$buff = "";

	foreach ($urlObj as $k => $v ) {
		if ($k != "sign") {
			$buff .= $k . "=" . $v . "&";
		}
	}

	$buff = trim($buff, "&");
	return $buff;
}

function code($redirectUrl)
{
	global $jieqiPayset;
	$urlObj["appid"] = WxPayConfig::APPID;
	$urlObj["redirect_uri"] = "$redirectUrl";
	$urlObj["response_type"] = "code";
	$urlObj["scope"] = "snsapi_base";
	$urlObj["state"] = "STATE#wechat_redirect";
	$bizString = tourlparams($urlObj);
	return "https://open.weixin.qq.com/connect/oauth2/authorize?" . $bizString;
}

function openid($code)
{
	global $jieqiPayset;
	$url = ForOpenid($code);
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_TIMEOUT, 30);
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	curl_setopt($ch, CURLOPT_HEADER, false);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	if ((WxPayConfig::CURL_PROXY_HOST != "0.0.0.0") && (WxPayConfig::CURL_PROXY_PORT != 0)) {
		curl_setopt($ch, CURLOPT_PROXY, WxPayConfig::CURL_PROXY_HOST);
		curl_setopt($ch, CURLOPT_PROXYPORT, WxPayConfig::CURL_PROXY_PORT);
	}

	$res = curl_exec($ch);
	curl_close($ch);
	$data = json_decode($res, true);
	$openid = $data["openid"];
	return $openid;
}

function ForOpenid($code)
{
	global $jieqiPayset;
	$urlObj["appid"] = WxPayConfig::APPID;
	$urlObj["secret"] = WxPayConfig::APPSECRET;
	$urlObj["code"] = $code;
	$urlObj["grant_type"] = "authorization_code";
	$bizString = tourlparams($urlObj);
	return "https://api.weixin.qq.com/sns/oauth2/access_token?" . $bizString;
}

require_once (dirname(dirname(dirname(dirname(__FILE__)))) . "/configs/pay/weixinpay.php");

?>
