<?php

/**
 * 
 * 鎺ュ彛璁块棶绫伙紝鍖呭惈镓EUR链夊井淇℃敮浠楢PI鍒楄〃镄勫皝瑁咃紝绫讳腑鏂规硶涓簊tatic鏂规硶锛?
 * 姣忎釜鎺ュ彛链夐粯璁よ秴镞舵椂闂达纸闄ゆ彁浜よ镓敮浠树负10s锛屼笂鎶ヨ秴镞舵椂闂翠负1s澶栵紝鍏朵粬鍧囦负6s锛?
 * @author widyhu
 *
 */
class WxPayApi
{
	/**
	 * 
	 * 缁熶竴涓嫔崟锛学xPayUnifiedOrder涓璷ut_trade_no銆乥ody銆乼otal_fee銆乼rade_type蹇呭～
	 * appid銆乵chid銆乻pbill_create_ip銆乶once_str涓嶉渶瑕佸～鍏?
	 * @param WxPayUnifiedOrder $inputObj
	 * @param int $timeOut
	 * @throws WxPayException
	 * @return 鎴愬姛镞惰繑锲烇紝鍏朵粬鎶涘纾甯?
	 */
	static public function unifiedOrder($inputObj, $timeOut = 6)
	{
		$url = "https://api.mch.weixin.qq.com/pay/unifiedorder";

		if (!$inputObj->IsOut_trade_noSet()) {
			throw new WxPayException("缂哄皯缁熶竴鏀粯鎺ュ彛蹇呭～鍙傛暟out_trade_no锛?);
		}
		else if (!$inputObj->IsBodySet()) {
			throw new WxPayException("缂哄皯缁熶竴鏀粯鎺ュ彛蹇呭～鍙傛暟body锛?);
		}
		else if (!$inputObj->IsTotal_feeSet()) {
			throw new WxPayException("缂哄皯缁熶竴鏀粯鎺ュ彛蹇呭～鍙傛暟total_fee锛?);
		}
		else if (!$inputObj->IsTrade_typeSet()) {
			throw new WxPayException("缂哄皯缁熶竴鏀粯鎺ュ彛蹇呭～鍙傛暟trade_type锛?);
		}

		if (($inputObj->GetTrade_type() == "JSAPI") && !$inputObj->IsOpenidSet()) {
			throw new WxPayException("缁熶竴鏀粯鎺ュ彛涓紝缂哄皯蹇呭～鍙傛暟openid锛乼rade_type涓篔SAPI镞讹紝openid涓哄繀濉弬鏁帮紒");
		}

		if (($inputObj->GetTrade_type() == "NATIVE") && !$inputObj->IsProduct_idSet()) {
			throw new WxPayException("缁熶竴鏀粯鎺ュ彛涓紝缂哄皯蹇呭～鍙傛暟product_id锛乼rade_type涓篔SAPI镞讹紝product_id涓哄繀濉弬鏁帮紒");
		}

		if (!$inputObj->IsNotify_urlSet()) {
			$inputObj->SetNotify_url(WxPayConfig::NOTIFY_URL);
		}

		$inputObj->SetAppid(WxPayConfig::APPID);
		$inputObj->SetMch_id(WxPayConfig::MCHID);
		$inputObj->SetSpbill_create_ip($_SERVER["REMOTE_ADDR"]);
		$inputObj->SetNonce_str(self::getNonceStr());
		$inputObj->SetSign();
		$xml = $inputObj->ToXml();
		$startTimeStamp = self::getMillisecond();
		$response = self::postXmlCurl($xml, $url, false, $timeOut);
		$result = WxPayResults::Init($response);
		self::reportCostTime($url, $startTimeStamp, $result);
		return $result;
	}

	/**
	 * 
	 * 镆ヨ璁㈠崟锛学xPayOrderQuery涓璷ut_trade_no銆乼ransaction_id镊冲皯濉竴涓?
	 * appid銆乵chid銆乻pbill_create_ip銆乶once_str涓嶉渶瑕佸～鍏?
	 * @param WxPayOrderQuery $inputObj
	 * @param int $timeOut
	 * @throws WxPayException
	 * @return 鎴愬姛镞惰繑锲烇紝鍏朵粬鎶涘纾甯?
	 */
	static public function orderQuery($inputObj, $timeOut = 6)
	{
		$url = "https://api.mch.weixin.qq.com/pay/orderquery";
		if (!$inputObj->IsOut_trade_noSet() && !$inputObj->IsTransaction_idSet()) {
			throw new WxPayException("璁㈠崟镆ヨ鎺ュ彛涓紝out_trade_no銆乼ransaction_id镊冲皯濉竴涓紒");
		}

		$inputObj->SetAppid(WxPayConfig::APPID);
		$inputObj->SetMch_id(WxPayConfig::MCHID);
		$inputObj->SetNonce_str(self::getNonceStr());
		$inputObj->SetSign();
		$xml = $inputObj->ToXml();
		$startTimeStamp = self::getMillisecond();
		$response = self::postXmlCurl($xml, $url, false, $timeOut);
		$result = WxPayResults::Init($response);
		self::reportCostTime($url, $startTimeStamp, $result);
		return $result;
	}

	/**
	 * 
	 * 鍏抽棴璁㈠崟锛学xPayCloseOrder涓璷ut_trade_no蹇呭～
	 * appid銆乵chid銆乻pbill_create_ip銆乶once_str涓嶉渶瑕佸～鍏?
	 * @param WxPayCloseOrder $inputObj
	 * @param int $timeOut
	 * @throws WxPayException
	 * @return 鎴愬姛镞惰繑锲烇紝鍏朵粬鎶涘纾甯?
	 */
	static public function closeOrder($inputObj, $timeOut = 6)
	{
		$url = "https://api.mch.weixin.qq.com/pay/closeorder";

		if (!$inputObj->IsOut_trade_noSet()) {
			throw new WxPayException("璁㈠崟镆ヨ鎺ュ彛涓紝out_trade_no蹇呭～锛?);
		}

		$inputObj->SetAppid(WxPayConfig::APPID);
		$inputObj->SetMch_id(WxPayConfig::MCHID);
		$inputObj->SetNonce_str(self::getNonceStr());
		$inputObj->SetSign();
		$xml = $inputObj->ToXml();
		$startTimeStamp = self::getMillisecond();
		$response = self::postXmlCurl($xml, $url, false, $timeOut);
		$result = WxPayResults::Init($response);
		self::reportCostTime($url, $startTimeStamp, $result);
		return $result;
	}

	/**
	 * 
	 * 鐢宠阃EUR娆撅紝WxPayRefund涓璷ut_trade_no銆乼ransaction_id镊冲皯濉竴涓笖
	 * out_refund_no銆乼otal_fee銆乺efund_fee銆乷p_user_id涓哄繀濉弬鏁?
	 * appid銆乵chid銆乻pbill_create_ip銆乶once_str涓嶉渶瑕佸～鍏?
	 * @param WxPayRefund $inputObj
	 * @param int $timeOut
	 * @throws WxPayException
	 * @return 鎴愬姛镞惰繑锲烇紝鍏朵粬鎶涘纾甯?
	 */
	static public function refund($inputObj, $timeOut = 6)
	{
		$url = "https://api.mch.weixin.qq.com/secapi/pay/refund";
		if (!$inputObj->IsOut_trade_noSet() && !$inputObj->IsTransaction_idSet()) {
			throw new WxPayException("阃EUR娆剧敌璇锋帴鍙ｄ腑锛宱ut_trade_no銆乼ransaction_id镊冲皯濉竴涓紒");
		}
		else if (!$inputObj->IsOut_refund_noSet()) {
			throw new WxPayException("阃EUR娆剧敌璇锋帴鍙ｄ腑锛岀己灏戝繀濉弬鏁皁ut_refund_no锛?);
		}
		else if (!$inputObj->IsTotal_feeSet()) {
			throw new WxPayException("阃EUR娆剧敌璇锋帴鍙ｄ腑锛岀己灏戝繀濉弬鏁皌otal_fee锛?);
		}
		else if (!$inputObj->IsRefund_feeSet()) {
			throw new WxPayException("阃EUR娆剧敌璇锋帴鍙ｄ腑锛岀己灏戝繀濉弬鏁皉efund_fee锛?);
		}
		else if (!$inputObj->IsOp_user_idSet()) {
			throw new WxPayException("阃EUR娆剧敌璇锋帴鍙ｄ腑锛岀己灏戝繀濉弬鏁皁p_user_id锛?);
		}

		$inputObj->SetAppid(WxPayConfig::APPID);
		$inputObj->SetMch_id(WxPayConfig::MCHID);
		$inputObj->SetNonce_str(self::getNonceStr());
		$inputObj->SetSign();
		$xml = $inputObj->ToXml();
		$startTimeStamp = self::getMillisecond();
		$response = self::postXmlCurl($xml, $url, true, $timeOut);
		$result = WxPayResults::Init($response);
		self::reportCostTime($url, $startTimeStamp, $result);
		return $result;
	}

	/**
	 * 
	 * 镆ヨ阃EUR娆?
	 * 鎻愪氦阃EUR娆剧敌璇峰悗锛岄EUR氲绷璋幂敤璇ユ帴鍙ｆ煡璇㈤EUREUR娆剧姸镐并EUR傞EUREUR娆炬湁涓EUR瀹氩欢镞讹紝
	 * 鐢ㄩ浂阍辨敮浠樼殑阃EUR娆?0鍒嗛挓鍐呭埌璐︼紝阈惰鍗℃敮浠樼殑阃EUR娆?涓伐浣沧棩鍚庨吨鏂版煡璇㈤EUREUR娆剧姸镐并EUR?
	 * WxPayRefundQuery涓璷ut_refund_no銆乷ut_trade_no銆乼ransaction_id銆乺efund_id锲涗釜鍙傛暟蹇呭～涓EUR涓?
	 * appid銆乵chid銆乻pbill_create_ip銆乶once_str涓嶉渶瑕佸～鍏?
	 * @param WxPayRefundQuery $inputObj
	 * @param int $timeOut
	 * @throws WxPayException
	 * @return 鎴愬姛镞惰繑锲烇紝鍏朵粬鎶涘纾甯?
	 */
	static public function refundQuery($inputObj, $timeOut = 6)
	{
		$url = "https://api.mch.weixin.qq.com/pay/refundquery";
		if (!$inputObj->IsOut_refund_noSet() && !$inputObj->IsOut_trade_noSet() && !$inputObj->IsTransaction_idSet() && !$inputObj->IsRefund_idSet()) {
			throw new WxPayException("阃EUR娆炬煡璇㈡帴鍙ｄ腑锛宱ut_refund_no銆乷ut_trade_no銆乼ransaction_id銆乺efund_id锲涗釜鍙傛暟蹇呭～涓EUR涓紒");
		}

		$inputObj->SetAppid(WxPayConfig::APPID);
		$inputObj->SetMch_id(WxPayConfig::MCHID);
		$inputObj->SetNonce_str(self::getNonceStr());
		$inputObj->SetSign();
		$xml = $inputObj->ToXml();
		$startTimeStamp = self::getMillisecond();
		$response = self::postXmlCurl($xml, $url, false, $timeOut);
		$result = WxPayResults::Init($response);
		self::reportCostTime($url, $startTimeStamp, $result);
		return $result;
	}

	/**
	 * 涓嬭浇瀵硅处鍗曪紝WxPayDownloadBill涓璪ill_date涓哄繀濉弬鏁?
	 * appid銆乵chid銆乻pbill_create_ip銆乶once_str涓嶉渶瑕佸～鍏?
	 * @param WxPayDownloadBill $inputObj
	 * @param int $timeOut
	 * @throws WxPayException
	 * @return 鎴愬姛镞惰繑锲烇紝鍏朵粬鎶涘纾甯?
	 */
	static public function downloadBill($inputObj, $timeOut = 6)
	{
		$url = "https://api.mch.weixin.qq.com/pay/downloadbill";

		if (!$inputObj->IsBill_dateSet()) {
			throw new WxPayException("瀵硅处鍗曟帴鍙ｄ腑锛岀己灏戝繀濉弬鏁痈ill_date锛?);
		}

		$inputObj->SetAppid(WxPayConfig::APPID);
		$inputObj->SetMch_id(WxPayConfig::MCHID);
		$inputObj->SetNonce_str(self::getNonceStr());
		$inputObj->SetSign();
		$xml = $inputObj->ToXml();
		$response = self::postXmlCurl($xml, $url, false, $timeOut);

		if (substr($response, 0, 5) == "<xml>") {
			return "";
		}

		return $response;
	}

	/**
	 * 鎻愪氦琚壂鏀粯API
	 * 鏀堕摱锻树娇鐢ㄦ壂镰佽澶囱鍙栧井淇＄敤鎴峰埛鍗℃巿鏉幂爜浠ュ悗锛屼簩缁寸爜鎴栨浔镰佷俊鎭紶阃佽呖鍟嗘埛鏀堕摱鍙帮紝
	 * 鐢卞晢鎴锋敹阈跺彴鎴栬EUR呭晢鎴峰悗鍙拌皟鐢ㄨ鎺ュ彛鍙戣捣鏀粯銆?
	 * WxPayWxPayMicroPay涓璪ody銆乷ut_trade_no銆乼otal_fee銆乤uth_code鍙傛暟蹇呭～
	 * appid銆乵chid銆乻pbill_create_ip銆乶once_str涓嶉渶瑕佸～鍏?
	 * @param WxPayWxPayMicroPay $inputObj
	 * @param int $timeOut
	 */
	static public function micropay($inputObj, $timeOut = 10)
	{
		$url = "https://api.mch.weixin.qq.com/pay/micropay";

		if (!$inputObj->IsBodySet()) {
			throw new WxPayException("鎻愪氦琚壂鏀粯API鎺ュ彛涓紝缂哄皯蹇呭～鍙傛暟body锛?);
		}
		else if (!$inputObj->IsOut_trade_noSet()) {
			throw new WxPayException("鎻愪氦琚壂鏀粯API鎺ュ彛涓紝缂哄皯蹇呭～鍙傛暟out_trade_no锛?);
		}
		else if (!$inputObj->IsTotal_feeSet()) {
			throw new WxPayException("鎻愪氦琚壂鏀粯API鎺ュ彛涓紝缂哄皯蹇呭～鍙傛暟total_fee锛?);
		}
		else if (!$inputObj->IsAuth_codeSet()) {
			throw new WxPayException("鎻愪氦琚壂鏀粯API鎺ュ彛涓紝缂哄皯蹇呭～鍙傛暟auth_code锛?);
		}

		$inputObj->SetSpbill_create_ip($_SERVER["REMOTE_ADDR"]);
		$inputObj->SetAppid(WxPayConfig::APPID);
		$inputObj->SetMch_id(WxPayConfig::MCHID);
		$inputObj->SetNonce_str(self::getNonceStr());
		$inputObj->SetSign();
		$xml = $inputObj->ToXml();
		$startTimeStamp = self::getMillisecond();
		$response = self::postXmlCurl($xml, $url, false, $timeOut);
		$result = WxPayResults::Init($response);
		self::reportCostTime($url, $startTimeStamp, $result);
		return $result;
	}

	/**
	 * 
	 * 鎾ら攒璁㈠崟API鎺ュ彛锛学xPayReverse涓弬鏁皁ut_trade_no鍜宼ransaction_id蹇呴』濉啓涓EUR涓?
	 * appid銆乵chid銆乻pbill_create_ip銆乶once_str涓嶉渶瑕佸～鍏?
	 * @param WxPayReverse $inputObj
	 * @param int $timeOut
	 * @throws WxPayException
	 */
	static public function reverse($inputObj, $timeOut = 6)
	{
		$url = "https://api.mch.weixin.qq.com/secapi/pay/reverse";
		if (!$inputObj->IsOut_trade_noSet() && !$inputObj->IsTransaction_idSet()) {
			throw new WxPayException("鎾ら攒璁㈠崟API鎺ュ彛涓紝鍙傛暟out_trade_no鍜宼ransaction_id蹇呴』濉啓涓EUR涓紒");
		}

		$inputObj->SetAppid(WxPayConfig::APPID);
		$inputObj->SetMch_id(WxPayConfig::MCHID);
		$inputObj->SetNonce_str(self::getNonceStr());
		$inputObj->SetSign();
		$xml = $inputObj->ToXml();
		$startTimeStamp = self::getMillisecond();
		$response = self::postXmlCurl($xml, $url, true, $timeOut);
		$result = WxPayResults::Init($response);
		self::reportCostTime($url, $startTimeStamp, $result);
		return $result;
	}

	/**
	 * 
	 * 娴嬮EUR熶笂鎶ワ紝璇ユ柟娉曞唴閮ㄥ皝瑁呭湪report涓紝浣跨敤镞惰娉ㄦ剰寮傚父娴佺▼
	 * WxPayReport涓璱nterface_url銆乺eturn_code銆乺esult_code銆乽ser_ip銆乪xecute_time_蹇呭～
	 * appid銆乵chid銆乻pbill_create_ip銆乶once_str涓嶉渶瑕佸～鍏?
	 * @param WxPayReport $inputObj
	 * @param int $timeOut
	 * @throws WxPayException
	 * @return 鎴愬姛镞惰繑锲烇紝鍏朵粬鎶涘纾甯?
	 */
	static public function report($inputObj, $timeOut = 1)
	{
		$url = "https://api.mch.weixin.qq.com/payitil/report";

		if (!$inputObj->IsInterface_urlSet()) {
			throw new WxPayException("鎺ュ彛URL锛岀己灏戝繀濉弬鏁癷nterface_url锛?);
		}

		if (!$inputObj->IsReturn_codeSet()) {
			throw new WxPayException("杩斿洖钟舵EUR佺爜锛岀己灏戝繀濉弬鏁皉eturn_code锛?);
		}

		if (!$inputObj->IsResult_codeSet()) {
			throw new WxPayException("涓氩姟缁撴灉锛岀己灏戝繀濉弬鏁皉esult_code锛?);
		}

		if (!$inputObj->IsUser_ipSet()) {
			throw new WxPayException("璁块棶鎺ュ彛IP锛岀己灏戝繀濉弬鏁皍ser_ip锛?);
		}

		if (!$inputObj->IsExecute_time_Set()) {
			throw new WxPayException("鎺ュ彛钥楁椂锛岀己灏戝繀濉弬鏁癳xecute_time_锛?);
		}

		$inputObj->SetAppid(WxPayConfig::APPID);
		$inputObj->SetMch_id(WxPayConfig::MCHID);
		$inputObj->SetUser_ip($_SERVER["REMOTE_ADDR"]);
		$inputObj->SetTime(date("YmdHis"));
		$inputObj->SetNonce_str(self::getNonceStr());
		$inputObj->SetSign();
		$xml = $inputObj->ToXml();
		$startTimeStamp = self::getMillisecond();
		$response = self::postXmlCurl($xml, $url, false, $timeOut);
		return $response;
	}

	/**
	 * 
	 * 鐢熸垚浜岀淮镰佽鍒?妯″纺涓EUR鐢熸垚鏀粯浜岀淮镰?
	 * appid銆乵chid銆乻pbill_create_ip銆乶once_str涓嶉渶瑕佸～鍏?
	 * @param WxPayBizPayUrl $inputObj
	 * @param int $timeOut
	 * @throws WxPayException
	 * @return 鎴愬姛镞惰繑锲烇紝鍏朵粬鎶涘纾甯?
	 */
	static public function bizpayurl($inputObj, $timeOut = 6)
	{
		if (!$inputObj->IsProduct_idSet()) {
			throw new WxPayException("鐢熸垚浜岀淮镰侊紝缂哄皯蹇呭～鍙傛暟product_id锛?);
		}

		$inputObj->SetAppid(WxPayConfig::APPID);
		$inputObj->SetMch_id(WxPayConfig::MCHID);
		$inputObj->SetTime_stamp(time());
		$inputObj->SetNonce_str(self::getNonceStr());
		$inputObj->SetSign();
		return $inputObj->GetValues();
	}

	/**
	 * 
	 * 杞崲鐭摼鎺?
	 * 璇ユ帴鍙ｄ富瑕佺敤浜庢壂镰佸师鐢熸敮浠樻ā寮忎竴涓殑浜岀淮镰侀摼鎺ヨ浆鎴愮煭阈炬帴(weixin://wxpay/s/XXXXXX)锛?
	 * 鍑忓皬浜岀淮镰佹暟鎹噺锛屾彁鍗囨壂鎻忛EUR熷害鍜岀簿纭害銆?
	 * appid銆乵chid銆乻pbill_create_ip銆乶once_str涓嶉渶瑕佸～鍏?
	 * @param WxPayShortUrl $inputObj
	 * @param int $timeOut
	 * @throws WxPayException
	 * @return 鎴愬姛镞惰繑锲烇紝鍏朵粬鎶涘纾甯?
	 */
	static public function shorturl($inputObj, $timeOut = 6)
	{
		$url = "https://api.mch.weixin.qq.com/tools/shorturl";

		if (!$inputObj->IsLong_urlSet()) {
			throw new WxPayException("闇EUR瑕佽浆鎹㈢殑URL锛岀鍚岖敤铡熶覆锛屼紶杈挞渶URL encode锛?);
		}

		$inputObj->SetAppid(WxPayConfig::APPID);
		$inputObj->SetMch_id(WxPayConfig::MCHID);
		$inputObj->SetNonce_str(self::getNonceStr());
		$inputObj->SetSign();
		$xml = $inputObj->ToXml();
		$startTimeStamp = self::getMillisecond();
		$response = self::postXmlCurl($xml, $url, false, $timeOut);
		$result = WxPayResults::Init($response);
		self::reportCostTime($url, $startTimeStamp, $result);
		return $result;
	}

	/**
 	 * 
 	 * 鏀粯缁撴灉阃氱敤阃氱煡
 	 * @param function $callback
 	 * 鐩存帴锲炶皟鍑芥暟浣跨敤鏂规硶: notify(you_function);
 	 * 锲炶皟绫绘垚锻桦嚱鏁版柟娉?notify(array($this, you_function));
 	 * $callback  铡熷瀷涓猴细function function_name($data){}
 	 */
	static public function notify($callback, &$msg)
	{
		$xml = $GLOBALS["HTTP_RAW_POST_DATA"];

		try {
			$result = WxPayResults::Init($xml);
		}
		catch (WxPayException $e) {
			$msg = $e->errorMessage();
			return false;
		}

		return call_user_func($callback, $result);
	}

	/**
	 * 
	 * 浜х敓闅忔満瀛楃涓诧紝涓嶉昵浜?2浣?
	 * @param int $length
	 * @return 浜х敓镄勯殢链哄瓧绗︿覆
	 */
	static public function getNonceStr($length = 32)
	{
		$chars = "abcdefghijklmnopqrstuvwxyz0123456789";
		$str = "";

		for ($i = 0; $i < $length; $i++) {
			$str .= substr($chars, mt_rand(0, strlen($chars) - 1), 1);
		}

		return $str;
	}

	/**
	 * 鐩存帴杈揿嚭xml
	 * @param string $xml
	 */
	static public function replyNotify($xml)
	{
		echo $xml;
	}

	/**
	 * 
	 * 涓婃姤鏁版嵁锛?涓婃姤镄勬椂链椤皢灞忚斀镓EUR链夊纾甯告祦绋?
	 * @param string $usrl
	 * @param int $startTimeStamp
	 * @param array $data
	 */
	static private function reportCostTime($url, $startTimeStamp, $data)
	{
		if (WxPayConfig::REPORT_LEVENL == 0) {
			return NULL;
		}

		if ((WxPayConfig::REPORT_LEVENL == 1) && array_key_exists("return_code", $data) && ($data["return_code"] == "SUCCESS") && array_key_exists("result_code", $data) && ($data["result_code"] == "SUCCESS")) {
			return NULL;
		}

		$endTimeStamp = self::getMillisecond();
		$objInput = new WxPayReport();
		$objInput->SetInterface_url($url);
		$objInput->SetExecute_time_($endTimeStamp - $startTimeStamp);

		if (array_key_exists("return_code", $data)) {
			$objInput->SetReturn_code($data["return_code"]);
		}

		if (array_key_exists("return_msg", $data)) {
			$objInput->SetReturn_msg($data["return_msg"]);
		}

		if (array_key_exists("result_code", $data)) {
			$objInput->SetResult_code($data["result_code"]);
		}

		if (array_key_exists("err_code", $data)) {
			$objInput->SetErr_code($data["err_code"]);
		}

		if (array_key_exists("err_code_des", $data)) {
			$objInput->SetErr_code_des($data["err_code_des"]);
		}

		if (array_key_exists("out_trade_no", $data)) {
			$objInput->SetOut_trade_no($data["out_trade_no"]);
		}

		if (array_key_exists("device_info", $data)) {
			$objInput->SetDevice_info($data["device_info"]);
		}

		try {
			self::report($objInput);
		}
		catch (WxPayException $e) {
		}
	}

	/**
	 * 浠ost鏂瑰纺鎻愪氦xml鍒板搴旗殑鎺ュ彛url
	 * 
	 * @param string $xml  闇EUR瑕乸ost镄刹ml鏁版嵁
	 * @param string $url  url
	 * @param bool $useCert 鏄惁闇EUR瑕佽瘉涔︼紝榛樿涓嶉渶瑕?
	 * @param int $second   url镓ц瓒呮椂镞堕棿锛岄粯璁?0s
	 * @throws WxPayException
	 */
	static private function postXmlCurl($xml, $url, $useCert = false, $second = 30)
	{
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_TIMEOUT, $second);
		if ((WxPayConfig::CURL_PROXY_HOST != "0.0.0.0") && (WxPayConfig::CURL_PROXY_PORT != 0)) {
			curl_setopt($ch, CURLOPT_PROXY, WxPayConfig::CURL_PROXY_HOST);
			curl_setopt($ch, CURLOPT_PROXYPORT, WxPayConfig::CURL_PROXY_PORT);
		}

		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
		curl_setopt($ch, CURLOPT_HEADER, false);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

		if ($useCert == true) {
			curl_setopt($ch, CURLOPT_SSLCERTTYPE, "PEM");
			curl_setopt($ch, CURLOPT_SSLCERT, WxPayConfig::SSLCERT_PATH);
			curl_setopt($ch, CURLOPT_SSLKEYTYPE, "PEM");
			curl_setopt($ch, CURLOPT_SSLKEY, WxPayConfig::SSLKEY_PATH);
		}

		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $xml);
		$data = curl_exec($ch);

		if ($data) {
			curl_close($ch);
			return $data;
		}
		else {
			$error = curl_errno($ch);
			curl_close($ch);
			throw new WxPayException("curl鍑洪敊锛岄敊璇爜:$error");
		}
	}

	/**
	 * 銮峰彇姣绾у埆镄勬椂闂存埑
	 */
	static private function getMillisecond()
	{
		$time = explode(" ", microtime());
		$time = $time[1] . ($time[0] * 1000);
		$time2 = explode(".", $time);
		$time = $time2[0];
		return $time;
	}
}

require_once ("WxPay.Exception.php");
require_once (dirname(dirname(dirname(dirname(__FILE__)))) . "/configs/pay/weixinpay.php");
require_once ("WxPay.Data.php");

?>
