<?php

/**
 * 
 * 鏁版嵁瀵硅薄鍩虹绫伙紝璇ョ被涓畾涔夋暟鎹被链EUR鍩烘湰镄勮涓猴紝鍖呮嫭锛?
 * 璁＄畻/璁剧疆/銮峰彇绛惧悕銆佽緭鍑簒ml镙煎纺镄勫弬鏁般EUR佷粠xml璇诲彇鏁版嵁瀵硅薄绛?
 * @author widyhu
 *
 */
class WxPayDataBase
{
	protected $values = array();

	/**
	* 璁剧疆绛惧悕锛岃瑙佺鍚岖敓鎴愮畻娉?
	* @param string $value 
	**/
	public function SetSign()
	{
		$sign = $this->MakeSign();
		$this->values["sign"] = $sign;
		return $sign;
	}

	/**
	* 銮峰彇绛惧悕锛岃瑙佺鍚岖敓鎴愮畻娉旷殑链?
	* @return 链?
	**/
	public function GetSign()
	{
		return $this->values["sign"];
	}

	/**
	* 鍒ゆ柇绛惧悕锛岃瑙佺鍚岖敓鎴愮畻娉曟槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsSignSet()
	{
		return array_key_exists("sign", $this->values);
	}

	/**
	 * 杈揿嚭xml瀛楃
	 * @throws WxPayException
	**/
	public function ToXml()
	{
		if (!is_array($this->values) || (count($this->values) <= 0)) {
			throw new WxPayException("鏁扮粍鏁版嵁寮傚父锛?);
		}

		$xml = "<xml>";

		foreach ($this->values as $key => $val ) {
			if (is_numeric($val)) {
				$xml .= "<" . $key . ">" . $val . "</" . $key . ">";
			}
			else {
				$xml .= "<" . $key . "><![CDATA[" . $val . "]]></" . $key . ">";
			}
		}

		$xml .= "</xml>";
		return $xml;
	}

	/**
     * 灏唜ml杞负array
     * @param string $xml
     * @throws WxPayException
     */
	public function FromXml($xml)
	{
		if (!$xml) {
			throw new WxPayException("xml鏁版嵁寮傚父锛?);
		}

		libxml_disable_entity_loader(true);
		$this->values = json_decode(json_encode(simplexml_load_string($xml, "SimpleXMLElement", LIBXML_NOCDATA)), true);
		return $this->values;
	}

	/**
	 * 镙煎纺鍖栧弬鏁版牸寮忓寲鎴耻rl鍙傛暟
	 */
	public function ToUrlParams()
	{
		$buff = "";

		foreach ($this->values as $k => $v ) {
			if (($k != "sign") && ($v != "") && !is_array($v)) {
				$buff .= $k . "=" . $v . "&";
			}
		}

		$buff = trim($buff, "&");
		return $buff;
	}

	/**
	 * 鐢熸垚绛惧悕
	 * @return 绛惧悕锛屾湰鍑芥暟涓嶈鐩杝ign鎴愬憳鍙橀噺锛屽瑕佽缃鍚嶉渶瑕佽皟鐢⊿etSign鏂规硶璧嫔EUR?
	 */
	public function MakeSign()
	{
		ksort($this->values);
		$string = $this->ToUrlParams();
		$string = $string . "&key=" . WxPayConfig::KEY;
		$string = md5($string);
		$result = strtoupper($string);
		return $result;
	}

	/**
	 * 銮峰彇璁剧疆镄勫EUR?
	 */
	public function GetValues()
	{
		return $this->values;
	}
}

/**
 * 
 * 鎺ュ彛璋幂敤缁撴灉绫?
 * @author widyhu
 *
 */
class WxPayResults extends WxPayDataBase
{

	/**
	 * 
	 * 妫EUR娴嬬鍚?
	 */
	public function CheckSign()
	{
		if (!$this->IsSignSet()) {
			throw new WxPayException("绛惧悕阌栾锛?);
		}

		$sign = $this->MakeSign();

		if ($this->GetSign() == $sign) {
			return true;
		}

		throw new WxPayException("绛惧悕阌栾锛?);
	}

	/**
	 * 
	 * 浣跨敤鏁扮粍鍒濆鍖?
	 * @param array $array
	 */
	public function FromArray($array)
	{
		$this->values = $array;
	}

	/**
	 * 
	 * 浣跨敤鏁扮粍鍒濆鍖栧璞?
	 * @param array $array
	 * @param 鏄惁妫EUR娴嬬鍚?$noCheckSign
	 */
	static public function InitFromArray($array, $noCheckSign = false)
	{
		$obj = new self();
		$obj->FromArray($array);

		if ($noCheckSign == false) {
			$obj->CheckSign();
		}

		return $obj;
	}

	/**
	 * 
	 * 璁剧疆鍙傛暟
	 * @param string $key
	 * @param string $value
	 */
	public function SetData($key, $value)
	{
		$this->values[$key] = $value;
	}

	/**
     * 灏唜ml杞负array
     * @param string $xml
     * @throws WxPayException
     */
	static public function Init($xml)
	{
		$obj = new self();
		$obj->FromXml($xml);

		if ($obj->values["return_code"] != "SUCCESS") {
			return $obj->GetValues();
		}

		$obj->CheckSign();
		return $obj->GetValues();
	}
}

/**
 * 
 * 锲炶皟鍩虹绫?
 * @author widyhu
 *
 */
class WxPayNotifyReply extends WxPayDataBase
{

	/**
	 * 
	 * 璁剧疆阌栾镰?FAIL 鎴栬EUR?SUCCESS
	 * @param string
	 */
	public function SetReturn_code($return_code)
	{
		$this->values["return_code"] = $return_code;
	}

	/**
	 * 
	 * 銮峰彇阌栾镰?FAIL 鎴栬EUR?SUCCESS
	 * @return string $return_code
	 */
	public function GetReturn_code()
	{
		return $this->values["return_code"];
	}

	/**
	 * 
	 * 璁剧疆阌栾淇℃伅
	 * @param string $return_code
	 */
	public function SetReturn_msg($return_msg)
	{
		$this->values["return_msg"] = $return_msg;
	}

	/**
	 * 
	 * 銮峰彇阌栾淇℃伅
	 * @return string
	 */
	public function GetReturn_msg()
	{
		return $this->values["return_msg"];
	}

	/**
	 * 
	 * 璁剧疆杩斿洖鍙傛暟
	 * @param string $key
	 * @param string $value
	 */
	public function SetData($key, $value)
	{
		$this->values[$key] = $value;
	}
}

/**
 * 
 * 缁熶竴涓嫔崟杈揿叆瀵硅薄
 * @author widyhu
 *
 */
class WxPayUnifiedOrder extends WxPayDataBase
{

	/**
	* 璁剧疆寰俊鍒嗛厤镄勫叕浼楄处鍙稩D
	* @param string $value 
	**/
	public function SetAppid($value)
	{
		$this->values["appid"] = $value;
	}

	/**
	* 銮峰彇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D镄勫EUR?
	* @return 链?
	**/
	public function GetAppid()
	{
		return $this->values["appid"];
	}

	/**
	* 鍒ゆ柇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsAppidSet()
	{
		return array_key_exists("appid", $this->values);
	}

	/**
	* 璁剧疆寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛
	* @param string $value 
	**/
	public function SetMch_id($value)
	{
		$this->values["mch_id"] = $value;
	}

	/**
	* 銮峰彇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛镄勫EUR?
	* @return 链?
	**/
	public function GetMch_id()
	{
		return $this->values["mch_id"];
	}

	/**
	* 鍒ゆ柇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsMch_idSet()
	{
		return array_key_exists("mch_id", $this->values);
	}

	/**
	* 璁剧疆寰俊鏀粯鍒嗛厤镄勭粓绔澶囧佛锛屽晢鎴疯嚜瀹氢箟
	* @param string $value 
	**/
	public function SetDevice_info($value)
	{
		$this->values["device_info"] = $value;
	}

	/**
	* 銮峰彇寰俊鏀粯鍒嗛厤镄勭粓绔澶囧佛锛屽晢鎴疯嚜瀹氢箟镄勫EUR?
	* @return 链?
	**/
	public function GetDevice_info()
	{
		return $this->values["device_info"];
	}

	/**
	* 鍒ゆ柇寰俊鏀粯鍒嗛厤镄勭粓绔澶囧佛锛屽晢鎴疯嚜瀹氢箟鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsDevice_infoSet()
	{
		return array_key_exists("device_info", $this->values);
	}

	/**
	* 璁剧疆闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶
	* @param string $value 
	**/
	public function SetNonce_str($value)
	{
		$this->values["nonce_str"] = $value;
	}

	/**
	* 銮峰彇闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶镄勫EUR?
	* @return 链?
	**/
	public function GetNonce_str()
	{
		return $this->values["nonce_str"];
	}

	/**
	* 鍒ゆ柇闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsNonce_strSet()
	{
		return array_key_exists("nonce_str", $this->values);
	}

	/**
	* 璁剧疆鍟嗗搧鎴栨敮浠桦崟绠EUR瑕佹弿杩?
	* @param string $value 
	**/
	public function SetBody($value)
	{
		$this->values["body"] = $value;
	}

	/**
	* 銮峰彇鍟嗗搧鎴栨敮浠桦崟绠EUR瑕佹弿杩扮殑链?
	* @return 链?
	**/
	public function GetBody()
	{
		return $this->values["body"];
	}

	/**
	* 鍒ゆ柇鍟嗗搧鎴栨敮浠桦崟绠EUR瑕佹弿杩版槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsBodySet()
	{
		return array_key_exists("body", $this->values);
	}

	/**
	* 璁剧疆鍟嗗搧鍚岖О鏄庣粏鍒楄〃
	* @param string $value 
	**/
	public function SetDetail($value)
	{
		$this->values["detail"] = $value;
	}

	/**
	* 銮峰彇鍟嗗搧鍚岖О鏄庣粏鍒楄〃镄勫EUR?
	* @return 链?
	**/
	public function GetDetail()
	{
		return $this->values["detail"];
	}

	/**
	* 鍒ゆ柇鍟嗗搧鍚岖О鏄庣粏鍒楄〃鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsDetailSet()
	{
		return array_key_exists("detail", $this->values);
	}

	/**
	* 璁剧疆闄勫姞鏁版嵁锛屽湪镆ヨAPI鍜屾敮浠橀EUR氱煡涓师镙疯繑锲烇紝璇ュ瓧娈典富瑕佺敤浜庡晢鎴锋恶甯﹁鍗旷殑镊畾涔夋暟鎹?
	* @param string $value 
	**/
	public function SetAttach($value)
	{
		$this->values["attach"] = $value;
	}

	/**
	* 銮峰彇闄勫姞鏁版嵁锛屽湪镆ヨAPI鍜屾敮浠橀EUR氱煡涓师镙疯繑锲烇紝璇ュ瓧娈典富瑕佺敤浜庡晢鎴锋恶甯﹁鍗旷殑镊畾涔夋暟鎹殑链?
	* @return 链?
	**/
	public function GetAttach()
	{
		return $this->values["attach"];
	}

	/**
	* 鍒ゆ柇闄勫姞鏁版嵁锛屽湪镆ヨAPI鍜屾敮浠橀EUR氱煡涓师镙疯繑锲烇紝璇ュ瓧娈典富瑕佺敤浜庡晢鎴锋恶甯﹁鍗旷殑镊畾涔夋暟鎹槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsAttachSet()
	{
		return array_key_exists("attach", $this->values);
	}

	/**
	* 璁剧疆鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛,32涓瓧绗﹀唴銆佸彲鍖呭惈瀛楁瘝, 鍏朵粬璇存槑瑙佸晢鎴疯鍗曞佛
	* @param string $value 
	**/
	public function SetOut_trade_no($value)
	{
		$this->values["out_trade_no"] = $value;
	}

	/**
	* 銮峰彇鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛,32涓瓧绗﹀唴銆佸彲鍖呭惈瀛楁瘝, 鍏朵粬璇存槑瑙佸晢鎴疯鍗曞佛镄勫EUR?
	* @return 链?
	**/
	public function GetOut_trade_no()
	{
		return $this->values["out_trade_no"];
	}

	/**
	* 鍒ゆ柇鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛,32涓瓧绗﹀唴銆佸彲鍖呭惈瀛楁瘝, 鍏朵粬璇存槑瑙佸晢鎴疯鍗曞佛鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsOut_trade_noSet()
	{
		return array_key_exists("out_trade_no", $this->values);
	}

	/**
	* 璁剧疆绗﹀悎ISO 4217镙囧嗳镄勪笁浣嶅瓧姣崭唬镰侊紝榛樿浜烘皯甯侊细CNY锛屽叾浠栧EUR煎垪琛ㄨ瑙佽揣甯佺被鍨?
	* @param string $value 
	**/
	public function SetFee_type($value)
	{
		$this->values["fee_type"] = $value;
	}

	/**
	* 銮峰彇绗﹀悎ISO 4217镙囧嗳镄勪笁浣嶅瓧姣崭唬镰侊紝榛樿浜烘皯甯侊细CNY锛屽叾浠栧EUR煎垪琛ㄨ瑙佽揣甯佺被鍨嬬殑链?
	* @return 链?
	**/
	public function GetFee_type()
	{
		return $this->values["fee_type"];
	}

	/**
	* 鍒ゆ柇绗﹀悎ISO 4217镙囧嗳镄勪笁浣嶅瓧姣崭唬镰侊紝榛樿浜烘皯甯侊细CNY锛屽叾浠栧EUR煎垪琛ㄨ瑙佽揣甯佺被鍨嬫槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsFee_typeSet()
	{
		return array_key_exists("fee_type", $this->values);
	}

	/**
	* 璁剧疆璁㈠崟镐婚噾棰濓紝鍙兘涓烘暣鏁帮紝璇﹁鏀粯閲戦
	* @param string $value 
	**/
	public function SetTotal_fee($value)
	{
		$this->values["total_fee"] = $value;
	}

	/**
	* 銮峰彇璁㈠崟镐婚噾棰濓紝鍙兘涓烘暣鏁帮紝璇﹁鏀粯閲戦镄勫EUR?
	* @return 链?
	**/
	public function GetTotal_fee()
	{
		return $this->values["total_fee"];
	}

	/**
	* 鍒ゆ柇璁㈠崟镐婚噾棰濓紝鍙兘涓烘暣鏁帮紝璇﹁鏀粯閲戦鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsTotal_feeSet()
	{
		return array_key_exists("total_fee", $this->values);
	}

	/**
	* 璁剧疆APP鍜岀綉椤垫敮浠樻彁浜ょ敤鎴风ip锛孨ative鏀粯濉皟鐢ㄥ井淇℃敮浠楢PI镄勬満鍣↖P銆?
	* @param string $value 
	**/
	public function SetSpbill_create_ip($value)
	{
		$this->values["spbill_create_ip"] = $value;
	}

	/**
	* 銮峰彇APP鍜岀綉椤垫敮浠樻彁浜ょ敤鎴风ip锛孨ative鏀粯濉皟鐢ㄥ井淇℃敮浠楢PI镄勬満鍣↖P銆傜殑链?
	* @return 链?
	**/
	public function GetSpbill_create_ip()
	{
		return $this->values["spbill_create_ip"];
	}

	/**
	* 鍒ゆ柇APP鍜岀綉椤垫敮浠樻彁浜ょ敤鎴风ip锛孨ative鏀粯濉皟鐢ㄥ井淇℃敮浠楢PI镄勬満鍣↖P銆傛槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsSpbill_create_ipSet()
	{
		return array_key_exists("spbill_create_ip", $this->values);
	}

	/**
	* 璁剧疆璁㈠崟鐢熸垚镞堕棿锛屾牸寮忎负yyyyMMddHHmmss锛屽2009骞?2链?5镞?镣?0鍒?0绉掕〃绀轰负20091225091010銆傚叾浠栬瑙佹椂闂磋鍒?
	* @param string $value 
	**/
	public function SetTime_start($value)
	{
		$this->values["time_start"] = $value;
	}

	/**
	* 銮峰彇璁㈠崟鐢熸垚镞堕棿锛屾牸寮忎负yyyyMMddHHmmss锛屽2009骞?2链?5镞?镣?0鍒?0绉掕〃绀轰负20091225091010銆傚叾浠栬瑙佹椂闂磋鍒欑殑链?
	* @return 链?
	**/
	public function GetTime_start()
	{
		return $this->values["time_start"];
	}

	/**
	* 鍒ゆ柇璁㈠崟鐢熸垚镞堕棿锛屾牸寮忎负yyyyMMddHHmmss锛屽2009骞?2链?5镞?镣?0鍒?0绉掕〃绀轰负20091225091010銆傚叾浠栬瑙佹椂闂磋鍒欐槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsTime_startSet()
	{
		return array_key_exists("time_start", $this->values);
	}

	/**
	* 璁剧疆璁㈠崟澶辨晥镞堕棿锛屾牸寮忎负yyyyMMddHHmmss锛屽2009骞?2链?7镞?镣?0鍒?0绉掕〃绀轰负20091227091010銆傚叾浠栬瑙佹椂闂磋鍒?
	* @param string $value 
	**/
	public function SetTime_expire($value)
	{
		$this->values["time_expire"] = $value;
	}

	/**
	* 銮峰彇璁㈠崟澶辨晥镞堕棿锛屾牸寮忎负yyyyMMddHHmmss锛屽2009骞?2链?7镞?镣?0鍒?0绉掕〃绀轰负20091227091010銆傚叾浠栬瑙佹椂闂磋鍒欑殑链?
	* @return 链?
	**/
	public function GetTime_expire()
	{
		return $this->values["time_expire"];
	}

	/**
	* 鍒ゆ柇璁㈠崟澶辨晥镞堕棿锛屾牸寮忎负yyyyMMddHHmmss锛屽2009骞?2链?7镞?镣?0鍒?0绉掕〃绀轰负20091227091010銆傚叾浠栬瑙佹椂闂磋鍒欐槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsTime_expireSet()
	{
		return array_key_exists("time_expire", $this->values);
	}

	/**
	* 璁剧疆鍟嗗搧镙囱锛屼唬閲戝埜鎴栫珛鍑忎紭鎯犲姛鑳界殑鍙傛暟锛岃鏄庤瑙佷唬閲戝埜鎴栫珛鍑忎紭鎯?
	* @param string $value 
	**/
	public function SetGoods_tag($value)
	{
		$this->values["goods_tag"] = $value;
	}

	/**
	* 銮峰彇鍟嗗搧镙囱锛屼唬閲戝埜鎴栫珛鍑忎紭鎯犲姛鑳界殑鍙傛暟锛岃鏄庤瑙佷唬閲戝埜鎴栫珛鍑忎紭鎯犵殑链?
	* @return 链?
	**/
	public function GetGoods_tag()
	{
		return $this->values["goods_tag"];
	}

	/**
	* 鍒ゆ柇鍟嗗搧镙囱锛屼唬閲戝埜鎴栫珛鍑忎紭鎯犲姛鑳界殑鍙傛暟锛岃鏄庤瑙佷唬閲戝埜鎴栫珛鍑忎紭鎯犳槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsGoods_tagSet()
	{
		return array_key_exists("goods_tag", $this->values);
	}

	/**
	* 璁剧疆鎺ユ敹寰俊鏀粯寮傛阃氱煡锲炶皟鍦板潃
	* @param string $value 
	**/
	public function SetNotify_url($value)
	{
		$this->values["notify_url"] = $value;
	}

	/**
	* 銮峰彇鎺ユ敹寰俊鏀粯寮傛阃氱煡锲炶皟鍦板潃镄勫EUR?
	* @return 链?
	**/
	public function GetNotify_url()
	{
		return $this->values["notify_url"];
	}

	/**
	* 鍒ゆ柇鎺ユ敹寰俊鏀粯寮傛阃氱煡锲炶皟鍦板潃鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsNotify_urlSet()
	{
		return array_key_exists("notify_url", $this->values);
	}

	/**
	* 璁剧疆鍙栧EUR煎涓嬶细JSAPI锛孨ATIVE锛孉PP锛岃缁呜鏄庤鍙傛暟瑙勫畾
	* @param string $value 
	**/
	public function SetTrade_type($value)
	{
		$this->values["trade_type"] = $value;
	}

	/**
	* 銮峰彇鍙栧EUR煎涓嬶细JSAPI锛孨ATIVE锛孉PP锛岃缁呜鏄庤鍙傛暟瑙勫畾镄勫EUR?
	* @return 链?
	**/
	public function GetTrade_type()
	{
		return $this->values["trade_type"];
	}

	/**
	* 鍒ゆ柇鍙栧EUR煎涓嬶细JSAPI锛孨ATIVE锛孉PP锛岃缁呜鏄庤鍙傛暟瑙勫畾鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsTrade_typeSet()
	{
		return array_key_exists("trade_type", $this->values);
	}

	/**
	* 璁剧疆trade_type=NATIVE锛屾鍙傛暟蹇呬紶銆傛id涓轰簩缁寸爜涓寘鍚殑鍟嗗搧ID锛屽晢鎴疯嚜琛屽畾涔夈EUR?
	* @param string $value 
	**/
	public function SetProduct_id($value)
	{
		$this->values["product_id"] = $value;
	}

	/**
	* 銮峰彇trade_type=NATIVE锛屾鍙傛暟蹇呬紶銆傛id涓轰簩缁寸爜涓寘鍚殑鍟嗗搧ID锛屽晢鎴疯嚜琛屽畾涔夈EUR傜殑链?
	* @return 链?
	**/
	public function GetProduct_id()
	{
		return $this->values["product_id"];
	}

	/**
	* 鍒ゆ柇trade_type=NATIVE锛屾鍙傛暟蹇呬紶銆傛id涓轰簩缁寸爜涓寘鍚殑鍟嗗搧ID锛屽晢鎴疯嚜琛屽畾涔夈EUR傛槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsProduct_idSet()
	{
		return array_key_exists("product_id", $this->values);
	}

	/**
	* 璁剧疆trade_type=JSAPI锛屾鍙傛暟蹇呬紶锛岀敤鎴峰湪鍟嗘埛appid涓嬬殑鍞竴镙囱瘑銆备笅鍗曞墠闇EUR瑕佽皟鐢ㄣEUR愮綉椤垫巿鏉冭幏鍙栫敤鎴蜂俊鎭EUR戞帴鍙ｈ幏鍙栧埌鐢ㄦ埛镄凮penid銆?
	* @param string $value 
	**/
	public function SetOpenid($value)
	{
		$this->values["openid"] = $value;
	}

	/**
	* 銮峰彇trade_type=JSAPI锛屾鍙傛暟蹇呬紶锛岀敤鎴峰湪鍟嗘埛appid涓嬬殑鍞竴镙囱瘑銆备笅鍗曞墠闇EUR瑕佽皟鐢ㄣEUR愮綉椤垫巿鏉冭幏鍙栫敤鎴蜂俊鎭EUR戞帴鍙ｈ幏鍙栧埌鐢ㄦ埛镄凮penid銆?镄勫EUR?
	* @return 链?
	**/
	public function GetOpenid()
	{
		return $this->values["openid"];
	}

	/**
	* 鍒ゆ柇trade_type=JSAPI锛屾鍙傛暟蹇呬紶锛岀敤鎴峰湪鍟嗘埛appid涓嬬殑鍞竴镙囱瘑銆备笅鍗曞墠闇EUR瑕佽皟鐢ㄣEUR愮綉椤垫巿鏉冭幏鍙栫敤鎴蜂俊鎭EUR戞帴鍙ｈ幏鍙栧埌鐢ㄦ埛镄凮penid銆?鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsOpenidSet()
	{
		return array_key_exists("openid", $this->values);
	}
}

/**
 * 
 * 璁㈠崟镆ヨ杈揿叆瀵硅薄
 * @author widyhu
 *
 */
class WxPayOrderQuery extends WxPayDataBase
{

	/**
	* 璁剧疆寰俊鍒嗛厤镄勫叕浼楄处鍙稩D
	* @param string $value 
	**/
	public function SetAppid($value)
	{
		$this->values["appid"] = $value;
	}

	/**
	* 銮峰彇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D镄勫EUR?
	* @return 链?
	**/
	public function GetAppid()
	{
		return $this->values["appid"];
	}

	/**
	* 鍒ゆ柇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsAppidSet()
	{
		return array_key_exists("appid", $this->values);
	}

	/**
	* 璁剧疆寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛
	* @param string $value 
	**/
	public function SetMch_id($value)
	{
		$this->values["mch_id"] = $value;
	}

	/**
	* 銮峰彇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛镄勫EUR?
	* @return 链?
	**/
	public function GetMch_id()
	{
		return $this->values["mch_id"];
	}

	/**
	* 鍒ゆ柇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsMch_idSet()
	{
		return array_key_exists("mch_id", $this->values);
	}

	/**
	* 璁剧疆寰俊镄勮鍗曞佛锛屼紭鍏堜娇鐢?
	* @param string $value 
	**/
	public function SetTransaction_id($value)
	{
		$this->values["transaction_id"] = $value;
	}

	/**
	* 銮峰彇寰俊镄勮鍗曞佛锛屼紭鍏堜娇鐢ㄧ殑链?
	* @return 链?
	**/
	public function GetTransaction_id()
	{
		return $this->values["transaction_id"];
	}

	/**
	* 鍒ゆ柇寰俊镄勮鍗曞佛锛屼紭鍏堜娇鐢ㄦ槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsTransaction_idSet()
	{
		return array_key_exists("transaction_id", $this->values);
	}

	/**
	* 璁剧疆鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛锛屽綋娌℃彁渚泃ransaction_id镞堕渶瑕佷紶杩欎釜銆?
	* @param string $value 
	**/
	public function SetOut_trade_no($value)
	{
		$this->values["out_trade_no"] = $value;
	}

	/**
	* 銮峰彇鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛锛屽綋娌℃彁渚泃ransaction_id镞堕渶瑕佷紶杩欎釜銆傜殑链?
	* @return 链?
	**/
	public function GetOut_trade_no()
	{
		return $this->values["out_trade_no"];
	}

	/**
	* 鍒ゆ柇鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛锛屽綋娌℃彁渚泃ransaction_id镞堕渶瑕佷紶杩欎釜銆傛槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsOut_trade_noSet()
	{
		return array_key_exists("out_trade_no", $this->values);
	}

	/**
	* 璁剧疆闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶
	* @param string $value 
	**/
	public function SetNonce_str($value)
	{
		$this->values["nonce_str"] = $value;
	}

	/**
	* 銮峰彇闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶镄勫EUR?
	* @return 链?
	**/
	public function GetNonce_str()
	{
		return $this->values["nonce_str"];
	}

	/**
	* 鍒ゆ柇闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsNonce_strSet()
	{
		return array_key_exists("nonce_str", $this->values);
	}
}

/**
 * 
 * 鍏抽棴璁㈠崟杈揿叆瀵硅薄
 * @author widyhu
 *
 */
class WxPayCloseOrder extends WxPayDataBase
{

	/**
	* 璁剧疆寰俊鍒嗛厤镄勫叕浼楄处鍙稩D
	* @param string $value 
	**/
	public function SetAppid($value)
	{
		$this->values["appid"] = $value;
	}

	/**
	* 銮峰彇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D镄勫EUR?
	* @return 链?
	**/
	public function GetAppid()
	{
		return $this->values["appid"];
	}

	/**
	* 鍒ゆ柇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsAppidSet()
	{
		return array_key_exists("appid", $this->values);
	}

	/**
	* 璁剧疆寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛
	* @param string $value 
	**/
	public function SetMch_id($value)
	{
		$this->values["mch_id"] = $value;
	}

	/**
	* 銮峰彇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛镄勫EUR?
	* @return 链?
	**/
	public function GetMch_id()
	{
		return $this->values["mch_id"];
	}

	/**
	* 鍒ゆ柇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsMch_idSet()
	{
		return array_key_exists("mch_id", $this->values);
	}

	/**
	* 璁剧疆鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛
	* @param string $value 
	**/
	public function SetOut_trade_no($value)
	{
		$this->values["out_trade_no"] = $value;
	}

	/**
	* 銮峰彇鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛镄勫EUR?
	* @return 链?
	**/
	public function GetOut_trade_no()
	{
		return $this->values["out_trade_no"];
	}

	/**
	* 鍒ゆ柇鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsOut_trade_noSet()
	{
		return array_key_exists("out_trade_no", $this->values);
	}

	/**
	* 璁剧疆鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛,32涓瓧绗﹀唴銆佸彲鍖呭惈瀛楁瘝, 鍏朵粬璇存槑瑙佸晢鎴疯鍗曞佛
	* @param string $value 
	**/
	public function SetNonce_str($value)
	{
		$this->values["nonce_str"] = $value;
	}

	/**
	* 銮峰彇鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛,32涓瓧绗﹀唴銆佸彲鍖呭惈瀛楁瘝, 鍏朵粬璇存槑瑙佸晢鎴疯鍗曞佛镄勫EUR?
	* @return 链?
	**/
	public function GetNonce_str()
	{
		return $this->values["nonce_str"];
	}

	/**
	* 鍒ゆ柇鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛,32涓瓧绗﹀唴銆佸彲鍖呭惈瀛楁瘝, 鍏朵粬璇存槑瑙佸晢鎴疯鍗曞佛鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsNonce_strSet()
	{
		return array_key_exists("nonce_str", $this->values);
	}
}

/**
 * 
 * 鎻愪氦阃EUR娆捐緭鍏ュ璞?
 * @author widyhu
 *
 */
class WxPayRefund extends WxPayDataBase
{

	/**
	* 璁剧疆寰俊鍒嗛厤镄勫叕浼楄处鍙稩D
	* @param string $value 
	**/
	public function SetAppid($value)
	{
		$this->values["appid"] = $value;
	}

	/**
	* 銮峰彇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D镄勫EUR?
	* @return 链?
	**/
	public function GetAppid()
	{
		return $this->values["appid"];
	}

	/**
	* 鍒ゆ柇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsAppidSet()
	{
		return array_key_exists("appid", $this->values);
	}

	/**
	* 璁剧疆寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛
	* @param string $value 
	**/
	public function SetMch_id($value)
	{
		$this->values["mch_id"] = $value;
	}

	/**
	* 銮峰彇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛镄勫EUR?
	* @return 链?
	**/
	public function GetMch_id()
	{
		return $this->values["mch_id"];
	}

	/**
	* 鍒ゆ柇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsMch_idSet()
	{
		return array_key_exists("mch_id", $this->values);
	}

	/**
	* 璁剧疆寰俊鏀粯鍒嗛厤镄勭粓绔澶囧佛锛屼笌涓嫔崟涓EUR镊?
	* @param string $value 
	**/
	public function SetDevice_info($value)
	{
		$this->values["device_info"] = $value;
	}

	/**
	* 銮峰彇寰俊鏀粯鍒嗛厤镄勭粓绔澶囧佛锛屼笌涓嫔崟涓EUR镊寸殑链?
	* @return 链?
	**/
	public function GetDevice_info()
	{
		return $this->values["device_info"];
	}

	/**
	* 鍒ゆ柇寰俊鏀粯鍒嗛厤镄勭粓绔澶囧佛锛屼笌涓嫔崟涓EUR镊存槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsDevice_infoSet()
	{
		return array_key_exists("device_info", $this->values);
	}

	/**
	* 璁剧疆闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶
	* @param string $value 
	**/
	public function SetNonce_str($value)
	{
		$this->values["nonce_str"] = $value;
	}

	/**
	* 銮峰彇闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶镄勫EUR?
	* @return 链?
	**/
	public function GetNonce_str()
	{
		return $this->values["nonce_str"];
	}

	/**
	* 鍒ゆ柇闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsNonce_strSet()
	{
		return array_key_exists("nonce_str", $this->values);
	}

	/**
	* 璁剧疆寰俊璁㈠崟鍙?
	* @param string $value 
	**/
	public function SetTransaction_id($value)
	{
		$this->values["transaction_id"] = $value;
	}

	/**
	* 銮峰彇寰俊璁㈠崟鍙风殑链?
	* @return 链?
	**/
	public function GetTransaction_id()
	{
		return $this->values["transaction_id"];
	}

	/**
	* 鍒ゆ柇寰俊璁㈠崟鍙锋槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsTransaction_idSet()
	{
		return array_key_exists("transaction_id", $this->values);
	}

	/**
	* 璁剧疆鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛,transaction_id銆乷ut_trade_no浜岄EUR変竴锛屽鏋滃悓镞跺瓨鍦ㄤ紭鍏堢骇锛歵ransaction_id> out_trade_no
	* @param string $value 
	**/
	public function SetOut_trade_no($value)
	{
		$this->values["out_trade_no"] = $value;
	}

	/**
	* 銮峰彇鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛,transaction_id銆乷ut_trade_no浜岄EUR変竴锛屽鏋滃悓镞跺瓨鍦ㄤ紭鍏堢骇锛歵ransaction_id> out_trade_no镄勫EUR?
	* @return 链?
	**/
	public function GetOut_trade_no()
	{
		return $this->values["out_trade_no"];
	}

	/**
	* 鍒ゆ柇鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛,transaction_id銆乷ut_trade_no浜岄EUR変竴锛屽鏋滃悓镞跺瓨鍦ㄤ紭鍏堢骇锛歵ransaction_id> out_trade_no鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsOut_trade_noSet()
	{
		return array_key_exists("out_trade_no", $this->values);
	}

	/**
	* 璁剧疆鍟嗘埛绯荤粺鍐呴儴镄勯EUREUR娆惧崟鍙凤紝鍟嗘埛绯荤粺鍐呴儴鍞竴锛屽悓涓EUR阃EUR娆惧崟鍙峰娆¤姹傚彧阃EUR涓EUR绗?
	* @param string $value 
	**/
	public function SetOut_refund_no($value)
	{
		$this->values["out_refund_no"] = $value;
	}

	/**
	* 銮峰彇鍟嗘埛绯荤粺鍐呴儴镄勯EUREUR娆惧崟鍙凤紝鍟嗘埛绯荤粺鍐呴儴鍞竴锛屽悓涓EUR阃EUR娆惧崟鍙峰娆¤姹傚彧阃EUR涓EUR绗旗殑链?
	* @return 链?
	**/
	public function GetOut_refund_no()
	{
		return $this->values["out_refund_no"];
	}

	/**
	* 鍒ゆ柇鍟嗘埛绯荤粺鍐呴儴镄勯EUREUR娆惧崟鍙凤紝鍟嗘埛绯荤粺鍐呴儴鍞竴锛屽悓涓EUR阃EUR娆惧崟鍙峰娆¤姹傚彧阃EUR涓EUR绗旀槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsOut_refund_noSet()
	{
		return array_key_exists("out_refund_no", $this->values);
	}

	/**
	* 璁剧疆璁㈠崟镐婚噾棰濓紝鍗曚綅涓哄垎锛屽彧鑳戒负鏁存暟锛岃瑙佹敮浠橀噾棰?
	* @param string $value 
	**/
	public function SetTotal_fee($value)
	{
		$this->values["total_fee"] = $value;
	}

	/**
	* 銮峰彇璁㈠崟镐婚噾棰濓紝鍗曚綅涓哄垎锛屽彧鑳戒负鏁存暟锛岃瑙佹敮浠橀噾棰濈殑链?
	* @return 链?
	**/
	public function GetTotal_fee()
	{
		return $this->values["total_fee"];
	}

	/**
	* 鍒ゆ柇璁㈠崟镐婚噾棰濓紝鍗曚綅涓哄垎锛屽彧鑳戒负鏁存暟锛岃瑙佹敮浠橀噾棰濇槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsTotal_feeSet()
	{
		return array_key_exists("total_fee", $this->values);
	}

	/**
	* 璁剧疆阃EUR娆炬EUR婚噾棰濓紝璁㈠崟镐婚噾棰濓紝鍗曚綅涓哄垎锛屽彧鑳戒负鏁存暟锛岃瑙佹敮浠橀噾棰?
	* @param string $value 
	**/
	public function SetRefund_fee($value)
	{
		$this->values["refund_fee"] = $value;
	}

	/**
	* 銮峰彇阃EUR娆炬EUR婚噾棰濓紝璁㈠崟镐婚噾棰濓紝鍗曚綅涓哄垎锛屽彧鑳戒负鏁存暟锛岃瑙佹敮浠橀噾棰濈殑链?
	* @return 链?
	**/
	public function GetRefund_fee()
	{
		return $this->values["refund_fee"];
	}

	/**
	* 鍒ゆ柇阃EUR娆炬EUR婚噾棰濓紝璁㈠崟镐婚噾棰濓紝鍗曚綅涓哄垎锛屽彧鑳戒负鏁存暟锛岃瑙佹敮浠橀噾棰濇槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsRefund_feeSet()
	{
		return array_key_exists("refund_fee", $this->values);
	}

	/**
	* 璁剧疆璐у竵绫诲瀷锛岀鍚圛SO 4217镙囧嗳镄勪笁浣嶅瓧姣崭唬镰侊紝榛樿浜烘皯甯侊细CNY锛屽叾浠栧EUR煎垪琛ㄨ瑙佽揣甯佺被鍨?
	* @param string $value 
	**/
	public function SetRefund_fee_type($value)
	{
		$this->values["refund_fee_type"] = $value;
	}

	/**
	* 銮峰彇璐у竵绫诲瀷锛岀鍚圛SO 4217镙囧嗳镄勪笁浣嶅瓧姣崭唬镰侊紝榛樿浜烘皯甯侊细CNY锛屽叾浠栧EUR煎垪琛ㄨ瑙佽揣甯佺被鍨嬬殑链?
	* @return 链?
	**/
	public function GetRefund_fee_type()
	{
		return $this->values["refund_fee_type"];
	}

	/**
	* 鍒ゆ柇璐у竵绫诲瀷锛岀鍚圛SO 4217镙囧嗳镄勪笁浣嶅瓧姣崭唬镰侊紝榛樿浜烘皯甯侊细CNY锛屽叾浠栧EUR煎垪琛ㄨ瑙佽揣甯佺被鍨嬫槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsRefund_fee_typeSet()
	{
		return array_key_exists("refund_fee_type", $this->values);
	}

	/**
	* 璁剧疆鎿崭綔锻桦笎鍙? 榛樿涓哄晢鎴峰佛
	* @param string $value 
	**/
	public function SetOp_user_id($value)
	{
		$this->values["op_user_id"] = $value;
	}

	/**
	* 銮峰彇鎿崭綔锻桦笎鍙? 榛樿涓哄晢鎴峰佛镄勫EUR?
	* @return 链?
	**/
	public function GetOp_user_id()
	{
		return $this->values["op_user_id"];
	}

	/**
	* 鍒ゆ柇鎿崭綔锻桦笎鍙? 榛樿涓哄晢鎴峰佛鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsOp_user_idSet()
	{
		return array_key_exists("op_user_id", $this->values);
	}
}

/**
 * 
 * 阃EUR娆炬煡璇㈣緭鍏ュ璞?
 * @author widyhu
 *
 */
class WxPayRefundQuery extends WxPayDataBase
{

	/**
	* 璁剧疆寰俊鍒嗛厤镄勫叕浼楄处鍙稩D
	* @param string $value 
	**/
	public function SetAppid($value)
	{
		$this->values["appid"] = $value;
	}

	/**
	* 銮峰彇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D镄勫EUR?
	* @return 链?
	**/
	public function GetAppid()
	{
		return $this->values["appid"];
	}

	/**
	* 鍒ゆ柇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsAppidSet()
	{
		return array_key_exists("appid", $this->values);
	}

	/**
	* 璁剧疆寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛
	* @param string $value 
	**/
	public function SetMch_id($value)
	{
		$this->values["mch_id"] = $value;
	}

	/**
	* 銮峰彇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛镄勫EUR?
	* @return 链?
	**/
	public function GetMch_id()
	{
		return $this->values["mch_id"];
	}

	/**
	* 鍒ゆ柇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsMch_idSet()
	{
		return array_key_exists("mch_id", $this->values);
	}

	/**
	* 璁剧疆寰俊鏀粯鍒嗛厤镄勭粓绔澶囧佛
	* @param string $value 
	**/
	public function SetDevice_info($value)
	{
		$this->values["device_info"] = $value;
	}

	/**
	* 銮峰彇寰俊鏀粯鍒嗛厤镄勭粓绔澶囧佛镄勫EUR?
	* @return 链?
	**/
	public function GetDevice_info()
	{
		return $this->values["device_info"];
	}

	/**
	* 鍒ゆ柇寰俊鏀粯鍒嗛厤镄勭粓绔澶囧佛鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsDevice_infoSet()
	{
		return array_key_exists("device_info", $this->values);
	}

	/**
	* 璁剧疆闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶
	* @param string $value 
	**/
	public function SetNonce_str($value)
	{
		$this->values["nonce_str"] = $value;
	}

	/**
	* 銮峰彇闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶镄勫EUR?
	* @return 链?
	**/
	public function GetNonce_str()
	{
		return $this->values["nonce_str"];
	}

	/**
	* 鍒ゆ柇闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsNonce_strSet()
	{
		return array_key_exists("nonce_str", $this->values);
	}

	/**
	* 璁剧疆寰俊璁㈠崟鍙?
	* @param string $value 
	**/
	public function SetTransaction_id($value)
	{
		$this->values["transaction_id"] = $value;
	}

	/**
	* 銮峰彇寰俊璁㈠崟鍙风殑链?
	* @return 链?
	**/
	public function GetTransaction_id()
	{
		return $this->values["transaction_id"];
	}

	/**
	* 鍒ゆ柇寰俊璁㈠崟鍙锋槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsTransaction_idSet()
	{
		return array_key_exists("transaction_id", $this->values);
	}

	/**
	* 璁剧疆鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛
	* @param string $value 
	**/
	public function SetOut_trade_no($value)
	{
		$this->values["out_trade_no"] = $value;
	}

	/**
	* 銮峰彇鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛镄勫EUR?
	* @return 链?
	**/
	public function GetOut_trade_no()
	{
		return $this->values["out_trade_no"];
	}

	/**
	* 鍒ゆ柇鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsOut_trade_noSet()
	{
		return array_key_exists("out_trade_no", $this->values);
	}

	/**
	* 璁剧疆鍟嗘埛阃EUR娆惧崟鍙?
	* @param string $value 
	**/
	public function SetOut_refund_no($value)
	{
		$this->values["out_refund_no"] = $value;
	}

	/**
	* 銮峰彇鍟嗘埛阃EUR娆惧崟鍙风殑链?
	* @return 链?
	**/
	public function GetOut_refund_no()
	{
		return $this->values["out_refund_no"];
	}

	/**
	* 鍒ゆ柇鍟嗘埛阃EUR娆惧崟鍙锋槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsOut_refund_noSet()
	{
		return array_key_exists("out_refund_no", $this->values);
	}

	/**
	* 璁剧疆寰俊阃EUR娆惧崟鍙穜efund_id銆乷ut_refund_no銆乷ut_trade_no銆乼ransaction_id锲涗釜鍙傛暟蹇呭～涓EUR涓紝濡傛灉鍚屾椂瀛桦湪浼桦厛绾т负锛歳efund_id>out_refund_no>transaction_id>out_trade_no
	* @param string $value 
	**/
	public function SetRefund_id($value)
	{
		$this->values["refund_id"] = $value;
	}

	/**
	* 銮峰彇寰俊阃EUR娆惧崟鍙穜efund_id銆乷ut_refund_no銆乷ut_trade_no銆乼ransaction_id锲涗釜鍙傛暟蹇呭～涓EUR涓紝濡傛灉鍚屾椂瀛桦湪浼桦厛绾т负锛歳efund_id>out_refund_no>transaction_id>out_trade_no镄勫EUR?
	* @return 链?
	**/
	public function GetRefund_id()
	{
		return $this->values["refund_id"];
	}

	/**
	* 鍒ゆ柇寰俊阃EUR娆惧崟鍙穜efund_id銆乷ut_refund_no銆乷ut_trade_no銆乼ransaction_id锲涗釜鍙傛暟蹇呭～涓EUR涓紝濡傛灉鍚屾椂瀛桦湪浼桦厛绾т负锛歳efund_id>out_refund_no>transaction_id>out_trade_no鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsRefund_idSet()
	{
		return array_key_exists("refund_id", $this->values);
	}
}

/**
 * 
 * 涓嬭浇瀵硅处鍗曡緭鍏ュ璞?
 * @author widyhu
 *
 */
class WxPayDownloadBill extends WxPayDataBase
{

	/**
	* 璁剧疆寰俊鍒嗛厤镄勫叕浼楄处鍙稩D
	* @param string $value 
	**/
	public function SetAppid($value)
	{
		$this->values["appid"] = $value;
	}

	/**
	* 銮峰彇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D镄勫EUR?
	* @return 链?
	**/
	public function GetAppid()
	{
		return $this->values["appid"];
	}

	/**
	* 鍒ゆ柇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsAppidSet()
	{
		return array_key_exists("appid", $this->values);
	}

	/**
	* 璁剧疆寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛
	* @param string $value 
	**/
	public function SetMch_id($value)
	{
		$this->values["mch_id"] = $value;
	}

	/**
	* 銮峰彇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛镄勫EUR?
	* @return 链?
	**/
	public function GetMch_id()
	{
		return $this->values["mch_id"];
	}

	/**
	* 鍒ゆ柇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsMch_idSet()
	{
		return array_key_exists("mch_id", $this->values);
	}

	/**
	* 璁剧疆寰俊鏀粯鍒嗛厤镄勭粓绔澶囧佛锛屽～鍐欐瀛楁锛屽彧涓嬭浇璇ヨ澶囧佛镄勫璐﹀崟
	* @param string $value 
	**/
	public function SetDevice_info($value)
	{
		$this->values["device_info"] = $value;
	}

	/**
	* 銮峰彇寰俊鏀粯鍒嗛厤镄勭粓绔澶囧佛锛屽～鍐欐瀛楁锛屽彧涓嬭浇璇ヨ澶囧佛镄勫璐﹀崟镄勫EUR?
	* @return 链?
	**/
	public function GetDevice_info()
	{
		return $this->values["device_info"];
	}

	/**
	* 鍒ゆ柇寰俊鏀粯鍒嗛厤镄勭粓绔澶囧佛锛屽～鍐欐瀛楁锛屽彧涓嬭浇璇ヨ澶囧佛镄勫璐﹀崟鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsDevice_infoSet()
	{
		return array_key_exists("device_info", $this->values);
	}

	/**
	* 璁剧疆闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶
	* @param string $value 
	**/
	public function SetNonce_str($value)
	{
		$this->values["nonce_str"] = $value;
	}

	/**
	* 銮峰彇闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶镄勫EUR?
	* @return 链?
	**/
	public function GetNonce_str()
	{
		return $this->values["nonce_str"];
	}

	/**
	* 鍒ゆ柇闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsNonce_strSet()
	{
		return array_key_exists("nonce_str", $this->values);
	}

	/**
	* 璁剧疆涓嬭浇瀵硅处鍗旷殑镞ユ湡锛屾牸寮忥细20140603
	* @param string $value 
	**/
	public function SetBill_date($value)
	{
		$this->values["bill_date"] = $value;
	}

	/**
	* 銮峰彇涓嬭浇瀵硅处鍗旷殑镞ユ湡锛屾牸寮忥细20140603镄勫EUR?
	* @return 链?
	**/
	public function GetBill_date()
	{
		return $this->values["bill_date"];
	}

	/**
	* 鍒ゆ柇涓嬭浇瀵硅处鍗旷殑镞ユ湡锛屾牸寮忥细20140603鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsBill_dateSet()
	{
		return array_key_exists("bill_date", $this->values);
	}

	/**
	* 璁剧疆ALL锛岃繑锲炲綋镞ユ墍链夎鍗曚俊鎭紝榛樿链粪UCCESS锛岃繑锲炲綋镞ユ垚锷熸敮浠樼殑璁㈠崟REFUND锛岃繑锲炲綋镞ラEUREUR娆捐鍗昍EVOKED锛屽凡鎾ら攒镄勮鍗?
	* @param string $value 
	**/
	public function SetBill_type($value)
	{
		$this->values["bill_type"] = $value;
	}

	/**
	* 銮峰彇ALL锛岃繑锲炲綋镞ユ墍链夎鍗曚俊鎭紝榛樿链粪UCCESS锛岃繑锲炲綋镞ユ垚锷熸敮浠樼殑璁㈠崟REFUND锛岃繑锲炲綋镞ラEUREUR娆捐鍗昍EVOKED锛屽凡鎾ら攒镄勮鍗旷殑链?
	* @return 链?
	**/
	public function GetBill_type()
	{
		return $this->values["bill_type"];
	}

	/**
	* 鍒ゆ柇ALL锛岃繑锲炲綋镞ユ墍链夎鍗曚俊鎭紝榛樿链粪UCCESS锛岃繑锲炲綋镞ユ垚锷熸敮浠樼殑璁㈠崟REFUND锛岃繑锲炲綋镞ラEUREUR娆捐鍗昍EVOKED锛屽凡鎾ら攒镄勮鍗曟槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsBill_typeSet()
	{
		return array_key_exists("bill_type", $this->values);
	}
}

/**
 * 
 * 娴嬮EUR熶笂鎶ヨ緭鍏ュ璞?
 * @author widyhu
 *
 */
class WxPayReport extends WxPayDataBase
{

	/**
	* 璁剧疆寰俊鍒嗛厤镄勫叕浼楄处鍙稩D
	* @param string $value 
	**/
	public function SetAppid($value)
	{
		$this->values["appid"] = $value;
	}

	/**
	* 銮峰彇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D镄勫EUR?
	* @return 链?
	**/
	public function GetAppid()
	{
		return $this->values["appid"];
	}

	/**
	* 鍒ゆ柇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsAppidSet()
	{
		return array_key_exists("appid", $this->values);
	}

	/**
	* 璁剧疆寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛
	* @param string $value 
	**/
	public function SetMch_id($value)
	{
		$this->values["mch_id"] = $value;
	}

	/**
	* 銮峰彇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛镄勫EUR?
	* @return 链?
	**/
	public function GetMch_id()
	{
		return $this->values["mch_id"];
	}

	/**
	* 鍒ゆ柇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsMch_idSet()
	{
		return array_key_exists("mch_id", $this->values);
	}

	/**
	* 璁剧疆寰俊鏀粯鍒嗛厤镄勭粓绔澶囧佛锛屽晢鎴疯嚜瀹氢箟
	* @param string $value 
	**/
	public function SetDevice_info($value)
	{
		$this->values["device_info"] = $value;
	}

	/**
	* 銮峰彇寰俊鏀粯鍒嗛厤镄勭粓绔澶囧佛锛屽晢鎴疯嚜瀹氢箟镄勫EUR?
	* @return 链?
	**/
	public function GetDevice_info()
	{
		return $this->values["device_info"];
	}

	/**
	* 鍒ゆ柇寰俊鏀粯鍒嗛厤镄勭粓绔澶囧佛锛屽晢鎴疯嚜瀹氢箟鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsDevice_infoSet()
	{
		return array_key_exists("device_info", $this->values);
	}

	/**
	* 璁剧疆闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶
	* @param string $value 
	**/
	public function SetNonce_str($value)
	{
		$this->values["nonce_str"] = $value;
	}

	/**
	* 銮峰彇闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶镄勫EUR?
	* @return 链?
	**/
	public function GetNonce_str()
	{
		return $this->values["nonce_str"];
	}

	/**
	* 鍒ゆ柇闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsNonce_strSet()
	{
		return array_key_exists("nonce_str", $this->values);
	}

	/**
	* 璁剧疆涓婃姤瀵瑰簲镄勬帴鍙ｇ殑瀹屾暣URL锛岀被浼硷细https://api.mch.weixin.qq.com/pay/unifiedorder瀵逛簬琚壂鏀粯锛屼负镟村ソ镄勫拰鍟嗘埛鍏卞悓鍒嗘瀽涓EUR娆′笟锷¤涓虹殑鏁翠綋钥楁椂鎯呭喌锛屽浜庝袱绉嶆帴鍏ユā寮忥紝璇烽兘鍦ㄩ棬搴椾晶瀵逛竴娆¤镓涓鸿繘琛屼竴娆″崟镫殑鏁翠綋涓婃姤锛屼笂鎶RL鎸囧畾涓猴细https://api.mch.weixin.qq.com/pay/micropay/total鍏充簬涓ょ鎺ュ叆妯″纺鍏蜂綋鍙弬钥冩湰鏂囨。绔犺妭锛氲镓敮浠桦晢鎴锋帴鍏ユā寮忓叾瀹冩帴鍙ｈ皟鐢ㄤ粛铹舵寜镦ц皟鐢ㄤ竴娆★紝涓婃姤涓EUR娆℃潵杩涜銆?
	* @param string $value 
	**/
	public function SetInterface_url($value)
	{
		$this->values["interface_url"] = $value;
	}

	/**
	* 銮峰彇涓婃姤瀵瑰簲镄勬帴鍙ｇ殑瀹屾暣URL锛岀被浼硷细https://api.mch.weixin.qq.com/pay/unifiedorder瀵逛簬琚壂鏀粯锛屼负镟村ソ镄勫拰鍟嗘埛鍏卞悓鍒嗘瀽涓EUR娆′笟锷¤涓虹殑鏁翠綋钥楁椂鎯呭喌锛屽浜庝袱绉嶆帴鍏ユā寮忥紝璇烽兘鍦ㄩ棬搴椾晶瀵逛竴娆¤镓涓鸿繘琛屼竴娆″崟镫殑鏁翠綋涓婃姤锛屼笂鎶RL鎸囧畾涓猴细https://api.mch.weixin.qq.com/pay/micropay/total鍏充簬涓ょ鎺ュ叆妯″纺鍏蜂綋鍙弬钥冩湰鏂囨。绔犺妭锛氲镓敮浠桦晢鎴锋帴鍏ユā寮忓叾瀹冩帴鍙ｈ皟鐢ㄤ粛铹舵寜镦ц皟鐢ㄤ竴娆★紝涓婃姤涓EUR娆℃潵杩涜銆傜殑链?
	* @return 链?
	**/
	public function GetInterface_url()
	{
		return $this->values["interface_url"];
	}

	/**
	* 鍒ゆ柇涓婃姤瀵瑰簲镄勬帴鍙ｇ殑瀹屾暣URL锛岀被浼硷细https://api.mch.weixin.qq.com/pay/unifiedorder瀵逛簬琚壂鏀粯锛屼负镟村ソ镄勫拰鍟嗘埛鍏卞悓鍒嗘瀽涓EUR娆′笟锷¤涓虹殑鏁翠綋钥楁椂鎯呭喌锛屽浜庝袱绉嶆帴鍏ユā寮忥紝璇烽兘鍦ㄩ棬搴椾晶瀵逛竴娆¤镓涓鸿繘琛屼竴娆″崟镫殑鏁翠綋涓婃姤锛屼笂鎶RL鎸囧畾涓猴细https://api.mch.weixin.qq.com/pay/micropay/total鍏充簬涓ょ鎺ュ叆妯″纺鍏蜂綋鍙弬钥冩湰鏂囨。绔犺妭锛氲镓敮浠桦晢鎴锋帴鍏ユā寮忓叾瀹冩帴鍙ｈ皟鐢ㄤ粛铹舵寜镦ц皟鐢ㄤ竴娆★紝涓婃姤涓EUR娆℃潵杩涜銆傛槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsInterface_urlSet()
	{
		return array_key_exists("interface_url", $this->values);
	}

	/**
	* 璁剧疆鎺ュ彛钥楁椂鎯呭喌锛屽崟浣崭负姣
	* @param string $value 
	**/
	public function SetExecute_time_($value)
	{
		$this->values["execute_time_"] = $value;
	}

	/**
	* 銮峰彇鎺ュ彛钥楁椂鎯呭喌锛屽崟浣崭负姣镄勫EUR?
	* @return 链?
	**/
	public function GetExecute_time_()
	{
		return $this->values["execute_time_"];
	}

	/**
	* 鍒ゆ柇鎺ュ彛钥楁椂鎯呭喌锛屽崟浣崭负姣鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsExecute_time_Set()
	{
		return array_key_exists("execute_time_", $this->values);
	}

	/**
	* 璁剧疆SUCCESS/FAIL姝ゅ瓧娈垫槸阃氢俊镙囱瘑锛岄潪浜ゆ槗镙囱瘑锛屼氦鏄撴槸鍚︽垚锷熼渶瑕佹煡鐪媡rade_state鏉ュ垽鏂?
	* @param string $value 
	**/
	public function SetReturn_code($value)
	{
		$this->values["return_code"] = $value;
	}

	/**
	* 銮峰彇SUCCESS/FAIL姝ゅ瓧娈垫槸阃氢俊镙囱瘑锛岄潪浜ゆ槗镙囱瘑锛屼氦鏄撴槸鍚︽垚锷熼渶瑕佹煡鐪媡rade_state鏉ュ垽鏂殑链?
	* @return 链?
	**/
	public function GetReturn_code()
	{
		return $this->values["return_code"];
	}

	/**
	* 鍒ゆ柇SUCCESS/FAIL姝ゅ瓧娈垫槸阃氢俊镙囱瘑锛岄潪浜ゆ槗镙囱瘑锛屼氦鏄撴槸鍚︽垚锷熼渶瑕佹煡鐪媡rade_state鏉ュ垽鏂槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsReturn_codeSet()
	{
		return array_key_exists("return_code", $this->values);
	}

	/**
	* 璁剧疆杩斿洖淇℃伅锛屽闱炵┖锛屼负阌栾铡熷洜绛惧悕澶辫触鍙傛暟镙煎纺镙￠獙阌栾
	* @param string $value 
	**/
	public function SetReturn_msg($value)
	{
		$this->values["return_msg"] = $value;
	}

	/**
	* 銮峰彇杩斿洖淇℃伅锛屽闱炵┖锛屼负阌栾铡熷洜绛惧悕澶辫触鍙傛暟镙煎纺镙￠獙阌栾镄勫EUR?
	* @return 链?
	**/
	public function GetReturn_msg()
	{
		return $this->values["return_msg"];
	}

	/**
	* 鍒ゆ柇杩斿洖淇℃伅锛屽闱炵┖锛屼负阌栾铡熷洜绛惧悕澶辫触鍙傛暟镙煎纺镙￠獙阌栾鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsReturn_msgSet()
	{
		return array_key_exists("return_msg", $this->values);
	}

	/**
	* 璁剧疆SUCCESS/FAIL
	* @param string $value 
	**/
	public function SetResult_code($value)
	{
		$this->values["result_code"] = $value;
	}

	/**
	* 銮峰彇SUCCESS/FAIL镄勫EUR?
	* @return 链?
	**/
	public function GetResult_code()
	{
		return $this->values["result_code"];
	}

	/**
	* 鍒ゆ柇SUCCESS/FAIL鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsResult_codeSet()
	{
		return array_key_exists("result_code", $this->values);
	}

	/**
	* 璁剧疆ORDERNOTEXIST钬旇鍗曚笉瀛桦湪SYSTEMERROR钬旗郴缁熼敊璇?
	* @param string $value 
	**/
	public function SetErr_code($value)
	{
		$this->values["err_code"] = $value;
	}

	/**
	* 銮峰彇ORDERNOTEXIST钬旇鍗曚笉瀛桦湪SYSTEMERROR钬旗郴缁熼敊璇殑链?
	* @return 链?
	**/
	public function GetErr_code()
	{
		return $this->values["err_code"];
	}

	/**
	* 鍒ゆ柇ORDERNOTEXIST钬旇鍗曚笉瀛桦湪SYSTEMERROR钬旗郴缁熼敊璇槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsErr_codeSet()
	{
		return array_key_exists("err_code", $this->values);
	}

	/**
	* 璁剧疆缁撴灉淇℃伅鎻忚堪
	* @param string $value 
	**/
	public function SetErr_code_des($value)
	{
		$this->values["err_code_des"] = $value;
	}

	/**
	* 銮峰彇缁撴灉淇℃伅鎻忚堪镄勫EUR?
	* @return 链?
	**/
	public function GetErr_code_des()
	{
		return $this->values["err_code_des"];
	}

	/**
	* 鍒ゆ柇缁撴灉淇℃伅鎻忚堪鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsErr_code_desSet()
	{
		return array_key_exists("err_code_des", $this->values);
	}

	/**
	* 璁剧疆鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛,鍟嗘埛鍙互鍦ㄤ笂鎶ユ椂鎻愪緵鐩稿叧鍟嗘埛璁㈠崟鍙锋柟渚垮井淇℃敮浠樻洿濂界殑鎻愰佩链嶅姟璐ㄩ噺銆?
	* @param string $value 
	**/
	public function SetOut_trade_no($value)
	{
		$this->values["out_trade_no"] = $value;
	}

	/**
	* 銮峰彇鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛,鍟嗘埛鍙互鍦ㄤ笂鎶ユ椂鎻愪緵鐩稿叧鍟嗘埛璁㈠崟鍙锋柟渚垮井淇℃敮浠樻洿濂界殑鎻愰佩链嶅姟璐ㄩ噺銆?镄勫EUR?
	* @return 链?
	**/
	public function GetOut_trade_no()
	{
		return $this->values["out_trade_no"];
	}

	/**
	* 鍒ゆ柇鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛,鍟嗘埛鍙互鍦ㄤ笂鎶ユ椂鎻愪緵鐩稿叧鍟嗘埛璁㈠崟鍙锋柟渚垮井淇℃敮浠樻洿濂界殑鎻愰佩链嶅姟璐ㄩ噺銆?鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsOut_trade_noSet()
	{
		return array_key_exists("out_trade_no", $this->values);
	}

	/**
	* 璁剧疆鍙戣捣鎺ュ彛璋幂敤镞剁殑链哄櫒IP 
	* @param string $value 
	**/
	public function SetUser_ip($value)
	{
		$this->values["user_ip"] = $value;
	}

	/**
	* 銮峰彇鍙戣捣鎺ュ彛璋幂敤镞剁殑链哄櫒IP 镄勫EUR?
	* @return 链?
	**/
	public function GetUser_ip()
	{
		return $this->values["user_ip"];
	}

	/**
	* 鍒ゆ柇鍙戣捣鎺ュ彛璋幂敤镞剁殑链哄櫒IP 鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsUser_ipSet()
	{
		return array_key_exists("user_ip", $this->values);
	}

	/**
	* 璁剧疆绯荤粺镞堕棿锛屾牸寮忎负yyyyMMddHHmmss锛屽2009骞?2链?7镞?镣?0鍒?0绉掕〃绀轰负20091227091010銆傚叾浠栬瑙佹椂闂磋鍒?
	* @param string $value 
	**/
	public function SetTime($value)
	{
		$this->values["time"] = $value;
	}

	/**
	* 銮峰彇绯荤粺镞堕棿锛屾牸寮忎负yyyyMMddHHmmss锛屽2009骞?2链?7镞?镣?0鍒?0绉掕〃绀轰负20091227091010銆傚叾浠栬瑙佹椂闂磋鍒欑殑链?
	* @return 链?
	**/
	public function GetTime()
	{
		return $this->values["time"];
	}

	/**
	* 鍒ゆ柇绯荤粺镞堕棿锛屾牸寮忎负yyyyMMddHHmmss锛屽2009骞?2链?7镞?镣?0鍒?0绉掕〃绀轰负20091227091010銆傚叾浠栬瑙佹椂闂磋鍒欐槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsTimeSet()
	{
		return array_key_exists("time", $this->values);
	}
}

/**
 * 
 * 鐭摼杞崲杈揿叆瀵硅薄
 * @author widyhu
 *
 */
class WxPayShortUrl extends WxPayDataBase
{

	/**
	* 璁剧疆寰俊鍒嗛厤镄勫叕浼楄处鍙稩D
	* @param string $value 
	**/
	public function SetAppid($value)
	{
		$this->values["appid"] = $value;
	}

	/**
	* 銮峰彇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D镄勫EUR?
	* @return 链?
	**/
	public function GetAppid()
	{
		return $this->values["appid"];
	}

	/**
	* 鍒ゆ柇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsAppidSet()
	{
		return array_key_exists("appid", $this->values);
	}

	/**
	* 璁剧疆寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛
	* @param string $value 
	**/
	public function SetMch_id($value)
	{
		$this->values["mch_id"] = $value;
	}

	/**
	* 銮峰彇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛镄勫EUR?
	* @return 链?
	**/
	public function GetMch_id()
	{
		return $this->values["mch_id"];
	}

	/**
	* 鍒ゆ柇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsMch_idSet()
	{
		return array_key_exists("mch_id", $this->values);
	}

	/**
	* 璁剧疆闇EUR瑕佽浆鎹㈢殑URL锛岀鍚岖敤铡熶覆锛屼紶杈挞渶URL encode
	* @param string $value 
	**/
	public function SetLong_url($value)
	{
		$this->values["long_url"] = $value;
	}

	/**
	* 銮峰彇闇EUR瑕佽浆鎹㈢殑URL锛岀鍚岖敤铡熶覆锛屼紶杈挞渶URL encode镄勫EUR?
	* @return 链?
	**/
	public function GetLong_url()
	{
		return $this->values["long_url"];
	}

	/**
	* 鍒ゆ柇闇EUR瑕佽浆鎹㈢殑URL锛岀鍚岖敤铡熶覆锛屼紶杈挞渶URL encode鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsLong_urlSet()
	{
		return array_key_exists("long_url", $this->values);
	}

	/**
	* 璁剧疆闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶
	* @param string $value 
	**/
	public function SetNonce_str($value)
	{
		$this->values["nonce_str"] = $value;
	}

	/**
	* 銮峰彇闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶镄勫EUR?
	* @return 链?
	**/
	public function GetNonce_str()
	{
		return $this->values["nonce_str"];
	}

	/**
	* 鍒ゆ柇闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsNonce_strSet()
	{
		return array_key_exists("nonce_str", $this->values);
	}
}

/**
 * 
 * 鎻愪氦琚壂杈揿叆瀵硅薄
 * @author widyhu
 *
 */
class WxPayMicroPay extends WxPayDataBase
{

	/**
	* 璁剧疆寰俊鍒嗛厤镄勫叕浼楄处鍙稩D
	* @param string $value 
	**/
	public function SetAppid($value)
	{
		$this->values["appid"] = $value;
	}

	/**
	* 銮峰彇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D镄勫EUR?
	* @return 链?
	**/
	public function GetAppid()
	{
		return $this->values["appid"];
	}

	/**
	* 鍒ゆ柇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsAppidSet()
	{
		return array_key_exists("appid", $this->values);
	}

	/**
	* 璁剧疆寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛
	* @param string $value 
	**/
	public function SetMch_id($value)
	{
		$this->values["mch_id"] = $value;
	}

	/**
	* 銮峰彇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛镄勫EUR?
	* @return 链?
	**/
	public function GetMch_id()
	{
		return $this->values["mch_id"];
	}

	/**
	* 鍒ゆ柇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsMch_idSet()
	{
		return array_key_exists("mch_id", $this->values);
	}

	/**
	* 璁剧疆缁堢璁惧鍙?鍟嗘埛镊畾涔夛紝濡傞棬搴楃紪鍙?
	* @param string $value 
	**/
	public function SetDevice_info($value)
	{
		$this->values["device_info"] = $value;
	}

	/**
	* 銮峰彇缁堢璁惧鍙?鍟嗘埛镊畾涔夛紝濡傞棬搴楃紪鍙?镄勫EUR?
	* @return 链?
	**/
	public function GetDevice_info()
	{
		return $this->values["device_info"];
	}

	/**
	* 鍒ゆ柇缁堢璁惧鍙?鍟嗘埛镊畾涔夛紝濡傞棬搴楃紪鍙?鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsDevice_infoSet()
	{
		return array_key_exists("device_info", $this->values);
	}

	/**
	* 璁剧疆闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶
	* @param string $value 
	**/
	public function SetNonce_str($value)
	{
		$this->values["nonce_str"] = $value;
	}

	/**
	* 銮峰彇闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶镄勫EUR?
	* @return 链?
	**/
	public function GetNonce_str()
	{
		return $this->values["nonce_str"];
	}

	/**
	* 鍒ゆ柇闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsNonce_strSet()
	{
		return array_key_exists("nonce_str", $this->values);
	}

	/**
	* 璁剧疆鍟嗗搧鎴栨敮浠桦崟绠EUR瑕佹弿杩?
	* @param string $value 
	**/
	public function SetBody($value)
	{
		$this->values["body"] = $value;
	}

	/**
	* 銮峰彇鍟嗗搧鎴栨敮浠桦崟绠EUR瑕佹弿杩扮殑链?
	* @return 链?
	**/
	public function GetBody()
	{
		return $this->values["body"];
	}

	/**
	* 鍒ゆ柇鍟嗗搧鎴栨敮浠桦崟绠EUR瑕佹弿杩版槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsBodySet()
	{
		return array_key_exists("body", $this->values);
	}

	/**
	* 璁剧疆鍟嗗搧鍚岖О鏄庣粏鍒楄〃
	* @param string $value 
	**/
	public function SetDetail($value)
	{
		$this->values["detail"] = $value;
	}

	/**
	* 銮峰彇鍟嗗搧鍚岖О鏄庣粏鍒楄〃镄勫EUR?
	* @return 链?
	**/
	public function GetDetail()
	{
		return $this->values["detail"];
	}

	/**
	* 鍒ゆ柇鍟嗗搧鍚岖О鏄庣粏鍒楄〃鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsDetailSet()
	{
		return array_key_exists("detail", $this->values);
	}

	/**
	* 璁剧疆闄勫姞鏁版嵁锛屽湪镆ヨAPI鍜屾敮浠橀EUR氱煡涓师镙疯繑锲烇紝璇ュ瓧娈典富瑕佺敤浜庡晢鎴锋恶甯﹁鍗旷殑镊畾涔夋暟鎹?
	* @param string $value 
	**/
	public function SetAttach($value)
	{
		$this->values["attach"] = $value;
	}

	/**
	* 銮峰彇闄勫姞鏁版嵁锛屽湪镆ヨAPI鍜屾敮浠橀EUR氱煡涓师镙疯繑锲烇紝璇ュ瓧娈典富瑕佺敤浜庡晢鎴锋恶甯﹁鍗旷殑镊畾涔夋暟鎹殑链?
	* @return 链?
	**/
	public function GetAttach()
	{
		return $this->values["attach"];
	}

	/**
	* 鍒ゆ柇闄勫姞鏁版嵁锛屽湪镆ヨAPI鍜屾敮浠橀EUR氱煡涓师镙疯繑锲烇紝璇ュ瓧娈典富瑕佺敤浜庡晢鎴锋恶甯﹁鍗旷殑镊畾涔夋暟鎹槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsAttachSet()
	{
		return array_key_exists("attach", $this->values);
	}

	/**
	* 璁剧疆鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛,32涓瓧绗﹀唴銆佸彲鍖呭惈瀛楁瘝, 鍏朵粬璇存槑瑙佸晢鎴疯鍗曞佛
	* @param string $value 
	**/
	public function SetOut_trade_no($value)
	{
		$this->values["out_trade_no"] = $value;
	}

	/**
	* 銮峰彇鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛,32涓瓧绗﹀唴銆佸彲鍖呭惈瀛楁瘝, 鍏朵粬璇存槑瑙佸晢鎴疯鍗曞佛镄勫EUR?
	* @return 链?
	**/
	public function GetOut_trade_no()
	{
		return $this->values["out_trade_no"];
	}

	/**
	* 鍒ゆ柇鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛,32涓瓧绗﹀唴銆佸彲鍖呭惈瀛楁瘝, 鍏朵粬璇存槑瑙佸晢鎴疯鍗曞佛鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsOut_trade_noSet()
	{
		return array_key_exists("out_trade_no", $this->values);
	}

	/**
	* 璁剧疆璁㈠崟镐婚噾棰濓紝鍗曚綅涓哄垎锛屽彧鑳戒负鏁存暟锛岃瑙佹敮浠橀噾棰?
	* @param string $value 
	**/
	public function SetTotal_fee($value)
	{
		$this->values["total_fee"] = $value;
	}

	/**
	* 銮峰彇璁㈠崟镐婚噾棰濓紝鍗曚綅涓哄垎锛屽彧鑳戒负鏁存暟锛岃瑙佹敮浠橀噾棰濈殑链?
	* @return 链?
	**/
	public function GetTotal_fee()
	{
		return $this->values["total_fee"];
	}

	/**
	* 鍒ゆ柇璁㈠崟镐婚噾棰濓紝鍗曚綅涓哄垎锛屽彧鑳戒负鏁存暟锛岃瑙佹敮浠橀噾棰濇槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsTotal_feeSet()
	{
		return array_key_exists("total_fee", $this->values);
	}

	/**
	* 璁剧疆绗﹀悎ISO 4217镙囧嗳镄勪笁浣嶅瓧姣崭唬镰侊紝榛樿浜烘皯甯侊细CNY锛屽叾浠栧EUR煎垪琛ㄨ瑙佽揣甯佺被鍨?
	* @param string $value 
	**/
	public function SetFee_type($value)
	{
		$this->values["fee_type"] = $value;
	}

	/**
	* 銮峰彇绗﹀悎ISO 4217镙囧嗳镄勪笁浣嶅瓧姣崭唬镰侊紝榛樿浜烘皯甯侊细CNY锛屽叾浠栧EUR煎垪琛ㄨ瑙佽揣甯佺被鍨嬬殑链?
	* @return 链?
	**/
	public function GetFee_type()
	{
		return $this->values["fee_type"];
	}

	/**
	* 鍒ゆ柇绗﹀悎ISO 4217镙囧嗳镄勪笁浣嶅瓧姣崭唬镰侊紝榛樿浜烘皯甯侊细CNY锛屽叾浠栧EUR煎垪琛ㄨ瑙佽揣甯佺被鍨嬫槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsFee_typeSet()
	{
		return array_key_exists("fee_type", $this->values);
	}

	/**
	* 璁剧疆璋幂敤寰俊鏀粯API镄勬満鍣↖P 
	* @param string $value 
	**/
	public function SetSpbill_create_ip($value)
	{
		$this->values["spbill_create_ip"] = $value;
	}

	/**
	* 銮峰彇璋幂敤寰俊鏀粯API镄勬満鍣↖P 镄勫EUR?
	* @return 链?
	**/
	public function GetSpbill_create_ip()
	{
		return $this->values["spbill_create_ip"];
	}

	/**
	* 鍒ゆ柇璋幂敤寰俊鏀粯API镄勬満鍣↖P 鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsSpbill_create_ipSet()
	{
		return array_key_exists("spbill_create_ip", $this->values);
	}

	/**
	* 璁剧疆璁㈠崟鐢熸垚镞堕棿锛屾牸寮忎负yyyyMMddHHmmss锛屽2009骞?2链?5镞?镣?0鍒?0绉掕〃绀轰负20091225091010銆傝瑙佹椂闂磋鍒?
	* @param string $value 
	**/
	public function SetTime_start($value)
	{
		$this->values["time_start"] = $value;
	}

	/**
	* 銮峰彇璁㈠崟鐢熸垚镞堕棿锛屾牸寮忎负yyyyMMddHHmmss锛屽2009骞?2链?5镞?镣?0鍒?0绉掕〃绀轰负20091225091010銆傝瑙佹椂闂磋鍒欑殑链?
	* @return 链?
	**/
	public function GetTime_start()
	{
		return $this->values["time_start"];
	}

	/**
	* 鍒ゆ柇璁㈠崟鐢熸垚镞堕棿锛屾牸寮忎负yyyyMMddHHmmss锛屽2009骞?2链?5镞?镣?0鍒?0绉掕〃绀轰负20091225091010銆傝瑙佹椂闂磋鍒欐槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsTime_startSet()
	{
		return array_key_exists("time_start", $this->values);
	}

	/**
	* 璁剧疆璁㈠崟澶辨晥镞堕棿锛屾牸寮忎负yyyyMMddHHmmss锛屽2009骞?2链?7镞?镣?0鍒?0绉掕〃绀轰负20091227091010銆傝瑙佹椂闂磋鍒?
	* @param string $value 
	**/
	public function SetTime_expire($value)
	{
		$this->values["time_expire"] = $value;
	}

	/**
	* 銮峰彇璁㈠崟澶辨晥镞堕棿锛屾牸寮忎负yyyyMMddHHmmss锛屽2009骞?2链?7镞?镣?0鍒?0绉掕〃绀轰负20091227091010銆傝瑙佹椂闂磋鍒欑殑链?
	* @return 链?
	**/
	public function GetTime_expire()
	{
		return $this->values["time_expire"];
	}

	/**
	* 鍒ゆ柇璁㈠崟澶辨晥镞堕棿锛屾牸寮忎负yyyyMMddHHmmss锛屽2009骞?2链?7镞?镣?0鍒?0绉掕〃绀轰负20091227091010銆傝瑙佹椂闂磋鍒欐槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsTime_expireSet()
	{
		return array_key_exists("time_expire", $this->values);
	}

	/**
	* 璁剧疆鍟嗗搧镙囱锛屼唬閲戝埜鎴栫珛鍑忎紭鎯犲姛鑳界殑鍙傛暟锛岃鏄庤瑙佷唬閲戝埜鎴栫珛鍑忎紭鎯?
	* @param string $value 
	**/
	public function SetGoods_tag($value)
	{
		$this->values["goods_tag"] = $value;
	}

	/**
	* 銮峰彇鍟嗗搧镙囱锛屼唬閲戝埜鎴栫珛鍑忎紭鎯犲姛鑳界殑鍙傛暟锛岃鏄庤瑙佷唬閲戝埜鎴栫珛鍑忎紭鎯犵殑链?
	* @return 链?
	**/
	public function GetGoods_tag()
	{
		return $this->values["goods_tag"];
	}

	/**
	* 鍒ゆ柇鍟嗗搧镙囱锛屼唬閲戝埜鎴栫珛鍑忎紭鎯犲姛鑳界殑鍙傛暟锛岃鏄庤瑙佷唬閲戝埜鎴栫珛鍑忎紭鎯犳槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsGoods_tagSet()
	{
		return array_key_exists("goods_tag", $this->values);
	}

	/**
	* 璁剧疆镓爜鏀粯鎺堟潈镰侊紝璁惧璇诲彇鐢ㄦ埛寰俊涓殑鏉＄爜鎴栬EUR呬簩缁寸爜淇℃伅
	* @param string $value 
	**/
	public function SetAuth_code($value)
	{
		$this->values["auth_code"] = $value;
	}

	/**
	* 銮峰彇镓爜鏀粯鎺堟潈镰侊紝璁惧璇诲彇鐢ㄦ埛寰俊涓殑鏉＄爜鎴栬EUR呬簩缁寸爜淇℃伅镄勫EUR?
	* @return 链?
	**/
	public function GetAuth_code()
	{
		return $this->values["auth_code"];
	}

	/**
	* 鍒ゆ柇镓爜鏀粯鎺堟潈镰侊紝璁惧璇诲彇鐢ㄦ埛寰俊涓殑鏉＄爜鎴栬EUR呬簩缁寸爜淇℃伅鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsAuth_codeSet()
	{
		return array_key_exists("auth_code", $this->values);
	}
}

/**
 * 
 * 鎾ら攒杈揿叆瀵硅薄
 * @author widyhu
 *
 */
class WxPayReverse extends WxPayDataBase
{

	/**
	* 璁剧疆寰俊鍒嗛厤镄勫叕浼楄处鍙稩D
	* @param string $value 
	**/
	public function SetAppid($value)
	{
		$this->values["appid"] = $value;
	}

	/**
	* 銮峰彇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D镄勫EUR?
	* @return 链?
	**/
	public function GetAppid()
	{
		return $this->values["appid"];
	}

	/**
	* 鍒ゆ柇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsAppidSet()
	{
		return array_key_exists("appid", $this->values);
	}

	/**
	* 璁剧疆寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛
	* @param string $value 
	**/
	public function SetMch_id($value)
	{
		$this->values["mch_id"] = $value;
	}

	/**
	* 銮峰彇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛镄勫EUR?
	* @return 链?
	**/
	public function GetMch_id()
	{
		return $this->values["mch_id"];
	}

	/**
	* 鍒ゆ柇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsMch_idSet()
	{
		return array_key_exists("mch_id", $this->values);
	}

	/**
	* 璁剧疆寰俊镄勮鍗曞佛锛屼紭鍏堜娇鐢?
	* @param string $value 
	**/
	public function SetTransaction_id($value)
	{
		$this->values["transaction_id"] = $value;
	}

	/**
	* 銮峰彇寰俊镄勮鍗曞佛锛屼紭鍏堜娇鐢ㄧ殑链?
	* @return 链?
	**/
	public function GetTransaction_id()
	{
		return $this->values["transaction_id"];
	}

	/**
	* 鍒ゆ柇寰俊镄勮鍗曞佛锛屼紭鍏堜娇鐢ㄦ槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsTransaction_idSet()
	{
		return array_key_exists("transaction_id", $this->values);
	}

	/**
	* 璁剧疆鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛,transaction_id銆乷ut_trade_no浜岄EUR変竴锛屽鏋滃悓镞跺瓨鍦ㄤ紭鍏堢骇锛歵ransaction_id> out_trade_no
	* @param string $value 
	**/
	public function SetOut_trade_no($value)
	{
		$this->values["out_trade_no"] = $value;
	}

	/**
	* 銮峰彇鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛,transaction_id銆乷ut_trade_no浜岄EUR変竴锛屽鏋滃悓镞跺瓨鍦ㄤ紭鍏堢骇锛歵ransaction_id> out_trade_no镄勫EUR?
	* @return 链?
	**/
	public function GetOut_trade_no()
	{
		return $this->values["out_trade_no"];
	}

	/**
	* 鍒ゆ柇鍟嗘埛绯荤粺鍐呴儴镄勮鍗曞佛,transaction_id銆乷ut_trade_no浜岄EUR変竴锛屽鏋滃悓镞跺瓨鍦ㄤ紭鍏堢骇锛歵ransaction_id> out_trade_no鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsOut_trade_noSet()
	{
		return array_key_exists("out_trade_no", $this->values);
	}

	/**
	* 璁剧疆闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶
	* @param string $value 
	**/
	public function SetNonce_str($value)
	{
		$this->values["nonce_str"] = $value;
	}

	/**
	* 銮峰彇闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶镄勫EUR?
	* @return 链?
	**/
	public function GetNonce_str()
	{
		return $this->values["nonce_str"];
	}

	/**
	* 鍒ゆ柇闅忔満瀛楃涓诧紝涓嶉昵浜?2浣嶃EUR傛帹钻愰殢链烘暟鐢熸垚绠楁硶鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsNonce_strSet()
	{
		return array_key_exists("nonce_str", $this->values);
	}
}

/**
 * 
 * 鎻愪氦JSAPI杈揿叆瀵硅薄
 * @author widyhu
 *
 */
class WxPayJsApiPay extends WxPayDataBase
{

	/**
	* 璁剧疆寰俊鍒嗛厤镄勫叕浼楄处鍙稩D
	* @param string $value 
	**/
	public function SetAppid($value)
	{
		$this->values["appId"] = $value;
	}

	/**
	* 銮峰彇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D镄勫EUR?
	* @return 链?
	**/
	public function GetAppid()
	{
		return $this->values["appId"];
	}

	/**
	* 鍒ゆ柇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsAppidSet()
	{
		return array_key_exists("appId", $this->values);
	}

	/**
	* 璁剧疆鏀粯镞堕棿鎴?
	* @param string $value 
	**/
	public function SetTimeStamp($value)
	{
		$this->values["timeStamp"] = $value;
	}

	/**
	* 銮峰彇鏀粯镞堕棿鎴崇殑链?
	* @return 链?
	**/
	public function GetTimeStamp()
	{
		return $this->values["timeStamp"];
	}

	/**
	* 鍒ゆ柇鏀粯镞堕棿鎴虫槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsTimeStampSet()
	{
		return array_key_exists("timeStamp", $this->values);
	}

	/**
	* 闅忔満瀛楃涓?
	* @param string $value 
	**/
	public function SetNonceStr($value)
	{
		$this->values["nonceStr"] = $value;
	}

	/**
	* 銮峰彇notify闅忔満瀛楃涓插EUR?
	* @return 链?
	**/
	public function GetReturn_code()
	{
		return $this->values["nonceStr"];
	}

	/**
	* 鍒ゆ柇闅忔満瀛楃涓叉槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsReturn_codeSet()
	{
		return array_key_exists("nonceStr", $this->values);
	}

	/**
	* 璁剧疆璁㈠崟璇︽儏镓╁睍瀛楃涓?
	* @param string $value 
	**/
	public function SetPackage($value)
	{
		$this->values["package"] = $value;
	}

	/**
	* 銮峰彇璁㈠崟璇︽儏镓╁睍瀛楃涓茬殑链?
	* @return 链?
	**/
	public function GetPackage()
	{
		return $this->values["package"];
	}

	/**
	* 鍒ゆ柇璁㈠崟璇︽儏镓╁睍瀛楃涓叉槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsPackageSet()
	{
		return array_key_exists("package", $this->values);
	}

	/**
	* 璁剧疆绛惧悕鏂瑰纺
	* @param string $value 
	**/
	public function SetSignType($value)
	{
		$this->values["signType"] = $value;
	}

	/**
	* 銮峰彇绛惧悕鏂瑰纺
	* @return 链?
	**/
	public function GetSignType()
	{
		return $this->values["signType"];
	}

	/**
	* 鍒ゆ柇绛惧悕鏂瑰纺鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsSignTypeSet()
	{
		return array_key_exists("signType", $this->values);
	}

	/**
	* 璁剧疆绛惧悕鏂瑰纺
	* @param string $value 
	**/
	public function SetPaySign($value)
	{
		$this->values["paySign"] = $value;
	}

	/**
	* 銮峰彇绛惧悕鏂瑰纺
	* @return 链?
	**/
	public function GetPaySign()
	{
		return $this->values["paySign"];
	}

	/**
	* 鍒ゆ柇绛惧悕鏂瑰纺鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsPaySignSet()
	{
		return array_key_exists("paySign", $this->values);
	}
}

/**
 * 
 * 镓爜鏀粯妯″纺涓EUR鐢熸垚浜岀淮镰佸弬鏁?
 * @author widyhu
 *
 */
class WxPayBizPayUrl extends WxPayDataBase
{

	/**
	* 璁剧疆寰俊鍒嗛厤镄勫叕浼楄处鍙稩D
	* @param string $value 
	**/
	public function SetAppid($value)
	{
		$this->values["appid"] = $value;
	}

	/**
	* 銮峰彇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D镄勫EUR?
	* @return 链?
	**/
	public function GetAppid()
	{
		return $this->values["appid"];
	}

	/**
	* 鍒ゆ柇寰俊鍒嗛厤镄勫叕浼楄处鍙稩D鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsAppidSet()
	{
		return array_key_exists("appid", $this->values);
	}

	/**
	* 璁剧疆寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛
	* @param string $value 
	**/
	public function SetMch_id($value)
	{
		$this->values["mch_id"] = $value;
	}

	/**
	* 銮峰彇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛镄勫EUR?
	* @return 链?
	**/
	public function GetMch_id()
	{
		return $this->values["mch_id"];
	}

	/**
	* 鍒ゆ柇寰俊鏀粯鍒嗛厤镄勫晢鎴峰佛鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsMch_idSet()
	{
		return array_key_exists("mch_id", $this->values);
	}

	/**
	* 璁剧疆鏀粯镞堕棿鎴?
	* @param string $value 
	**/
	public function SetTime_stamp($value)
	{
		$this->values["time_stamp"] = $value;
	}

	/**
	* 銮峰彇鏀粯镞堕棿鎴崇殑链?
	* @return 链?
	**/
	public function GetTime_stamp()
	{
		return $this->values["time_stamp"];
	}

	/**
	* 鍒ゆ柇鏀粯镞堕棿鎴虫槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsTime_stampSet()
	{
		return array_key_exists("time_stamp", $this->values);
	}

	/**
	* 璁剧疆闅忔満瀛楃涓?
	* @param string $value 
	**/
	public function SetNonce_str($value)
	{
		$this->values["nonce_str"] = $value;
	}

	/**
	* 銮峰彇闅忔満瀛楃涓茬殑链?
	* @return 链?
	**/
	public function GetNonce_str()
	{
		return $this->values["nonce_str"];
	}

	/**
	* 鍒ゆ柇闅忔満瀛楃涓叉槸鍚﹀瓨鍦?
	* @return true 鎴?false
	**/
	public function IsNonce_strSet()
	{
		return array_key_exists("nonce_str", $this->values);
	}

	/**
	* 璁剧疆鍟嗗搧ID
	* @param string $value 
	**/
	public function SetProduct_id($value)
	{
		$this->values["product_id"] = $value;
	}

	/**
	* 銮峰彇鍟嗗搧ID镄勫EUR?
	* @return 链?
	**/
	public function GetProduct_id()
	{
		return $this->values["product_id"];
	}

	/**
	* 鍒ゆ柇鍟嗗搧ID鏄惁瀛桦湪
	* @return true 鎴?false
	**/
	public function IsProduct_idSet()
	{
		return array_key_exists("product_id", $this->values);
	}
}

require_once (dirname(dirname(dirname(dirname(__FILE__)))) . "/configs/pay/weixinpay.php");
require_once ("WxPay.Exception.php");

?>
