<?php

define("JIEQI_MODULE_NAME", "pay");
define("JIEQI_PAY_TYPE", "yeepay");
require_once ("../../global.php");
require_once ("yeepaycommon.php");
jieqi_loadlang("pay", JIEQI_MODULE_NAME);
jieqi_getconfigs(JIEQI_MODULE_NAME, JIEQI_PAY_TYPE, "jieqiPayset");
$logflag = (defined("JIEQI_DEBUG_MODE") && (0 < JIEQI_DEBUG_MODE) ? 1 : 0);

if ($logflag) {
	$logfile = JIEQI_ROOT_PATH . "/files/pay/log/" . JIEQI_PAY_TYPE . "_return.txt";
	jieqi_checkdir(dirname($logfile), true);
	$log = print_r($_REQUEST, true);
	jieqi_writefile($logfile, $log, "ab");
}

$merchantId = $jieqiPayset[JIEQI_PAY_TYPE]["payid"];
$keyValue = $jieqiPayset[JIEQI_PAY_TYPE]["paykey"];
$paytype = JIEQI_PAY_TYPE;

if (isset($_REQUEST["rb_BankId"])) {
	$_REQUEST["rb_BankId"] = trim($_REQUEST["rb_BankId"]);
}

if (!empty($_REQUEST["rb_BankId"]) && isset($jieqiPayset[JIEQI_PAY_TYPE]["paytype"][$_REQUEST["rb_BankId"]])) {
	$paytype = $jieqiPayset[JIEQI_PAY_TYPE]["paytype"][$_REQUEST["rb_BankId"]];
}

$return = getcallbackvalue($sCmd, $sErrorCode, $sTrxId, $amount, $cur, $productId, $orderId, $userId, $MP, $bType, $svrHmac);
$bRet = checkhmac($sCmd, $sErrorCode, $sTrxId, $orderId, $amount, $cur, $productId, $userId, $MP, $bType, $svrHmac);

if ($bRet) {
	if ($sErrorCode == "1") {
		include_once ($jieqiModules["pay"]["path"] . "/class/paylog.php");
		$paylog_handler = JieqiPaylogHandler::getInstance("JieqiPaylogHandler");
		$orderid = intval($orderId);
		$paylog = $paylog_handler->get($orderid);

		if (is_object($paylog)) {
			$buyname = $paylog->getVar("buyname");
			$buyid = $paylog->getVar("buyid");
			$payflag = $paylog->getVar("payflag");
			$egold = $paylog->getVar("egold");
			$money = $paylog->getVar("money");

			if ($payflag == 0) {
				include_once (JIEQI_ROOT_PATH . "/class/users.php");
				$users_handler = &JieqiUsersHandler::getInstance("JieqiUsersHandler");
				$paysilver = (empty($jieqiPayset[JIEQI_PAY_TYPE]["paysilver"]) ? 0 : intval($jieqiPayset[JIEQI_PAY_TYPE]["paysilver"]));
				$payscore = (empty($jieqiPayset[JIEQI_PAY_TYPE]["payrate"]) ? 0 : floor(($money * $jieqiPayset[JIEQI_PAY_TYPE]["payrate"]) / 100));
				$ret = $users_handler->income($buyid, $egold, $paysilver, $payscore);

				if ($ret) {
					$note = sprintf($jieqiLang["pay"]["add_egold_success"], $buyname, JIEQI_EGOLD_NAME, $egold);
				}
				else {
					$note = sprintf($jieqiLang["pay"]["add_egold_failure"], $buyid, $buyname, JIEQI_EGOLD_NAME, $egold);
				}

				$paylog->setVar("rettime", JIEQI_NOW_TIME);
				$paylog->setVar("retserialno", $sTrxId);
				$paylog->setVar("retaccount", $userId);
				$paylog->setVar("retinfo", "");
				$paylog->setVar("money", intval($amount * 100));
				$paylog->setVar("paytype", $paytype);
				$paylog->setVar("note", $note);
				$paylog->setVar("payflag", 1);

				if (!$paylog_handler->insert($paylog)) {
					jieqi_printfail($jieqiLang["pay"]["save_paylog_failure"]);
				}
			}

			if ($bType == "2") {
				echo "success";
			}

			jieqi_msgwin(LANG_DO_SUCCESS, sprintf($jieqiLang["pay"]["buy_egold_success"], $buyname, JIEQI_EGOLD_NAME, $egold));
		}
		else {
			jieqi_printfail($jieqiLang["pay"]["no_buy_record"]);
		}
	}
	else {
		jieqi_printfail($jieqiLang["pay"]["pay_return_error"]);
	}
}
else {
	jieqi_printfail($jieqiLang["pay"]["return_checkcode_error"]);
}

?>
